VehicleInspector.global = {	
	isOn = true;
	foundMoh = false;	
	iconDisplay = {isOn=true,fillIcon=true,vehicleIcon=1,attachedIcon=0,fillLevelBar=false,
		comparseOrder = "setSpeed,setField,setVehicle,setJobType,setFillLevelInformation,setAttached,setLeasing,setParking,setGps,setControlledName,setRemainingString,";
		setOrder={"setSpeed","setField","setVehicle","setJobType","setFillLevelInformation","setAttached","setLeasing","setParking","setGps","setControlledName","setRemainingString"},
		comparseOrderVehicle = "setVehicleIcon,setVehicleName,";
		setOrderVehicle={"setVehicleIcon","setVehicleName"},
		comparseOrderFillLevelInformation = "setFillTypeIcon,setFillLevel,setFillProzent,setFillTypeName,";
		setOrderFillLevelInformation={"setFillTypeIcon","setFillLevel","setFillProzent","setFillTypeName"},
	};
	previewVehicleData = {isOn=true,canLoadedFillTypes=true};
	settingLineState = 1; --0 off, 1 helpOn, 2 helpOff, 3 on
	settingLineBounds = {0, 0, 0, 0};
	sortBy = 0;
	
	forceView = 0; --0 off, 1 all seeTxt, 2 all seeTxt+vehicle
	
	isHidden = false;
	hlGui = {isLoad=false,page={},side={}};	
	onlyMoh = false;
	mohSlot = {isGenerate=false, viewViCategory={}};
	testNumber = {};
	testString = {};
		
	fixPosY = {onF1=0.009, offF1=0, onSchema=-0.002};
	fixPosX = {onF1=0, offF1=0, onSchema=0};
	posX = {default=0.005, otherMod=0, [1]=0, [2]=0};
	posY = {default=0.99, otherMod=0, [1]=0, [2]=0};
	width = {last=0, [1]=0, [2]=0};
	height = {last=0, [1]=0, [2]=0};
	toLarge = false;
	viewModus = 1;
	
	maxTxtSize = 0.017000;
	minTxtSize = 0.008000;
	defaultTxtSize = 0.010000;
	txtSize = 0.010000;
	txtSizeLV = 0.000250;
	
	minTxtWidthDistance = 0.0005000;
	maxTxtWidthDistance = 0.006000;
	defaultTxtWidthDistance = 0.001000;
	txtWidthDistance = 0.001000;
	txtWidthDistanceLV = 0.000500;
	
	minTxtLineDistance = 0.001000;
	maxTxtLineDistance = 0.008000;
	defaultTxtLineDistance = 0.005000;
	txtLineDistance = 0.005000;
	txtLineDistanceLV = 0.001000;
	
	--minTxtWidthFix = -3;
	--maxTxtWidthFix = 3;
	--defaultTxtWidthFix = 0;
	--txtWidthFix = 0;	
	--txtWidthFixLV = 1;
	
	minVehicleNameLength = 3;
	maxVehicleNameLength = 20; 
	defaultVehicleNameLength = 10;
	vehicleNameLength = 10;
	vehicleNameLengthLV = 1;
	
	minFillNameLength = 3;	
	maxFillNameLength = 20;
	defaultFillNameLength = 10;
	fillNameLength = 10;
	fillNameLengthLV = 1;

	minPlayerNameLength = 4;	
	maxPlayerNameLength = 25;
	defaultPlayerNameLength = 15;
	playerNameLength = 15;
	playerNameLengthLV = 1;
	
	minAttachedLimit = 2;
	maxAttachedLimit = 6;
	defaultAttachedLimit = 4;
	attachedLimit = 4;
	attachedLimitLV = 1;
	
	seeBackground = true; 	
	backgroundT = 0.80;
	seePlayerOnTop = true;
	seeHelperOnTop = true;
	seeFieldNumberMP = false;
	autoMouseOffJoinVehicle = false;
	joinVehicles = 1;
	viewWorkingWidth = {isOn=true, state=1, cSize=0};
	viewUnloadSide = {isOn=true, state=1, pos=1, cSize=0, size=0.013};
	viewAttachedDamage = {isOn=true, state=1, cSize=0};
	
	searchInvert = {"sowing", "sowingmachine", "sprayer", "seeders", "fertilizer", "manure", "potatoharvesting", "selfpropelledsprayer", "spreader", "fertilizerspreaders", "manurespreaders", "beetharvesting", "harvesters"};
	
	iconWidescreenFix = 0;
	helperJobEndTimeBlinking = 20; --sec
	
};

VehicleInspector.seeWarning = {
	isBlocking = true;
	isFuelEmpty = true;
	fuelProzent = 10;
	isWater = true;	
	isDamage = true;
	damageProzent = 90;
};

VehicleInspector.seeVehicle = {
	onlyControlled = false; --needs isPlayer or/and isHelper
	notFillLevel = true;
	notAttached = false;	
	isTrain = false;	
	isOwnFarmVehicle = true;	
	isHelper = true;
	isPlayer = true;
	isHorsePlayer = true;
	isLeasing = true;
	isParking = true;
	isGps = true;
	
	--new--
	train = true;
	tractor = true;
	harvester = true;
	truck = true;
	car = true;
	other = true;
	teleloader = true;
	tool = true;
	trailer = true;
	loadtrailer = true;
	lowtrailer = true;
	--new--
};

VehicleInspector.seeTxt = {	
	playerName = true;
	helperName = false;
	vehicleName = 2; --0 Off, 1 VehicleName, 2 VehicleSmallName, 3 VehicleTypeName
	fillName = 1; --0 Off, 1 FillName, 2 realFillName	
	speed = true;
	field = true;
	fieldNumber = true;	
	fillProzent = true;
	fillLevel = true;
	fillObject = true;
	jobType = true; --old
	jobTypeTxt = 1; --0 off, 1 full Txt, 2 small txt   --new
	overload = true;
	leasing = true;
	parking = true;
	gps = true;	
	totalAttached = true;
	horse = true;
	cpRemaining = {state=0, mohVisible=true}; --0=all Off, 1=Time On/Waypoints Off, 2=Time Off/Waypoints On, 3=Time/Waypoints On --mohVisible for MultiOverlayHud Cmd and Color Icons
	adRemaining = {state=0, mohVisible=true}; --0=all Off, 1=Time On/Waypoints Off, 2=Time Off/Waypoints On, 3=Time/Waypoints On --mohVisible for MultiOverlayHud Cmd and Color Icons	
};

VehicleInspector.showHorse = {	
	horseWarningColor = true; 
	seeHorseCare = true; 
	seeHorseDayRiding = true; 
	seeHorseTodayRiding = true; 
	seeHorseTodayRidingMin = true; 
	seeHorseTodayRidingSec = true; 
	seeHorseFitness = true; 
	seeHorseHealth = true; 
};

VehicleInspector.showDraw = {
	helpMenuOn = true;	
	helpMenuOff = true;	
	inGameMapOn = true;
	inGameMapOff = true;	
};

VehicleInspector.txt = {		
	color = true;
	bold = false;
	separator = "|";
	ownSeparator = "--";
	speed = "km"; --Utils.getNoNil(g_i18n:getText("ui_cruiseControlSpeed"), "km");
	isField = "F";
	fieldNumberSeparator = "-";
	isHorse = Utils.getNoNil(g_i18n:getText("shopItem_animalHorse"), "Horse");
	fillNameToFillLevel = " ";  --is separator
	isOverload = "*Überladen*";
	isParking = "PA";
	isGps = "GPS";
	isHelper = "H";	
	isTrain = "T";				
	isPlayer = "P";				
	isSaEmpty = "! Empty !";
	isObject = " #";
	isSa = "^";				--is separator, see better Seeds/sowing etc.
	isSaOrFill = "?";		--is separator, Seeds/sowing or Fill is Unknown etc.
	isWater = "! Water !";
	isDamage = "! Damage !";
	isBlocking = "! Blocking !";
	isFuelEmpty = "! Fuel Empty !";
	isFillLevelFull = "! Full !";
	isLeasing = "Leasing";
	horseHealth = "Health:";
	horseFitness = Utils.getNoNil(g_i18n:getText("ui_horseFitness"), "Fitness:");
	horseTodayRiding = "Today Riding: ";
	horseDayRiding = Utils.getNoNil(g_i18n:getText("ui_horseDailyRiding"), "Days Riding:");
	horseTodayRidingHour = "h";
	horseCare = Utils.getNoNil(g_i18n:getText("statistic_cleanliness"), "Care:");
	remainingTimeSeparator = ":";
	remainingWaypoints = "w";
	remainingTimeWaypointsSeparator = " | ";
};

VehicleInspector.showColor = {	
	txt = "white"; 
	separator = "white";
	playerControlled = "ls15";
	otherPlayerControlled = "ls15Disabled";
	field = "mangenta";
	water = "darkBlue";
	damage = "orange";
	blocking = "red";
	leasing = "deepPink";
	background = "blackDisabled";
	parking = "yellow";
	gps = "ls15";
	full = "red";
	empty = "red";
	selected = "khaki";
	remainingString = "ls22";
};

VehicleInspector.showColorDefault = {};

