hlGuiMouseKeyEvents = {};

function hlGuiMouseKeyEvents:setKeyMouse(unicode, sym, modifier, isDownKey, posX, posY, isDown, isUp, button)	
	if unicode ~= nil then
		if not g_currentMission.hl.dragDrop.on then
			hlGuiMouseKeyEvents:setKey(unicode, sym, modifier, isDownKey);			
		end;
	else
		if g_currentMission.hl.isMouseCursor then
			if not g_currentMission.hl.dragDrop.on then
				hlGuiMouseKeyEvents:setMouse(posX, posY, isDown, isUp, button);
			elseif g_currentMission.hl.dragDrop.on then
				hlGuiMouseKeyEvents:setDragDropMouse(posX, posY, isDown, isUp, button);
			end;
		end;
	end;
end;

function hlGuiMouseKeyEvents:setMouse(posX, posY, isDown, isUp, button)	 
		
	for key,value in pairs (g_currentMission.hlGui.clickAreas.master) do
		if key ~= nil and value ~= nil and value[1] ~= nil then
			if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(value))then				
				local whichArea = value.whichArea;				
				if g_currentMission.hlGui.clickAreas.menue[tostring(whichArea)] ~= nil and #g_currentMission.hlGui.clickAreas.menue[tostring(whichArea)] > 0 then
					for area=1, #g_currentMission.hlGui.clickAreas.menue[tostring(whichArea)] do
						if g_currentMission.hlGui.clickAreas.menue[tostring(whichArea)] == nil or g_currentMission.hlGui.clickAreas.menue[tostring(whichArea)][area] == nil or g_currentMission.hlGui.clickAreas.menue[tostring(whichArea)][area][1] == nil then break;end;
						if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(g_currentMission.hlGui.clickAreas.menue[tostring(whichArea)][area]))then
							local clickAreaTable = g_currentMission.hlGui.clickAreas.menue[tostring(whichArea)][area];							
							if button == Input.MOUSE_BUTTON_LEFT and isDown and (tostring(clickAreaTable.whereClick) == "dragDrop_" or tostring(clickAreaTable.whereClick) == "dragDropWH_") then
								if not g_currentMission.hl.dragDrop.on then				
									if tostring(clickAreaTable.whereClick) == "dragDropWH_" then
										g_currentMission.hl.setDragDrop(true, "_hlGuiMenueWH_", clickAreaTable.whatClick, "");										
									else
										g_currentMission.hl.setDragDrop(true, "_hlGuiMenue_", clickAreaTable.whatClick, "");
									end;
								elseif g_currentMission.hl.dragDrop.on and isDown and g_currentMission.hl.dragDrop.where == clickAreaTable.whatClick then
									g_currentMission.hl.setDragDrop(false);										
								end;
							else
								hlGuiMouseKeyEvents:setButton(posX, posY, isDown, isUp, button, clickAreaTable);									
							end;						
						end;		
					end;
				end;			
			end;
		end;
	end;
	
end;

function hlGuiMouseKeyEvents:setKey(unicode, sym, modifier, isDown)
	
end;	

function hlGuiMouseKeyEvents:setDragDropMouse(posX, posY, isDown, isUp, button)	
	if button == Input.MOUSE_BUTTON_LEFT and isDown then		
		if g_currentMission.hl.dragDrop.on then
			if g_currentMission.hl.dragDrop.what == "_hlGuiMenue_" or g_currentMission.hl.dragDrop.what == "_hlGuiMenueWH_" then
				g_currentMission.hl.setDragDrop(false);					
				return;
			end;
		end;
	end;
end;

function hlGuiMouseKeyEvents:setButton(posX, posY, isDown, isUp, button, clickAreaTable)
	if hlGuiSetGet:isPullDownOpenButton() then
		--if clickAreaTable.whereClick ~= "pullDownMenueOpenArea_" then g_currentMission.hlGui.menue.pullDownButton.select = 0;end;
		if clickAreaTable.whereClick == "pullDownMenueOpen_" then
			g_currentMission.hlGui.menue.pullDownButton.select = clickAreaTable.pullDown.line;		
		end;
	end;
	if button == Input.MOUSE_BUTTON_LEFT then
		hlGuiMouseKeyEvents:buttonLeft(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_MIDDLE then
		hlGuiMouseKeyEvents:buttonMiddle(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_RIGHT then
		hlGuiMouseKeyEvents:buttonRight(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_WHEEL_UP then
		hlGuiMouseKeyEvents:buttonWheelUp(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_WHEEL_DOWN then
		hlGuiMouseKeyEvents:buttonWheelDown(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif clickAreaTable.infoTxt ~= nil and type(clickAreaTable.infoTxt) == "string" and string.len(clickAreaTable.infoTxt) > 0 then
		g_currentMission.hlGui.menue.infoBox.txt = tostring(clickAreaTable.infoTxt);
	end;		
end;

function hlGuiMouseKeyEvents:buttonLeft(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whereClick == "openHlGuiMenue_" and isDown then
		hlGuiSetGet:setOpen();
		return;
	elseif clickAreaTable.whereClick == "closeHlGuiMenue_" and isDown then
		hlGuiSetGet:setClose();
		return;
	elseif clickAreaTable.whereClick == "saveHlGuiMenue_" and isDown then
		hlGuiSetGet:setSave();
		return;	
	elseif clickAreaTable.whereClick == "helpHlGuiMenue_" and isDown then
		hlGuiSetGet:setHelp();
		return;
	elseif clickAreaTable.whereClick == "infoHlGuiMenue_" and isDown then
		hlGuiSetGet:setInfo();
		return;
	elseif clickAreaTable.whereClick == "zoomOutHlGuiMenue_" and isDown then
		hlGuiSetGet:setZoomOutIn(true);
		return;
	elseif clickAreaTable.whereClick == "zoomInHlGuiMenue_" and isDown then
		hlGuiSetGet:setZoomOutIn(false);
		return;
	elseif (clickAreaTable.whereClick == "sideLineButton_" or clickAreaTable.whereClick == "sideLineButtonUp_" or clickAreaTable.whereClick == "sideLineButtonDown_" or clickAreaTable.whereClick == "sideLineButtonLeft_" or clickAreaTable.whereClick == "sideLineButtonRight_") and isDown then
		if hlGuiSetGet:isPullDownOpenButton() then hlGuiSetGet:resetPullDownButton();end;
		if clickAreaTable.callback ~= nil then
			clickAreaTable.mouseClick = "MOUSE_BUTTON_LEFT";			
			clickAreaTable.up = clickAreaTable.whereClick == "sideLineButtonUp_";
			clickAreaTable.down = clickAreaTable.whereClick == "sideLineButtonDown_"
			clickAreaTable.right = clickAreaTable.whereClick == "sideLineButtonRight_"
			clickAreaTable.left =  clickAreaTable.whereClick == "sideLineButtonLeft_"
			clickAreaTable.callback(clickAreaTable);
		end;
		return;
	elseif (clickAreaTable.whereClick == "modPullDownHlGuiMenue_" or clickAreaTable.whereClick == "pagePullDownHlGuiMenue_" or clickAreaTable.whereClick == "sidePullDownHlGuiMenue_" or clickAreaTable.whereClick == "sideLineButtonPullDown_") and isDown then
		hlGuiSetGet:setMenuePullDown(clickAreaTable);
		return;	
	elseif hlGuiSetGet:isPullDownOpenButton() and clickAreaTable.whereClick == "pullDownMenueOpen_" and isDown then
		hlGuiSetGet:setMenuePullDownClick(clickAreaTable);
		return;
	end;
end;

function hlGuiMouseKeyEvents:buttonMiddle(posX, posY, isDown, isUp, button, clickAreaTable)
end;

function hlGuiMouseKeyEvents:buttonRight(posX, posY, isDown, isUp, button, clickAreaTable)
end;

function hlGuiMouseKeyEvents:buttonWheelUp(posX, posY, isDown, isUp, button, clickAreaTable)
	if hlGuiSetGet:isPullDownOpenButton() then
		if clickAreaTable.whereClick == "pullDownMenueOpenArea_" and isDown then
			clickAreaTable.up = true;
			hlGuiSetGet:setMenuePullDownBounds(clickAreaTable);
			return;
		end;
	else
		if not hlGuiSetGet:isPullDownOpenButton() and clickAreaTable.whereClick == "sideOpenArea_" and isDown then
			clickAreaTable.up = true;
			hlGuiSetGet:setSideLineBounds(clickAreaTable);			
			return;
		end;
	end;
end;

function hlGuiMouseKeyEvents:buttonWheelDown(posX, posY, isDown, isUp, button, clickAreaTable)
	if hlGuiSetGet:isPullDownOpenButton() then
		if clickAreaTable.whereClick == "pullDownMenueOpenArea_" and isDown then
			clickAreaTable.down = true;
			hlGuiSetGet:setMenuePullDownBounds(clickAreaTable);
			return;
		end;
	else
		if not hlGuiSetGet:isPullDownOpenButton() and clickAreaTable.whereClick == "sideOpenArea_" and isDown then
			clickAreaTable.down = true;
			hlGuiSetGet:setSideLineBounds(clickAreaTable);			
			return;
		end;
	end;
end;