viDrawIcons = {};

function viDrawIcons:setOpen()
	VehicleInspector.clickAreas.slave["default"] = {};
	VehicleInspector.clickAreas.master["default"] = {};
	--if VehicleInspector.global.foundMoh and VehicleInspector.global.onlyMoh then VehicleInspector.isVisible=false;return;end;
	function setSettingLine()
		if viSetGet:canSettingLine() then
			viDrawSettingLine:setOpen(0);	
		end;
	end;
	if not viSetGet:helpMenue() or not viSetGet:inGameMapMenu() then VehicleInspector.isVisible=false;setSettingLine();return;end;
	setSettingLine();
	if VehicleInspector.global.isHidden then VehicleInspector.isVisible=false;return;end;
	viOutput:loadVehicleByIcons();
	if #VehicleInspector.ownOutput <= 0 and #VehicleInspector.contractorOutput <= 0 then VehicleInspector.isVisible=false;return;end;
	VehicleInspector.isVisible = true;
	local posX = VehicleInspector.global.posX[VehicleInspector.global.viewModus];	 
	local posY = VehicleInspector.global.posY[VehicleInspector.global.viewModus];
	local width = 0; --VehicleInspector.global.width[VehicleInspector.global.viewModus];
	local height = 0; --VehicleInspector.global.height[VehicleInspector.global.viewModus];
	--local lastWidth = VehicleInspector.global.width.last;
	--local lastHeight = VehicleInspector.global.height.last;
	local endPosY = viSetGet:getEndPosY(); --g_currentMission.hlGui.menue.posY[2]+g_currentMission.hlGui.menue.height[2]; --VehicleInspector.inGameMapMenu
	local txtSize = VehicleInspector.global.txtSize;
	local txtHeight = getTextHeight(txtSize, utf8Substr("Äg", 0));
	local iconTxtHeight = getTextHeight(txtSize, utf8Substr("0", 0));
	local txtWidthDistance = VehicleInspector.global.txtWidthDistance;
	local txtLineDistance = VehicleInspector.global.txtLineDistance;	
	local ls22TxtColor = g_currentMission.hl.getColor("ls22", true);
	local fieldTxtColor = g_currentMission.hl.getColor(VehicleInspector.showColor.field, true);
	local iconHeight = txtHeight+(0.0025); 
	local iconWidescreenFix = 1.6+(VehicleInspector.global.iconWidescreenFix); --breitbild fix
	local iconWidth = txtHeight/iconWidescreenFix+((0.0025)/iconWidescreenFix);
	local separatorColor = g_currentMission.hl.getColor(VehicleInspector.showColor.separator, true);
	local txt = "";
	local isToLarge = false;
	local widthDif = 0.001;
	local sizeDif = 0.001;	
	local color = g_currentMission.hl.getColor(VehicleInspector.showColor.background, true);		
	local disableClickArea = g_currentMission.hl.dragDrop.on or not g_currentMission.hl.isMouseCursor;
	if VehicleInspector.global.seeBackground then VehicleInspector.overlays["ground"]:render();end;
	
	local startPosX = posX;
	local nextPosY = posY-iconHeight-(txtLineDistance);
	local startPosY = posY-iconHeight-(txtLineDistance);
	
	local groundOverlay = VehicleInspector.overlays["roundGround"];
	local storeGroundOverlay = VehicleInspector.overlays["storeGround"];
	local overlay;
	local tempOverlay;
	local iconLeftPosX = startPosX;
	function getJobEndBlinking(line)
		if line.blinking then
			if g_currentMission.hl.runsTimer("1sec", true) then
				return true;				
			end;
		end;
		return false;
	end;
	function setSpeed(line)
		if not VehicleInspector.seeTxt.speed and VehicleInspector.global.forceView == 0 then return;end;
		g_currentMission.hl.setOverlay(groundOverlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
		groundOverlay:render();
		overlay = VehicleInspector.overlays["speed"];
		g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
		if tonumber(line.speed) > 0 then
			if line.isTempomatOn then
				tempOverlay = VehicleInspector.overlays["tempomat"];
				g_currentMission.hl.setOverlay(tempOverlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
				tempOverlay:render();
			end;
			local optiSize = g_currentMission.hl.optiWidthSize(iconWidth*0.9, tostring(line.speed), txtSize);
			local iconTxtWidth = getTextWidth(optiSize, tostring(line.speed));			
			iconTxtHeight = getTextHeight(optiSize, utf8Substr(tostring(line.speed), 0));
			setTextColor(unpack(ls22TxtColor));
			renderText(iconLeftPosX+(iconWidth/2)-(iconTxtWidth/2), overlay.y+(iconHeight/2)-(iconTxtHeight/2)+0.001, optiSize, tostring(line.speed));			
			setTextColor(1, 1, 1, 1);
		else
			if line.isEngineOn then 
				color = g_currentMission.hl.getColor("green", true);				
			else
				color = g_currentMission.hl.getColor("whiteOff", true);				
			end;
			VehicleInspector:get_hl("setBackgroundColor", {overlay, color}, "viDrawIcons:setOpen()");
			overlay:render();
		end;
		iconLeftPosX = iconLeftPosX+iconWidth+widthDif;
	end;
	function setField(line)
		if not VehicleInspector.seeTxt.field and VehicleInspector.global.forceView == 0 then return;end;
		g_currentMission.hl.setOverlay(groundOverlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
		groundOverlay:render();		
		local fieldNrTxt = "";
		if line.isField and line.fieldNr > 0 then fieldNrTxt = tostring(line.fieldNr);end;
		if not line.isField or (line.isField and line.fieldNr <= 0) then
			overlay = VehicleInspector.overlays["field"];
			g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
			if not line.isField or line.fieldNr > 0 then
				color = g_currentMission.hl.getColor("darkGrayOff", true);				
			elseif line.isField then
				color = g_currentMission.hl.getColor("yellowDisabled", true);				
			end;
			VehicleInspector:get_hl("setBackgroundColor", {overlay, color}, "viDrawIcons:setOpen()");
			overlay:render();
		else
			local optiSize = g_currentMission.hl.optiWidthSize(iconWidth*0.9, tostring(fieldNrTxt), txtSize);
			local iconTxtWidth = getTextWidth(optiSize, tostring(fieldNrTxt));
			iconTxtHeight = getTextHeight(optiSize, utf8Substr(tostring(fieldNrTxt), 0));
			setTextColor(unpack(fieldTxtColor));
			renderText(iconLeftPosX+(iconWidth/2)-(iconTxtWidth/2), groundOverlay.y+(iconHeight/2)-(iconTxtHeight/2)+0.001, optiSize, tostring(fieldNrTxt));				
			setTextColor(1, 1, 1, 1);
		end;
		iconLeftPosX = iconLeftPosX+iconWidth+widthDif;
	end;
	function setVehicleIcon(line, isLine, tableType)
		if VehicleInspector.global.iconDisplay.vehicleIcon == 0 and VehicleInspector.global.forceView == 0 then return;end;
		local tempVehicleIcon = VehicleInspector.global.iconDisplay.vehicleIcon;
		if VehicleInspector.global.forceView == 2 then tempVehicleIcon = 2;end;
		local vehicleType = line.viCategoryName;
		local canRealIcon = line.storeName ~= nil and VehicleInspector.storeOverlays[line.storeName] ~= nil;
		if tempVehicleIcon == 2 and canRealIcon then
			g_currentMission.hl.setOverlay(storeGroundOverlay, iconLeftPosX, nextPosY, iconWidth*1.1, iconHeight*1.1);
			--storeGroundOverlay:render();
			overlay = VehicleInspector.storeOverlays[line.storeName];
			g_currentMission.hl.setOverlay(overlay, iconLeftPosX-0.003, nextPosY, iconWidth*1.5, iconHeight*1.5);												
			overlay:render();
			tempOverlay = VehicleInspector.overlays["uMarker"];
			g_currentMission.hl.setOverlay(tempOverlay, iconLeftPosX, nextPosY+0.001, iconWidth, iconHeight);
			local viewMarker = false;
			if line.isPlayer and not line.isOtherPlayer then
				color = g_currentMission.hl.getColor(VehicleInspector.showColor.playerControlled, true);
				viewMarker = true;
			elseif line.isPlayer and line.isOtherPlayer then
				color = g_currentMission.hl.getColor(VehicleInspector.showColor.otherPlayerControlled, true);
				viewUMarker = true;
			elseif line.isHelper then
				color = g_currentMission.hl.getColor("darkGreen", true);
				viewMarker = true;
			else
				color = g_currentMission.hl.getColor("whiteOff", true);
			end;
			VehicleInspector:get_hl("setBackgroundColor", {tempOverlay, color}, "viDrawIcons:setOpen()");
			if viewMarker then tempOverlay:render();end;
			iconLeftPosX = iconLeftPosX+iconWidth+widthDif;
			if line.rootNode ~= nil and line.rootNode > 0 and not disableClickArea then viDrawIcons:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whereClick="vehicleJoin_", rootNode=line.rootNode, line=isLine, tableType=tableType} );end;
		elseif tempVehicleIcon == 1 or (tempVehicleIcon == 2 and not canRealIcon) then
			g_currentMission.hl.setOverlay(groundOverlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
			groundOverlay:render();
			overlay = VehicleInspector.categoryOverlays[VehicleInspector.vehicleTypeCategoryNumber[vehicleType]];
			if overlay == nil then overlay = VehicleInspector.categoryOverlays[5];end;
			g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
			if line.isPlayer and not line.isOtherPlayer then
				color = g_currentMission.hl.getColor(VehicleInspector.showColor.playerControlled, true);
			elseif line.isPlayer and line.isOtherPlayer then
				color = g_currentMission.hl.getColor(VehicleInspector.showColor.otherPlayerControlled, true);
			elseif line.isHelper then
				color = g_currentMission.hl.getColor("darkGreen", true);
			else
				color = g_currentMission.hl.getColor("whiteOff", true);
			end;
			VehicleInspector:get_hl("setBackgroundColor", {overlay, color}, "viDrawIcons:setOpen()");
			overlay:render();			
			iconLeftPosX = iconLeftPosX+iconWidth+widthDif;
			if line.rootNode ~= nil and line.rootNode > 0 and not disableClickArea then viDrawIcons:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whereClick="vehicleJoin_", rootNode=line.rootNode, line=isLine, tableType=tableType} );end;
		end;
	end;
	function setVehicleName(line, isLine, tableType)
		if VehicleInspector.seeTxt.vehicleName == 0 and VehicleInspector.global.forceView == 0 then return;end;
		if line.vehicleName:len() > 0 then
			local firstIconLeftPosX = iconLeftPosX;
			local vehicleNameTxt = tostring(line.vehicleName);
			local iconTxtWidth = getTextWidth(txtSize, tostring(vehicleNameTxt));
			local maxIconWidth = g_currentMission.hl.getMaxIconWidth(iconTxtWidth, iconWidth*0.9);
			if maxIconWidth < 3 then maxIconWidth = 3;end;
			for i=1, maxIconWidth do
				if i == 1 then
					overlay = VehicleInspector.overlays["frontGround"];
					g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
					overlay:render();
					iconLeftPosX = iconLeftPosX+iconWidth;
				elseif i == maxIconWidth then
					overlay = VehicleInspector.overlays["backGround"];
					g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
					overlay:render();
					iconLeftPosX = iconLeftPosX+iconWidth+widthDif;
				else
					overlay = VehicleInspector.overlays["middleGround"];
					g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
					overlay:render();
					iconLeftPosX = iconLeftPosX+iconWidth;
				end;
			end;
			if line.rootNode ~= nil and line.rootNode > 0 and not disableClickArea then viDrawIcons:clickAreas(false, {firstIconLeftPosX, firstIconLeftPosX+iconWidth*maxIconWidth, overlay.y, overlay.y+overlay.height, whereClick="vehicleJoin_", rootNode=line.rootNode, line=isLine, tableType=tableType} );end;
			local optiSize = g_currentMission.hl.optiWidthSize((iconWidth*0.9)*maxIconWidth, tostring(vehicleNameTxt), txtSize);
			iconTxtWidth = getTextWidth(optiSize, tostring(vehicleNameTxt));
			iconTxtHeight = getTextHeight(optiSize, utf8Substr(tostring(vehicleNameTxt), 0));
			setTextColor(1, 1, 1, 1);
			renderText(firstIconLeftPosX+(iconWidth*maxIconWidth/2)-(iconTxtWidth/2), overlay.y+(iconHeight/2)-(iconTxtHeight/2)+0.001, optiSize, tostring(vehicleNameTxt));				
			setTextColor(1, 1, 1, 1);
		end;
	end;
	function setAttachedIcon(line)
		if VehicleInspector.global.iconDisplay.attachedIcon == 0 and VehicleInspector.global.forceView == 0 then return;end;
		local tempAttachedIcon = VehicleInspector.global.iconDisplay.attachedIcon;
		if VehicleInspector.global.forceView == 2 then tempAttachedIcon = 2;end;
		for v=1, #line.rootNodes do
			local vehicle = g_currentMission:getNodeObject(line.rootNodes[v])
			if vehicle ~= nil then
				local vehicleType = vehicle.viCategoryName;
				local storeName = tostring(vehicle.getName(vehicle));
				local canRealIcon = storeName ~= nil and VehicleInspector.storeOverlays[storeName] ~= nil;
				if tempAttachedIcon == 2 and canRealIcon then
					g_currentMission.hl.setOverlay(storeGroundOverlay, iconLeftPosX, nextPosY, iconWidth*1.1, iconHeight*1.1);
					--storeGroundOverlay:render();
					overlay = VehicleInspector.storeOverlays[storeName];
					g_currentMission.hl.setOverlay(overlay, iconLeftPosX-0.003, nextPosY, iconWidth*1.5, iconHeight*1.5);												
					overlay:render();
					iconLeftPosX = iconLeftPosX+iconWidth+widthDif;
				elseif tempAttachedIcon == 1 or (tempAttachedIcon == 2 and not canRealIcon) then
					g_currentMission.hl.setOverlay(groundOverlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
					groundOverlay:render();
					local categoryNumber = VehicleInspector.vehicleTypeCategoryNumber[vehicleType];
					if categoryNumber == nil or categoryNumber < 8 or categoryNumber > 12 then categoryNumber = 8;end;
					overlay = VehicleInspector.categoryOverlays[categoryNumber];					
					g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY+0.001, iconWidth, iconHeight);
					color = g_currentMission.hl.getColor("whiteOff", true);
					VehicleInspector:get_hl("setBackgroundColor", {overlay, color}, "viDrawIcons:setOpen()");
					overlay:render();			
					iconLeftPosX = iconLeftPosX+iconWidth+widthDif;
				end;
			end;
		end;
	end;
	function setFillTypeIcon(line)
		if not VehicleInspector.global.iconDisplay.fillIcon and VehicleInspector.global.forceView == 0 then return;end;
		if line.fillType ~= nil and line.fillType > 0 and VehicleInspector.fillTypeOverlays[line.fillType] ~= nil then
			g_currentMission.hl.setOverlay(groundOverlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
			groundOverlay:render();
			overlay = VehicleInspector.fillTypeOverlays[line.fillType];
			g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
			overlay:render();
			iconLeftPosX = iconLeftPosX+iconWidth+widthDif;
		end;
	end;
	function setFillProzent(line, prozentColor)
		if not VehicleInspector.seeTxt.fillProzent and VehicleInspector.global.forceView == 0 then return;end;
		if line.fillProzent ~= nil and line.fillProzent > 0 then
			local prozentTxt = string.format("%1.0f", "".. tonumber(line.fillProzent)).. "%";
			overlay = VehicleInspector.overlays["frontGround"];
			tempOverlay = VehicleInspector.overlays["backGround"];
			g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
			g_currentMission.hl.setOverlay(tempOverlay, iconLeftPosX+iconWidth, nextPosY, iconWidth, iconHeight);
			overlay:render();
			tempOverlay:render();
			local optiSize = g_currentMission.hl.optiWidthSize(iconWidth*1.8, tostring(prozentTxt), txtSize);
			local iconTxtWidth = getTextWidth(optiSize, tostring(prozentTxt));
			iconTxtHeight = getTextHeight(optiSize, utf8Substr(tostring(prozentTxt), 0));			
			setTextColor(unpack(prozentColor));
			renderText(iconLeftPosX+(iconWidth)-(iconTxtWidth/2), overlay.y+(iconHeight/2)-(iconTxtHeight/2)+0.001, optiSize, tostring(prozentTxt));			
			setTextColor(1, 1, 1, 1);
			iconLeftPosX = iconLeftPosX+(iconWidth*2)+widthDif;
		end;
	end;
	function setFillLevel(line, prozentColor)
		if not VehicleInspector.seeTxt.fillLevel and VehicleInspector.global.forceView == 0 then return;end;
		if line.fillLevel ~= nil and line.fillLevel > 0 then
			local firstIconLeftPosX = iconLeftPosX;
			local fillLevelTxt = tostring(string.format("%1.0f", Utils.getNoNil(line.fillLevel, 0)));
			local iconTxtWidth = getTextWidth(txtSize, tostring(fillLevelTxt));
			local maxIconWidth = g_currentMission.hl.getMaxIconWidth(iconTxtWidth, iconWidth*0.9);
			if maxIconWidth < 3 then maxIconWidth = 3;end;
			for i=1, maxIconWidth do
				if i == 1 then
					overlay = VehicleInspector.overlays["frontGround"];
					g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
					overlay:render();
					iconLeftPosX = iconLeftPosX+iconWidth;
				elseif i == maxIconWidth then
					overlay = VehicleInspector.overlays["backGround"];
					g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
					overlay:render();
					iconLeftPosX = iconLeftPosX+iconWidth+widthDif;
				else
					overlay = VehicleInspector.overlays["middleGround"];
					g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
					overlay:render();
					iconLeftPosX = iconLeftPosX+iconWidth;
				end;
			end;
			local optiSize = g_currentMission.hl.optiWidthSize((iconWidth*0.9)*maxIconWidth, tostring(fillLevelTxt), txtSize);
			iconTxtWidth = getTextWidth(optiSize, tostring(fillLevelTxt));
			iconTxtHeight = getTextHeight(optiSize, utf8Substr(tostring(fillLevelTxt), 0));
			setTextColor(unpack(prozentColor));
			renderText(firstIconLeftPosX+(iconWidth*maxIconWidth/2)-(iconTxtWidth/2), overlay.y+(iconHeight/2)-(iconTxtHeight/2)+0.001, optiSize, tostring(fillLevelTxt));			
			setTextColor(1, 1, 1, 1);
		end;
	end;
	function setFillTypeName(line, prozentColor)
		if not VehicleInspector.seeTxt.fillName == 0 and VehicleInspector.global.forceView == 0 then return;end;
		if line.fillTypeName ~= nil and line.fillTypeName:lower() ~= "unknown" then			
			local firstIconLeftPosX = iconLeftPosX;
			local iconTxtWidth = getTextWidth(txtSize, tostring(line.fillTypeName));
			local maxIconWidth = g_currentMission.hl.getMaxIconWidth(iconTxtWidth, iconWidth*0.9);
			if maxIconWidth < 3 then maxIconWidth = 3;end;
			for i=1, maxIconWidth do
				if i == 1 then
					overlay = VehicleInspector.overlays["frontGround"];
					g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
					overlay:render();
					iconLeftPosX = iconLeftPosX+iconWidth;
				elseif i == maxIconWidth then
					overlay = VehicleInspector.overlays["backGround"];
					g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
					overlay:render();
					iconLeftPosX = iconLeftPosX+iconWidth+widthDif;
				else
					overlay = VehicleInspector.overlays["middleGround"];
					g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
					overlay:render();
					iconLeftPosX = iconLeftPosX+iconWidth;
				end;
			end;
			local optiSize = g_currentMission.hl.optiWidthSize((iconWidth*0.9)*maxIconWidth, tostring(line.fillTypeName), txtSize);
			iconTxtWidth = getTextWidth(optiSize, tostring(line.fillTypeName));
			iconTxtHeight = getTextHeight(optiSize, utf8Substr(tostring(line.fillTypeName), 0));
			setTextColor(unpack(prozentColor));
			renderText(firstIconLeftPosX+(iconWidth*maxIconWidth/2)-(iconTxtWidth/2), overlay.y+(iconHeight/2)-(iconTxtHeight/2)+0.001, optiSize, tostring(line.fillTypeName));			
			setTextColor(1, 1, 1, 1);
		end;
	end;
	function setLeasing(line)
		if not VehicleInspector.seeTxt.leasing and VehicleInspector.global.forceView == 0 then return;end;
		if line.isLeasing then
			g_currentMission.hl.setOverlay(groundOverlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
			groundOverlay:render();
			overlay = VehicleInspector.overlays["leasing"];
			g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
			color = g_currentMission.hl.getColor(VehicleInspector.showColor.leasing, true)
			VehicleInspector:get_hl("setBackgroundColor", {overlay, color}, "viDrawIcons:setOpen()");
			overlay:render();
			iconLeftPosX = iconLeftPosX+iconWidth+widthDif;
		end;
	end;
	function setParking(line)
		if not VehicleInspector.seeTxt.parking and VehicleInspector.global.forceView == 0 then return;end;
		if line.isParking then
			g_currentMission.hl.setOverlay(groundOverlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
			groundOverlay:render();
			overlay = VehicleInspector.overlays["parking"];
			g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
			color = g_currentMission.hl.getColor(VehicleInspector.showColor.parking, true)
			VehicleInspector:get_hl("setBackgroundColor", {overlay, color}, "viDrawIcons:setOpen()");
			overlay:render();
			iconLeftPosX = iconLeftPosX+iconWidth+widthDif;
		end;
	end;
	function setGps(line)
		if not VehicleInspector.seeTxt.gps and VehicleInspector.global.forceView == 0 then return;end;
		if line.isGps then
			g_currentMission.hl.setOverlay(groundOverlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
			groundOverlay:render();
			overlay = VehicleInspector.overlays["gps"];
			g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
			if not line.isGpsActive then
				color = g_currentMission.hl.getColor("darkGray", true)
			else
				color = g_currentMission.hl.getColor(VehicleInspector.showColor.gps, true);
			end;
			VehicleInspector:get_hl("setBackgroundColor", {overlay, color}, "viDrawIcons:setOpen()");
			overlay:render();
			iconLeftPosX = iconLeftPosX+iconWidth+widthDif;
		end;
	end;
	function setAttached(line)
		if not VehicleInspector.seeTxt.totalAttached and VehicleInspector.global.forceView == 0 then return;end;
		if line.totalAttached > 0 then
			g_currentMission.hl.setOverlay(groundOverlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
			groundOverlay:render();
			overlay = VehicleInspector.overlays["attached"];
			g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
			--color = g_currentMission.hl.getColor("ls22Inactive", true);
			if g_currentMission.hl.runsTimer("15sec", true) then
				color = g_currentMission.hl.getColor("darkGrayOff1", true);
			else
				color = g_currentMission.hl.getColor("darkGray", true);
			end;
			VehicleInspector:get_hl("setBackgroundColor", {overlay, color}, "viDrawIcons:setOpen()");
			overlay:render();
			if g_currentMission.hl.runsTimer("15sec", true) then
				local optiSize = g_currentMission.hl.optiHeightSize(iconWidth, tostring(line.totalAttached), txtSize);
				local iconTxtWidth = getTextWidth(optiSize, tostring(line.totalAttached));			
				iconTxtHeight = getTextHeight(optiSize, utf8Substr(tostring(line.totalAttached), 0));
				color = g_currentMission.hl.getColor("ls22", true);
				setTextColor(unpack(color));
				renderText(iconLeftPosX+(iconWidth/2), groundOverlay.y+(iconHeight/2)-(iconTxtHeight/2)+0.001, optiSize, tostring(line.totalAttached));
				setTextColor(1, 1, 1, 1);
			end;
			iconLeftPosX = iconLeftPosX+iconWidth+widthDif;
		end;
	end;
	function setControlledName(line)
		if line.controlledName:len() > 0 then
			local firstIconLeftPosX = iconLeftPosX;
			local iconTxtWidth = getTextWidth(txtSize, tostring(line.controlledName));
			local maxIconWidth = g_currentMission.hl.getMaxIconWidth(iconTxtWidth, iconWidth*0.9);
			if maxIconWidth < 3 then maxIconWidth = 3;end;
			for i=1, maxIconWidth do
				if i == 1 then
					overlay = VehicleInspector.overlays["frontGround"];
					g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
					overlay:render();
					iconLeftPosX = iconLeftPosX+iconWidth;
				elseif i == maxIconWidth then
					overlay = VehicleInspector.overlays["backGround"];
					g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
					overlay:render();
					iconLeftPosX = iconLeftPosX+iconWidth+widthDif;
				else
					overlay = VehicleInspector.overlays["middleGround"];
					g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
					overlay:render();
					iconLeftPosX = iconLeftPosX+iconWidth;
				end;
			end;
			local optiSize = g_currentMission.hl.optiWidthSize((iconWidth*0.9)*maxIconWidth, tostring(line.controlledName), txtSize);
			iconTxtWidth = getTextWidth(optiSize, tostring(line.controlledName));
			iconTxtHeight = getTextHeight(optiSize, utf8Substr(tostring(line.controlledName), 0));
			if line.isPlayer and not line.isOtherPlayer then
				color = g_currentMission.hl.getColor(VehicleInspector.showColor.playerControlled, true);
			elseif line.isPlayer and line.isOtherPlayer then
				color = g_currentMission.hl.getColor(VehicleInspector.showColor.otherPlayerControlled, true);
			elseif line.isHelper then
				color = g_currentMission.hl.getColor("darkGreen", true);
			else
				color = g_currentMission.hl.getColor("whiteOff", true);
			end;
			setTextColor(unpack(color));
			renderText(firstIconLeftPosX+(iconWidth*maxIconWidth/2)-(iconTxtWidth/2), overlay.y+(iconHeight/2)-(iconTxtHeight/2)+0.001, optiSize, tostring(line.controlledName));			
			setTextColor(1, 1, 1, 1);
		end;
	end;	
	function setWarnings(line, isLineBlinking)
		if isLineBlinking then			
			local otherPosX = startPosX-iconWidth-widthDif;
			g_currentMission.hl.setOverlay(groundOverlay, otherPosX, nextPosY, iconWidth, iconHeight);
			groundOverlay:render();
			overlay = VehicleInspector.overlays["buttonRight"];
			g_currentMission.hl.setOverlay(overlay, otherPosX, nextPosY, iconWidth, iconHeight);				
			color = g_currentMission.hl.getColor("ls22", true);				
			VehicleInspector:get_hl("setBackgroundColor", {overlay, color}, "viDrawIcons:setOpen()");
			overlay:render();			
		end;
		if line.isWarning and not isLineBlinking then
			local otherPosX = startPosX-iconWidth-widthDif;
			g_currentMission.hl.setOverlay(groundOverlay, otherPosX, nextPosY, iconWidth, iconHeight);
			groundOverlay:render();		
			if line.warnings.isPipeState then
				overlay = VehicleInspector.overlays["overloaded"];
				g_currentMission.hl.setOverlay(overlay, otherPosX, nextPosY, iconWidth, iconHeight);				
				color = g_currentMission.hl.getColor("yellow", true);				
				VehicleInspector:get_hl("setBackgroundColor", {overlay, color}, "viDrawIcons:setOpen()");
				overlay:render();
			elseif line.warnings.isBlocking then
				overlay = VehicleInspector.overlays["warning1"];
				g_currentMission.hl.setOverlay(overlay, otherPosX, nextPosY, iconWidth, iconHeight);
				if line.warnings.blockingType == 2 then
					color = g_currentMission.hl.getColor("yellow", true);
				else
					color = g_currentMission.hl.getColor(VehicleInspector.showColor.blocking, true);
				end;
				VehicleInspector:get_hl("setBackgroundColor", {overlay, color}, "viDrawIcons:setOpen()");
				overlay:render();							
			elseif line.warnings.isWater then
				overlay = VehicleInspector.overlays["warning1"];
				g_currentMission.hl.setOverlay(overlay, otherPosX, nextPosY, iconWidth, iconHeight);
				color = g_currentMission.hl.getColor(VehicleInspector.showColor.water, true);
				VehicleInspector:get_hl("setBackgroundColor", {overlay, color}, "viDrawIcons:setOpen()");
				overlay:render();
			elseif line.warnings.isDamage then
				overlay = VehicleInspector.overlays["repair"];
				g_currentMission.hl.setOverlay(overlay, otherPosX, nextPosY, iconWidth, iconHeight);
				color = g_currentMission.hl.getColor(VehicleInspector.showColor.damage, true);
				VehicleInspector:get_hl("setBackgroundColor", {overlay, color}, "viDrawIcons:setOpen()");
				overlay:render();
			elseif line.warnings.isFuelEmpty then
				overlay = VehicleInspector.overlays["refuel"];
				g_currentMission.hl.setOverlay(overlay, otherPosX, nextPosY, iconWidth, iconHeight);
				color = g_currentMission.hl.getColor(VehicleInspector.showColor.empty, true);
				VehicleInspector:get_hl("setBackgroundColor", {overlay, color}, "viDrawIcons:setOpen()");
				overlay:render();
			end;			
		end;
	end;
	function setJobTypeTxt(line)
		if VehicleInspector.seeTxt.jobTypeTxt == 0 and VehicleInspector.global.forceView == 0 then return;end;
		if line.isJob or line.isAdJob then
			if line.jobTypeTxt:len() > 0 and (VehicleInspector.seeTxt.jobTypeTxt == 1 or VehicleInspector.global.forceView > 0) then
				local firstIconLeftPosX = iconLeftPosX;
				local iconTxtWidth = getTextWidth(txtSize, tostring(line.jobTypeTxt));
				local maxIconWidth = g_currentMission.hl.getMaxIconWidth(iconTxtWidth, iconWidth*0.9);
				if maxIconWidth < 3 then maxIconWidth = 3;end;
				for i=1, maxIconWidth do
					if i == 1 then
						overlay = VehicleInspector.overlays["frontGround"];
						g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
						overlay:render();
						iconLeftPosX = iconLeftPosX+iconWidth;
					elseif i == maxIconWidth then
						overlay = VehicleInspector.overlays["backGround"];
						g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
						overlay:render();
						iconLeftPosX = iconLeftPosX+iconWidth+widthDif;
					else
						overlay = VehicleInspector.overlays["middleGround"];
						g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
						overlay:render();
						iconLeftPosX = iconLeftPosX+iconWidth;
					end;
				end;
				local optiSize = g_currentMission.hl.optiWidthSize((iconWidth*0.9)*maxIconWidth, tostring(line.jobTypeTxt), txtSize);
				iconTxtWidth = getTextWidth(optiSize, tostring(line.jobTypeTxt));
				iconTxtHeight = getTextHeight(optiSize, utf8Substr(tostring(line.jobTypeTxt), 0));
				color = g_currentMission.hl.getColor("green", true);
				setTextColor(unpack(color));
				renderText(firstIconLeftPosX+(iconWidth*maxIconWidth/2)-(iconTxtWidth/2), overlay.y+(iconHeight/2)-(iconTxtHeight/2)+0.001, optiSize, tostring(line.jobTypeTxt));				
				setTextColor(1, 1, 1, 1);
			elseif line.jobTypeIconTxt:len() > 0 and (VehicleInspector.seeTxt.jobTypeTxt == 2 or VehicleInspector.global.forceView > 0) then
				g_currentMission.hl.setOverlay(groundOverlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
				groundOverlay:render();
				color = g_currentMission.hl.getColor("green", true);
				local optiSize = g_currentMission.hl.optiWidthSize((iconWidth*0.9), tostring(line.jobTypeIconTxt), txtSize);
				local iconTxtWidth = getTextWidth(optiSize, tostring(line.jobTypeIconTxt));
				iconTxtHeight = getTextHeight(optiSize, utf8Substr(tostring(line.jobTypeIconTxt), 0));
				setTextColor(unpack(color));
				renderText(iconLeftPosX+(iconWidth/2)-(iconTxtWidth/2), groundOverlay.y+(iconHeight/2)-(iconTxtHeight/2)+0.001, optiSize, tostring(line.jobTypeIconTxt));
				setTextColor(1, 1, 1, 1);
				iconLeftPosX = iconLeftPosX+iconWidth+widthDif;
			end;
		end;
	end;	
	function setRemainingString(line)
		if line.remainingString == nil then return;end;		
		local firstIconLeftPosX = iconLeftPosX;
		local iconTxtWidth = getTextWidth(txtSize-0.0005, tostring(line.remainingString));
		local maxIconWidth = g_currentMission.hl.getMaxIconWidth(iconTxtWidth, iconWidth*0.95);
		if maxIconWidth < 3 then maxIconWidth = 3;end;
		for i=1, maxIconWidth do
			if i == 1 then
				overlay = VehicleInspector.overlays["frontGround"];
				g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
				overlay:render();
				iconLeftPosX = iconLeftPosX+iconWidth;
			elseif i == maxIconWidth then
				overlay = VehicleInspector.overlays["backGround"];
				g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
				overlay:render();
				iconLeftPosX = iconLeftPosX+iconWidth+widthDif;
			else
				overlay = VehicleInspector.overlays["middleGround"];
				g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
				overlay:render();
				iconLeftPosX = iconLeftPosX+iconWidth;
			end;
		end;		
		local optiSize = g_currentMission.hl.optiWidthSize((iconWidth*0.9)*maxIconWidth, tostring(line.remainingString), txtSize-0.0005); 
		iconTxtWidth = getTextWidth(optiSize, tostring(line.remainingString));
		iconTxtHeight = getTextHeight(optiSize, utf8Substr(tostring(line.remainingString), 0));
		color = g_currentMission.hl.getColor(VehicleInspector.showColor.remainingString, true);
		setTextColor(unpack(color));
		--setTextBold(true);
		renderText(firstIconLeftPosX+(iconWidth*maxIconWidth/2)-(iconTxtWidth/2), overlay.y+(iconHeight/2)-(iconTxtHeight/2)+0.001, optiSize, tostring(line.remainingString));				
		renderText(firstIconLeftPosX+(iconWidth*maxIconWidth/2)-(iconTxtWidth/2), overlay.y+(iconHeight/2)-(iconTxtHeight/2)+0.001, optiSize, tostring(line.remainingString));
		--setTextBold(false);
		setTextColor(1, 1, 1, 1);		
	end;
	function setFarmName(farmName)
		iconLeftPosX = startPosX;
		local firstIconLeftPosX = iconLeftPosX;
		local iconTxtWidth = getTextWidth(txtSize, tostring(farmName));
		local maxIconWidth = g_currentMission.hl.getMaxIconWidth(iconTxtWidth, iconWidth*0.9);
		if maxIconWidth < 3 then maxIconWidth = 3;end;
		for i=1, maxIconWidth do
			if i == 1 then
				overlay = VehicleInspector.overlays["frontGround"];
				g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
				overlay:render();
				iconLeftPosX = iconLeftPosX+iconWidth;
			elseif i == maxIconWidth then
				overlay = VehicleInspector.overlays["backGround"];
				g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
				overlay:render();
				iconLeftPosX = iconLeftPosX+iconWidth+widthDif;
			else
				overlay = VehicleInspector.overlays["middleGround"];
				g_currentMission.hl.setOverlay(overlay, iconLeftPosX, nextPosY, iconWidth, iconHeight);
				overlay:render();
				iconLeftPosX = iconLeftPosX+iconWidth;
			end;
		end;
		local optiSize = g_currentMission.hl.optiWidthSize((iconWidth*0.9)*maxIconWidth, tostring(farmName), txtSize);
		iconTxtWidth = getTextWidth(optiSize, tostring(farmName));
		iconTxtHeight = getTextHeight(optiSize, utf8Substr(tostring(farmName), 0));
		setTextColor(1, 1, 1, 1);
		renderText(firstIconLeftPosX+(iconWidth*maxIconWidth/2)-(iconTxtWidth/2), overlay.y+(iconHeight/2)-(iconTxtHeight/2)+0.001, optiSize, tostring(farmName));				
		setTextColor(1, 1, 1, 1);		
	end;	
	-------------------------
	if nextPosY-iconHeight-txtLineDistance < endPosY then isToLarge=true;end;
	local isFirstLine = false;
	local viewLines = 0;
	if not isToLarge then
		for line=1, #VehicleInspector.ownOutput do
			local isLine = VehicleInspector.ownOutput[line];
			if isLine ~= nil and isLine.view then
				viewLines = viewLines+1;
				if width < iconLeftPosX-startPosX then width = iconLeftPosX-startPosX;end;
				if nextPosY-iconHeight-txtLineDistance < endPosY then isToLarge=true;break;end;
				if isFirstLine then nextPosY = nextPosY-iconHeight-txtLineDistance;end;
				local lineBlinking = getJobEndBlinking(isLine);
				isFirstLine = true;
				iconLeftPosX = startPosX;			
				for order=1, #VehicleInspector.global.iconDisplay.setOrder do
					if VehicleInspector.global.iconDisplay.setOrder[order] == "setSpeed" then
						setSpeed(isLine);			
					elseif VehicleInspector.global.iconDisplay.setOrder[order] == "setField" then
						setField(isLine);
					elseif VehicleInspector.global.iconDisplay.setOrder[order] == "setVehicle" then
						for vOrder=1, #VehicleInspector.global.iconDisplay.setOrderVehicle do
							if VehicleInspector.global.iconDisplay.setOrderVehicle[vOrder] == "setVehicleIcon" then
								setVehicleIcon(isLine, line, "ownOutput");
							elseif VehicleInspector.global.iconDisplay.setOrderVehicle[vOrder] == "setVehicleName" then
								setVehicleName(isLine, line, "ownOutput");
							end;
						end;
					elseif VehicleInspector.global.iconDisplay.setOrder[order] == "setFillLevelInformation" then
						if isLine.fillLevelInformation ~= nil and #isLine.fillLevelInformation > 0 then 
							local attachedLimit = 0;
							for f=1, #isLine.fillLevelInformation do
								if isLine.fillLevelInformation[f] ~= nil then
									if attachedLimit >= VehicleInspector.global.attachedLimit and VehicleInspector.global.forceView ~= 2 then break;end;
									local prozentColor = 1;
									if VehicleInspector.txt.color then prozentColor = g_currentMission.hl.getProzentColor(isLine.fillLevelInformation[f].fillProzent, isLine.fillLevelInformation[f].isSeedsOrAnd);end;
									prozentColor = g_currentMission.hl.getColorProzent(prozentColor,true);
									setAttachedIcon(isLine.fillLevelInformation[f]);
									for fOrder=1, #VehicleInspector.global.iconDisplay.setOrderFillLevelInformation do
										if VehicleInspector.global.iconDisplay.setOrderFillLevelInformation[fOrder] == "setFillTypeIcon" then
											setFillTypeIcon(isLine.fillLevelInformation[f], prozentColor);
										elseif VehicleInspector.global.iconDisplay.setOrderFillLevelInformation[fOrder] == "setFillLevel" then
											setFillLevel(isLine.fillLevelInformation[f], prozentColor);
										elseif VehicleInspector.global.iconDisplay.setOrderFillLevelInformation[fOrder] == "setFillProzent" then
											setFillProzent(isLine.fillLevelInformation[f], prozentColor);
										elseif VehicleInspector.global.iconDisplay.setOrderFillLevelInformation[fOrder] == "setFillTypeName" then
											setFillTypeName(isLine.fillLevelInformation[f], prozentColor);
										end;
									end;
									attachedLimit = attachedLimit+1;
								end;
							end;
						end;
					elseif VehicleInspector.global.iconDisplay.setOrder[order] == "setAttached" then
						setAttached(isLine);
					elseif VehicleInspector.global.iconDisplay.setOrder[order] == "setControlledName" then
						setControlledName(isLine);
					elseif VehicleInspector.global.iconDisplay.setOrder[order] == "setLeasing" then
						setLeasing(isLine);
					elseif VehicleInspector.global.iconDisplay.setOrder[order] == "setParking" then
						setParking(isLine);
					elseif VehicleInspector.global.iconDisplay.setOrder[order] == "setGps" then
						setGps(isLine);		
					elseif VehicleInspector.global.iconDisplay.setOrder[order] == "setJobType" then
						setJobTypeTxt(isLine);
					elseif VehicleInspector.global.iconDisplay.setOrder[order] == "setRemainingString" then
						setRemainingString(isLine);
					end;
				end;
				setWarnings(isLine, lineBlinking);
				--renderText(iconLeftPosX, nextPosY, txtSize, tostring(isLine.warnings.fuelPercent));				
				if width < iconLeftPosX-startPosX then width = iconLeftPosX-startPosX;end;
				--if line ~= #VehicleInspector.ownOutput then nextPosY = nextPosY-iconHeight-txtLineDistance;end;
				--if nextPosY-iconHeight-txtLineDistance < endPosY then isToLarge=true;break;end;
			end;		
		end;
	end;
	-------------------------
	-------------------------
	local lastFarmId = 0;
	--if startPosY ~= nextPosY then nextPosY = nextPosY-iconHeight-txtLineDistance;startPosY=nextPosY;isFirstLine=false;end;
	if not isToLarge then
		if isFirstLine or startPosY ~= nextPosY then nextPosY = nextPosY-iconHeight-txtLineDistance;startPosY=nextPosY;isFirstLine=false;end;
		for line=1, #VehicleInspector.contractorOutput do
			local isLine = VehicleInspector.contractorOutput[line];
			if isLine ~= nil and isLine.view then
				viewLines = viewLines+1;
				if width < iconLeftPosX-startPosX then width = iconLeftPosX-startPosX;end;
				if nextPosY-iconHeight-txtLineDistance < endPosY then isToLarge=true;break;end;
				if lastFarmId == 0 or lastFarmId ~= isLine.farmId then 
					lastFarmId = isLine.farmId;					
					setFarmName("---"..isLine.farmName.."---");
					if nextPosY-iconHeight-txtLineDistance < endPosY then isToLarge=true;break;end;
					nextPosY = nextPosY-iconHeight-txtLineDistance;
					isFirstLine = false;
				end;
				if isFirstLine then nextPosY = nextPosY-iconHeight-txtLineDistance;end;
				local lineBlinking = getJobEndBlinking(isLine);
				isFirstLine = true;
				iconLeftPosX = startPosX;			
				for order=1, #VehicleInspector.global.iconDisplay.setOrder do
					if VehicleInspector.global.iconDisplay.setOrder[order] == "setSpeed" then
						setSpeed(isLine);			
					elseif VehicleInspector.global.iconDisplay.setOrder[order] == "setField" then
						setField(isLine);
					elseif VehicleInspector.global.iconDisplay.setOrder[order] == "setVehicle" then
						for vOrder=1, #VehicleInspector.global.iconDisplay.setOrderVehicle do
							if VehicleInspector.global.iconDisplay.setOrderVehicle[vOrder] == "setVehicleIcon" then
								setVehicleIcon(isLine, line, "contractorOutput");
							elseif VehicleInspector.global.iconDisplay.setOrderVehicle[vOrder] == "setVehicleName" then
								setVehicleName(isLine, line, "contractorOutput");
							end;
						end;
					elseif VehicleInspector.global.iconDisplay.setOrder[order] == "setFillLevelInformation" then
						if isLine.fillLevelInformation ~= nil and #isLine.fillLevelInformation > 0 then 
							local attachedLimit = 0;
							for f=1, #isLine.fillLevelInformation do
								if isLine.fillLevelInformation[f] ~= nil then
									if attachedLimit >= VehicleInspector.global.attachedLimit and VehicleInspector.global.forceView ~= 2 then break;end;
									local prozentColor = 1;
									if VehicleInspector.txt.color then prozentColor = g_currentMission.hl.getProzentColor(isLine.fillLevelInformation[f].fillProzent, isLine.fillLevelInformation[f].isSeedsOrAnd);end;
									prozentColor = g_currentMission.hl.getColorProzent(prozentColor,true);
									setAttachedIcon(isLine.fillLevelInformation[f]);
									for fOrder=1, #VehicleInspector.global.iconDisplay.setOrderFillLevelInformation do
										if VehicleInspector.global.iconDisplay.setOrderFillLevelInformation[fOrder] == "setFillTypeIcon" then
											setFillTypeIcon(isLine.fillLevelInformation[f], prozentColor);
										elseif VehicleInspector.global.iconDisplay.setOrderFillLevelInformation[fOrder] == "setFillLevel" then
											setFillLevel(isLine.fillLevelInformation[f], prozentColor);
										elseif VehicleInspector.global.iconDisplay.setOrderFillLevelInformation[fOrder] == "setFillProzent" then
											setFillProzent(isLine.fillLevelInformation[f], prozentColor);
										elseif VehicleInspector.global.iconDisplay.setOrderFillLevelInformation[fOrder] == "setFillTypeName" then
											setFillTypeName(isLine.fillLevelInformation[f], prozentColor);
										end;
									end;
									attachedLimit = attachedLimit+1;
								end;
							end;					
						end;
					elseif VehicleInspector.global.iconDisplay.setOrder[order] == "setAttached" then
						setAttached(isLine);
					elseif VehicleInspector.global.iconDisplay.setOrder[order] == "setControlledName" then
						setControlledName(isLine);
					elseif VehicleInspector.global.iconDisplay.setOrder[order] == "setLeasing" then
						setLeasing(isLine);
					elseif VehicleInspector.global.iconDisplay.setOrder[order] == "setParking" then
						setParking(isLine);
					elseif VehicleInspector.global.iconDisplay.setOrder[order] == "setGps" then
						setGps(isLine);
					elseif VehicleInspector.global.iconDisplay.setOrder[order] == "setJobType" then
						setJobTypeTxt(isLine);
					elseif VehicleInspector.global.iconDisplay.setOrder[order] == "setRemainingString" then
						setRemainingString(isLine);
					end;
				end;
				setWarnings(isLine, lineBlinking);
				if width < iconLeftPosX-startPosX then width = iconLeftPosX-startPosX;end;
				--if line ~= #VehicleInspector.contractorOutput then nextPosY = nextPosY-iconHeight-txtLineDistance;end;
				--if nextPosY-iconHeight-txtLineDistance < endPosY then isToLarge=true;break;end;
			end;		
		end;
	end;
	if startPosY == nextPosY then nextPosY = nextPosY+((iconHeight+txtLineDistance));end;
	-------------------------
	height = posY-nextPosY+txtLineDistance;
	if viewLines == 0 then height = 0;end;
	VehicleInspector.global.width[VehicleInspector.global.viewModus] = width+0.002; 
	VehicleInspector.global.height[VehicleInspector.global.viewModus] = height;		
	if viewLines > 0 and not disableClickArea then viDrawIcons:clickAreas(true, {posX, posX+(width+0.002), nextPosY-txtLineDistance, nextPosY-txtLineDistance+height} );end;	
	if VehicleInspector.global.seeBackground then
		if VehicleInspector.overlays["ground"].a ~= VehicleInspector.global.backgroundT then 
			local backgroundColor = g_currentMission.hl.getColor(VehicleInspector.showColor.background, true);
			backgroundColor[4] = VehicleInspector.global.backgroundT;
			VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["ground"], backgroundColor}, "viDraw:setOpen()");
		end;
		g_currentMission.hl.setOverlay(VehicleInspector.overlays["ground"], posX, nextPosY-txtLineDistance, width+0.002, height);
	end;
	if isToLarge then VehicleInspector.global.toLarge = true;else VehicleInspector.global.toLarge = false;end;
	if isToLarge and g_currentMission.hl.runsTimer("1sec", true) then
		setTextBold(true);
		setTextColor(unpack(g_currentMission.hl.getColor("ls22", true)));
		renderText(posX+0.001, nextPosY-iconHeight, txtSize, tostring("! to large !"));
		setTextColor(1, 1, 1, 1);
		setTextBold(false);
	end;	
end;

function viDrawIcons:clickAreas(masterArea, args)		
	if masterArea then
		VehicleInspector.clickAreas.master["default"] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1
			whichArea="default";
		};
	else	
		VehicleInspector.clickAreas.slave["default"][#VehicleInspector.clickAreas.slave["default"]+1] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1
			whatClick = "default";
			whereClick = args.whereClick;
			rootNode = args.rootNode;
			line = args.line;
			tableType = args.tableType
		};
	end;
end;