viSetGetForMoh = {};
viSetGetForMoh.cmd = {};

function viSetGetForMoh.onDrawAfter(args)
	if args == nil or type(args) ~= "table" or args.overlay == nil or args.overlay.ownValue == nil then return;end;
	function setRemainingNotActiveIcon(color)
		local iconPos = VehicleInspector.moh.moSetGetOverlays.icons.byName["VehicleInspector"]["icon"]["vehicleInspectorOff"];
		local overlay = VehicleInspector.moh.moSetGetOverlays.icons["VehicleInspector"]["icon"][iconPos]; 
		g_currentMission.hl.setOverlay(overlay,args.overlay.x+(args.overlay.width/4),args.overlay.y-(args.overlay.height/4),args.overlay.width,args.overlay.height);	
		g_currentMission.hl.setBackgroundColor(overlay, g_currentMission.hl.getColor(color, true));
		overlay:render();
	end;
	function setRemainingVisibleIcon(color)
		local iconPos = VehicleInspector.moh.moSetGetOverlays.icons.byName["VehicleInspector"]["icon"]["vehicleInspectorRemainVisible"];
		local overlay = VehicleInspector.moh.moSetGetOverlays.icons["VehicleInspector"]["icon"][iconPos]; 
		g_currentMission.hl.setOverlay(overlay,args.overlay.x,args.overlay.y,args.overlay.width,args.overlay.height);		
		g_currentMission.hl.setBackgroundColor(overlay, g_currentMission.hl.getColor(color, true));
		overlay:render();
	end;
	function setRemainingTimeIcon(color)
		local iconPos = VehicleInspector.moh.moSetGetOverlays.icons.byName["VehicleInspector"]["icon"]["vehicleInspectorRemainTime"];
		local overlay = VehicleInspector.moh.moSetGetOverlays.icons["VehicleInspector"]["icon"][iconPos]; 
		g_currentMission.hl.setOverlay(overlay,args.overlay.x,args.overlay.y,args.overlay.width,args.overlay.height);		
		g_currentMission.hl.setBackgroundColor(overlay, g_currentMission.hl.getColor(color, true));
		overlay:render();
	end;
	function setRemainingWaypointsIcon(color)
		local iconPos = VehicleInspector.moh.moSetGetOverlays.icons.byName["VehicleInspector"]["icon"]["vehicleInspectorRemainWaypoints"];
		local overlay = VehicleInspector.moh.moSetGetOverlays.icons["VehicleInspector"]["icon"][iconPos]; 
		g_currentMission.hl.setOverlay(overlay,args.overlay.x,args.overlay.y,args.overlay.width,args.overlay.height);
		g_currentMission.hl.setBackgroundColor(overlay, g_currentMission.hl.getColor(color, true));
		overlay:render();
	end;
	if args.overlay.ownValue == "onOff" then
		if not VehicleInspector.global.isOn then		
			--Attention(do not forget ), load 1x icon is this okay,load more icons, set better icon over name (moSetGetOverlays.icons.byName[modName][groupName][iconName] = return icon table pos) --iconName at ...xml
			--local overlay = VehicleInspector.moh.moSetGetOverlays.icons["VehicleInspector"]["icon"][1];
			local iconPos = VehicleInspector.moh.moSetGetOverlays.icons.byName["VehicleInspector"]["icon"]["vehicleInspectorOff"];
			local overlay = VehicleInspector.moh.moSetGetOverlays.icons["VehicleInspector"]["icon"][iconPos]; 
			g_currentMission.hl.setOverlay(overlay,args.overlay.x,args.overlay.y,args.overlay.width,args.overlay.height);		
			overlay:render();		
		end;
	elseif args.overlay.ownValue == "setState" then
		local iconPos = VehicleInspector.moh.moSetGetOverlays.icons.byName["VehicleInspector"]["icon"]["vehicleInspectorSetState"];
		local overlay = VehicleInspector.moh.moSetGetOverlays.icons["VehicleInspector"]["icon"][iconPos]; 
		local color = "green";		
		if VehicleInspector.global.joinVehicles == 1 then color = "red" end;
		g_currentMission.hl.setOverlay(overlay,args.overlay.x,args.overlay.y,args.overlay.width,args.overlay.height);		
		g_currentMission.hl.setBackgroundColor(overlay, g_currentMission.hl.getColor(color, true));		
		overlay:render();
	
	--0=all Off, 1=Time On/Waypoints Off, 2=Time Off/Waypoints On, 3=Time/Waypoints On --mohVisible for MultiOverlayHud Cmd and Color Icons
	elseif args.overlay.ownValue == "viewAdRemaining" then
		if VehicleInspector.otherMods.autoDrive == nil or not VehicleInspector.global.isOn then
			--setRemainingNotActiveIcon("black");
		else 
			local viCmdFound = false;
			if VehicleInspector.moh.moSetGetOverlays.pda[args.whichPda].apps[args.appLine][args.appPos].cmd ~= nil and #VehicleInspector.moh.moSetGetOverlays.pda[args.whichPda].apps[args.appLine][args.appPos].cmd > 0 then
				for cmd=1, #VehicleInspector.moh.moSetGetOverlays.pda[args.whichPda].apps[args.appLine][args.appPos].cmd do
					local appCmd = VehicleInspector.moh.moSetGetOverlays.pda[args.whichPda].apps[args.appLine][args.appPos].cmd[cmd];
					if appCmd.regName == "VehicleInspector_cmd_action_viAdRemainingState_" then viCmdFound = true;break;end;				 
				end;
			end;
			if viCmdFound then
				local iconPos = VehicleInspector.moh.moSetGetOverlays.icons.byName["VehicleInspector"]["icon"]["vehicleInspectorLogoAD"];
				local overlay = VehicleInspector.moh.moSetGetOverlays.icons["VehicleInspector"]["icon"][iconPos];
				g_currentMission.hl.setOverlay(overlay,args.overlay.x,args.overlay.y,args.overlay.width,args.overlay.height);
				overlay:render();			
				if VehicleInspector.seeTxt.adRemaining.state == 0 then return;end;
				if VehicleInspector.seeTxt.adRemaining.state ~= 0 then
					local color = "red";
					local remainTime = VehicleInspector.seeTxt.adRemaining.state == 1 or VehicleInspector.seeTxt.adRemaining.state == 3;
					local remainWaypoints = VehicleInspector.seeTxt.adRemaining.state == 2 or VehicleInspector.seeTxt.adRemaining.state == 3;
					if remainTime then
						color = "darkGreen";
					elseif not remainTime and remainWaypoints then
						color = "darkGray";
					else
						color = "red";
					end;					
					setRemainingTimeIcon(color)					
					if remainWaypoints then
						color = "darkGreen";
					elseif remainTime and not remainWaypoints then
						color = "darkGray";
					else
						color = "red";
					end;
					setRemainingWaypointsIcon(color);					
				end;
				if VehicleInspector.seeTxt.adRemaining.state ~= 0 and not VehicleInspector.seeTxt.adRemaining.mohVisible then
					setRemainingNotActiveIcon("red");
				end;			
			end;
		end;
	elseif args.overlay.ownValue == "viewCpRemaining" then		
		if VehicleInspector.otherMods.courseplay == nil or not VehicleInspector.global.isOn then 
			--setRemainingNotActiveIcon("black");
		else
			local viCmdFound = false;
			if VehicleInspector.moh.moSetGetOverlays.pda[args.whichPda].apps[args.appLine][args.appPos].cmd ~= nil and #VehicleInspector.moh.moSetGetOverlays.pda[args.whichPda].apps[args.appLine][args.appPos].cmd > 0 then
				for cmd=1, #VehicleInspector.moh.moSetGetOverlays.pda[args.whichPda].apps[args.appLine][args.appPos].cmd do
					local appCmd = VehicleInspector.moh.moSetGetOverlays.pda[args.whichPda].apps[args.appLine][args.appPos].cmd[cmd];
					if appCmd.regName == "VehicleInspector_cmd_action_viCpRemainingState_" then viCmdFound = true;break;end;				 
				end;
			end;
			if viCmdFound then
				local iconPos = VehicleInspector.moh.moSetGetOverlays.icons.byName["VehicleInspector"]["icon"]["vehicleInspectorLogoCP"];
				local overlay = VehicleInspector.moh.moSetGetOverlays.icons["VehicleInspector"]["icon"][iconPos];	
				g_currentMission.hl.setOverlay(overlay,args.overlay.x,args.overlay.y,args.overlay.width,args.overlay.height);
				overlay:render();
				if VehicleInspector.seeTxt.cpRemaining.state == 0 then return;end;
				if VehicleInspector.seeTxt.cpRemaining.state ~= 0 then
					local color = "red";
					local remainTime = VehicleInspector.seeTxt.cpRemaining.state == 1 or VehicleInspector.seeTxt.cpRemaining.state == 3;
					local remainWaypoints = VehicleInspector.seeTxt.cpRemaining.state == 2 or VehicleInspector.seeTxt.cpRemaining.state == 3;					
					if remainTime then
						color = "darkGreen";
					elseif not remainTime and remainWaypoints then
						color = "darkGray";
					else
						color = "red";
					end;					
					setRemainingTimeIcon(color)					
					if remainWaypoints then
						color = "darkGreen";
					elseif remainTime and not remainWaypoints then
						color = "darkGray";
					else
						color = "red";
					end;
					setRemainingWaypointsIcon(color);					
				end;
				if VehicleInspector.seeTxt.cpRemaining.state ~= 0 and not VehicleInspector.seeTxt.cpRemaining.mohVisible then
					setRemainingNotActiveIcon("red");
				end;
			end;
		end;
	elseif args.overlay.ownValue == "viewAdCpRemaining" then		
		if (VehicleInspector.otherMods.courseplay == nil and VehicleInspector.otherMods.autoDrive == nil) or not VehicleInspector.global.isOn then
			--setRemainingNotActiveIcon();
		else
			local viAdCmdFound = false;
			local viCpCmdFound = false;
			if VehicleInspector.moh.moSetGetOverlays.pda[args.whichPda].apps[args.appLine][args.appPos].cmd ~= nil and #VehicleInspector.moh.moSetGetOverlays.pda[args.whichPda].apps[args.appLine][args.appPos].cmd > 0 then
				for cmd=1, #VehicleInspector.moh.moSetGetOverlays.pda[args.whichPda].apps[args.appLine][args.appPos].cmd do
					local appCmd = VehicleInspector.moh.moSetGetOverlays.pda[args.whichPda].apps[args.appLine][args.appPos].cmd[cmd];
					if appCmd.regName == "VehicleInspector_cmd_action_viCpRemainingState_" then viCpCmdFound = true;end;
					if appCmd.regName == "VehicleInspector_cmd_action_viAdRemainingState_" then viAdCmdFound = true;end;
					if viAdCmdFound and viCpCmdFound then break;end;
				end;				
			end;
			if viCpCmdFound and VehicleInspector.otherMods.courseplay == nil then viCpCmdFound = false;end;
			if viAdCmdFound and VehicleInspector.otherMods.autoDrive == nil then viAdCmdFound = false;end;
			if not viAdCmdFound and not viCpCmdFound then return;end;
			local adRemainTime = VehicleInspector.seeTxt.adRemaining.state == 1 or VehicleInspector.seeTxt.adRemaining.state == 3;
			local cpRemainTime = VehicleInspector.seeTxt.cpRemaining.state == 1 or VehicleInspector.seeTxt.cpRemaining.state == 3;
			local adRemainWaypoints = VehicleInspector.seeTxt.adRemaining.state == 2 or VehicleInspector.seeTxt.adRemaining.state == 3;
			local cpRemainWaypoints = VehicleInspector.seeTxt.cpRemaining.state == 2 or VehicleInspector.seeTxt.cpRemaining.state == 3;
			
			local remainingVisibleIconColor = "darkGray";
			local remainingTimeIconColor = "darkGray";
			local remainingWaypointsIconColor = "darkGray";			
			function setRemainingTimeIconColor()
				if viAdCmdFound and viCpCmdFound then
					if VehicleInspector.seeTxt.cpRemaining.state == 0 and VehicleInspector.seeTxt.adRemaining.state == 0 then return;end;
					if adRemainTime and cpRemainTime then 
						remainingTimeIconColor = "darkGreen";
					elseif (adRemainTime and not cpRemainTime) or (not adRemainTime and cpRemainTime) then
						remainingTimeIconColor = "yellowGreen";
					elseif not adRemainTime and not cpRemainTime then
						remainingTimeIconColor = "red";
					end;
				end;
				if viAdCmdFound and not viCpCmdFound then
					if VehicleInspector.seeTxt.adRemaining.state == 0 then return;end;
					if adRemainTime then 
						remainingTimeIconColor = "darkGreen";				
					elseif not adRemainTime then
						remainingTimeIconColor = "red";
					end;			
				end;
				if not viAdCmdFound and viCpCmdFound then
					if VehicleInspector.seeTxt.cpRemaining.state == 0 then return;end;
					if cpRemainTime then 
						remainingTimeIconColor = "darkGreen";				
					elseif not cpRemainTime then
						remainingTimeIconColor = "red";
					end;			
				end;
				setRemainingTimeIcon(remainingTimeIconColor);
			end;
			function setRemainingWaypointsIconColor()
				if viAdCmdFound and viCpCmdFound then
					if VehicleInspector.seeTxt.cpRemaining.state == 0 and VehicleInspector.seeTxt.adRemaining.state == 0 then return;end;
					if adRemainWaypoints and cpRemainWaypoints then 
						remainingWaypointsIconColor = "darkGreen";
					elseif (adRemainWaypoints and not cpRemainWaypoints) or (not adRemainWaypoints and cpRemainWaypoints) then
						remainingWaypointsIconColor = "yellowGreen";
					elseif not adRemainWaypoints and not cpRemainWaypoints then
						remainingWaypointsIconColor = "red";
					end;
				end;
				if viAdCmdFound and not viCpCmdFound then
					if VehicleInspector.seeTxt.adRemaining.state == 0 then return;end;
					if adRemainWaypoints then 
						remainingWaypointsIconColor = "darkGreen";				
					elseif not adRemainWaypoints then
						remainingWaypointsIconColor = "red";
					end;			
				end;
				if not viAdCmdFound and viCpCmdFound then
					if VehicleInspector.seeTxt.cpRemaining.state == 0 then return;end;
					if cpRemainWaypoints then 
						remainingWaypointsIconColor = "darkGreen";				
					elseif not cpRemainWaypoints then
						remainingWaypointsIconColor = "red";
					end;			
				end;
				setRemainingWaypointsIcon(remainingWaypointsIconColor);
			end;
			function setRemainingVisibleIconColor()
				if viAdCmdFound and viCpCmdFound then
					if VehicleInspector.seeTxt.cpRemaining.state == 0 and VehicleInspector.seeTxt.adRemaining.state == 0 then return;end;
					if VehicleInspector.seeTxt.adRemaining.mohVisible and VehicleInspector.seeTxt.cpRemaining.mohVisible then
						remainingVisibleIconColor = "darkGreen";
					elseif (VehicleInspector.seeTxt.adRemaining.mohVisible and not VehicleInspector.seeTxt.cpRemaining.mohVisible) or (not VehicleInspector.seeTxt.adRemaining.mohVisible and VehicleInspector.seeTxt.cpRemaining.mohVisible) then
						remainingVisibleIconColor = "yellowGreen";
					else
						remainingVisibleIconColor = "red";
					end;
				end;
				if viAdCmdFound and not viCpCmdFound then
					if VehicleInspector.seeTxt.adRemaining.state == 0 then return;end;
					if VehicleInspector.seeTxt.adRemaining.mohVisible then
						remainingVisibleIconColor = "darkGreen";
					else
						remainingVisibleIconColor = "red";
					end;
				end;
				if not viAdCmdFound and viCpCmdFound then
					if VehicleInspector.seeTxt.cpRemaining.state == 0 then return;end;
					if VehicleInspector.seeTxt.cpRemaining.mohVisible then
						remainingVisibleIconColor = "darkGreen";
					else
						remainingVisibleIconColor = "red";
					end;
				end;
				setRemainingVisibleIcon(remainingVisibleIconColor);
			end;
			setRemainingTimeIconColor();
			setRemainingWaypointsIconColor();
			setRemainingVisibleIconColor();			
		end;	
	end;
end;

function viSetGetForMoh.onDrawOpen(args)
	
end;

function viSetGetForMoh:loadPdaIcons()
	g_currentMission.multiOverlayV4.overlayFunction.savePreviewIcons( {xmlTagName="viIcons.vehiclePda", modDir=VehicleInspector.modDir, iconFile="scripte/mohFeatures/vehicles1.dds", xmlFile="scripte/mohFeatures/viIcons.xml", modName="VehicleInspector", groupName="vehicle", fileFormat="m512x512", previewIcons=true} );
	g_currentMission.multiOverlayV4.overlayFunction.loadIcons( {xmlTagName="viIcons.vehicleInspectorIcons", modDir=VehicleInspector.modDir, iconFile="scripte/mohFeatures/vehicles1.dds", xmlFile="scripte/mohFeatures/viIcons.xml", modName="VehicleInspector", groupName="icon", fileFormat="m512x512", previewIcons=false} );
	g_currentMission.multiOverlayV4.pdaCallbacks.vehicleInspector = {};
	g_currentMission.multiOverlayV4.pdaCallbacks.vehicleInspector.onDrawAfter = viSetGetForMoh.onDrawAfter;	
	g_currentMission.multiOverlayV4.pdaCallbacks.vehicleInspector.onDrawOpen = viSetGetForMoh.onDrawOpen;
end;

function viSetGetForMoh:loadCmds()
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "action_viOnOff_";
			groupName = "OnOff-OtherMods";			
			displayName = "VehicleInspector On/Off";
			infoTxt = "Click Left for VehicleInspector On/Off (Tip Icon -MultiOvlerayV4 and Group otherMods)";
			mouseClickAccepts = {true,false,false};
			ownTable = {};
			typ = {"action_"};			
			actionCallback = viSetGetForMoh.cmd.onOff;		
		}
	);
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "action_viJoinAllVehicle_";
			groupName = "VehicleInspector-Join";			
			displayName = "Join forward/back Vehicle(all)";
			infoTxt = "Click Left Join Forward/Click Right Join Back (Tip Icon -VehicleInspector and Group vehicle)";
			mouseClickAccepts = {true,false,true};
			ownTable = {joinType="all"};
			typ = {"action_"};			
			actionCallback = viSetGetForMoh.cmd.joinVehicle;		
		}
	);
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "action_viJoinTractorVehicle_";
			groupName = "VehicleInspector-Join";			
			displayName = "Join forward/back Vehicle(tractor)";
			infoTxt = "Tip Icon -VehicleInspector and Group vehicle";
			mouseClickAccepts = {true,false,true};
			ownTable = {joinType="tractor"};
			typ = {"action_"};			
			actionCallback = viSetGetForMoh.cmd.joinVehicle;		
		}
	);
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "action_viJoinHarvesterVehicle_";
			groupName = "VehicleInspector-Join";			
			displayName = "Join forward/back Vehicle(harvester)";
			infoTxt = "Tip Icon -VehicleInspector and Group vehicle";
			mouseClickAccepts = {true,false,true};
			ownTable = {joinType="harvester"};
			typ = {"action_"};			
			actionCallback = viSetGetForMoh.cmd.joinVehicle;		
		}
	);
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "action_viJoinTruckVehicle_";
			groupName = "VehicleInspector-Join";			
			displayName = "Join forward/back Vehicle(truck)";
			infoTxt = "Tip Icon -VehicleInspector and Group vehicle";
			mouseClickAccepts = {true,false,true};
			ownTable = {joinType="truck"};
			typ = {"action_"};			
			actionCallback = viSetGetForMoh.cmd.joinVehicle;		
		}
	);
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "action_viJoinTeleLoaderVehicle_";
			groupName = "VehicleInspector-Join";			
			displayName = "Join forward/back Vehicle(teleloader)";
			infoTxt = "Tip Icon -VehicleInspector and Group vehicle";
			mouseClickAccepts = {true,false,true};
			ownTable = {joinType="teleloader"};
			typ = {"action_"};			
			actionCallback = viSetGetForMoh.cmd.joinVehicle;		
		}
	);
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "action_viJoinCarVehicle_";
			groupName = "VehicleInspector-Join";			
			displayName = "Join forward/back Vehicle(car)";
			infoTxt = "Tip Icon -VehicleInspector and Group vehicle";
			mouseClickAccepts = {true,false,true};
			ownTable = {joinType="car"};
			typ = {"action_"};			
			actionCallback = viSetGetForMoh.cmd.joinVehicle;		
		}
	);
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "action_viJoinOtherVehicle_";
			groupName = "VehicleInspector-Join";			
			displayName = "Join forward/back Vehicle(other)";
			infoTxt = "Tip Icon -VehicleInspector and Group vehicle";
			mouseClickAccepts = {true,false,true};
			ownTable = {joinType="other"};
			typ = {"action_"};			
			actionCallback = viSetGetForMoh.cmd.joinVehicle;		
		}
	);
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "action_viJoinTractorWithAttachedVehicle_";
			groupName = "VehicleInspector-Join";			
			displayName = "Join forward/back Vehicle with Attached(tractor)";
			infoTxt = "Tip Icon -VehicleInspector and Group vehicle";
			mouseClickAccepts = {true,false,true};
			ownTable = {joinType="tractor", attachedType="all"};
			typ = {"action_"};			
			actionCallback = viSetGetForMoh.cmd.joinVehicle;		
		}
	);
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "action_viJoinTractorWithoutAttachedVehicle_";
			groupName = "VehicleInspector-Join";			
			displayName = "Join forward/back Vehicle without Attached(tractor)";
			infoTxt = "Tip Icon -VehicleInspector and Group vehicle";
			mouseClickAccepts = {true,false,true};
			ownTable = {joinType="tractor", attachedType="none"};
			typ = {"action_"};			
			actionCallback = viSetGetForMoh.cmd.joinVehicle;		
		}
	);
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "action_viJoinAllParkingVehicle_";
			groupName = "VehicleInspector-Join";			
			displayName = "Join forward/back Vehicle is Parking(all)";
			infoTxt = "needs Parking Mod  (Tip Icon -VehicleInspector and Group vehicle)";
			mouseClickAccepts = {true,false,true};
			ownTable = {joinType="all", attachedType="parking"};
			typ = {"action_"};			
			actionCallback = viSetGetForMoh.cmd.joinVehicle;		
		}
	);
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "action_viJoinContractorState_";
			groupName = "VehicleInspector-Join";			
			displayName = "Set Vehicle Join State (Own/All/Contracting)";
			infoTxt = "Join Own Vehicles/All/Contractor Vehicles  (Tip Icon -VehicleInspector and Group vehicle)";
			mouseClickAccepts = {true,false,false};
			ownTable = {};
			typ = {"action_"};			
			actionCallback = viSetGetForMoh.cmd.setJoinVehicleState;		
		}
	);
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "action_viAdRemainingState_";
			groupName = "VehicleInspector-Other";			
			displayName = "Vehicle AD Remaining State On/Off";
			infoTxt = "View Vehicles AD Remaining Time/Waypoints  (Tip Icon -VehicleInspector and Group vehicle)";
			mouseClickAccepts = {true,true,true};
			ownTable = {};
			typ = {"action_"};			
			actionCallback = viSetGetForMoh.cmd.setVehicleAdRemainingMohState;		
		}
	);
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "action_viCpRemainingState_";
			groupName = "VehicleInspector-Other";			
			displayName = "Vehicle CP Remaining State On/Off";
			infoTxt = "View Vehicles CP Remaining Time/Waypoints  (Tip Icon -VehicleInspector and Group vehicle)";
			mouseClickAccepts = {true,true,true};
			ownTable = {};
			typ = {"action_"};			
			actionCallback = viSetGetForMoh.cmd.setVehicleCpRemainingMohState;		
		}
	);
	local isGenerate, errorTxt = g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "output_viMohSlotOutput_";
			groupName = "VehicleInspector";			
			displayName = "VehicleInspector";
			infoTxt = "VehicleInspector Default Output Display over MultiOverlayV4 Slot";
			mouseClickAccepts = {true,false,true};
			ownTable = {};
			freeCmd = false;
			typ = {"output_"};			
			actionCallback = viVehicleMohOutput.giveOutputTable;		
		}
	);	
end;

function viSetGetForMoh.cmd.viMohSlotDeleted(args)
	if args ~= nil and args.whichSlot ~= nil and args.whichSlot == "viVehicleSlot_" then
		VehicleInspector.global.mohSlot.isGenerate = false;
		VehicleInspector.moh.moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
		VehicleInspector.moh.moSetGetOverlays.infoHelpBox.info.titel = "VehicleInspector Info";
		VehicleInspector.moh.moSetGetOverlays.infoHelpBox.info.txt = "Schade das dir dieses VI Features über den MultiOverlayV4 Hud nicht gefällt";	
	end;
	return;
end;

function viSetGetForMoh.cmd.viMohSlotSaved(args)
	if args ~= nil and args.whichSlot ~= nil and args.whichSlot == "viVehicleSlot_" then
		VehicleInspector:saveSettings();
	end;
	return;
end;

function viSetGetForMoh.cmd.viMohSlotIsOpen(args)
	if args ~= nil and args.whichSlot ~= nil and args.whichSlot == "viVehicleSlot_" then
	end;
	return;
end;

function viSetGetForMoh.cmd.onOff(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.mouseClick == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		VehicleInspector.global.isOn = not VehicleInspector.global.isOn;
	end;
	return;
end;

function viSetGetForMoh.cmd.setVehicleAdRemainingMohState(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.mouseClick == nil then return;end;
	if (args.mouseClick == "MOUSE_BUTTON_LEFT" or args.mouseClick == "MOUSE_BUTTON_MIDDLE" or args.mouseClick == "MOUSE_BUTTON_RIGHT") and args.isDown then
		if not VehicleInspector.seeTxt.adRemaining.mohVisible then
			VehicleInspector.seeTxt.adRemaining.mohVisible = true;
			g_currentMission:showBlinkingWarning("Remaining Time/Waypoints Visible", 3000);
		else
			VehicleInspector.seeTxt.adRemaining.mohVisible = false;
			g_currentMission:showBlinkingWarning("Remaining Time/Waypoints Not Visible", 3000);
		end;	
	end;
end;

function viSetGetForMoh.cmd.setVehicleCpRemainingMohState(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.mouseClick == nil then return;end;
	if (args.mouseClick == "MOUSE_BUTTON_LEFT" or args.mouseClick == "MOUSE_BUTTON_MIDDLE" or args.mouseClick == "MOUSE_BUTTON_RIGHT") and args.isDown then
		if not VehicleInspector.seeTxt.cpRemaining.mohVisible then 
			VehicleInspector.seeTxt.cpRemaining.mohVisible = true;
			g_currentMission:showBlinkingWarning("Remaining Time/Waypoints Visible", 3000);
		else
			VehicleInspector.seeTxt.cpRemaining.mohVisible = false;
			g_currentMission:showBlinkingWarning("Remaining Time/Waypoints Not Visible", 3000);
		end;
	end;
end;

function viSetGetForMoh.cmd.setJoinVehicleState(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.mouseClick == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if VehicleInspector.global.joinVehicles+1 > 2 then VehicleInspector.global.joinVehicles = 1;else VehicleInspector.global.joinVehicles = VehicleInspector.global.joinVehicles+1;end;
	end;
	return;
end;

function viSetGetForMoh.cmd.joinVehicle(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.ownTable == nil or args.mouseClick == nil then return;end;
	if (args.mouseClick == "MOUSE_BUTTON_LEFT" or args.mouseClick == "MOUSE_BUTTON_RIGHT") and args.isDown then
		local joinType = args.cmdTable.ownTable.joinType;
		local trailer = args.cmdTable.ownTable.attachedType ~= nil;		
		local attachedType = args.cmdTable.ownTable.attachedType
		if args.mouseClick == "MOUSE_BUTTON_LEFT" then 
			viSetGetForMoh:joinVehicle(1, joinType, trailer, attachedType);			
		elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" then 
			viSetGetForMoh:joinVehicle(-1, joinType, trailer, attachedType);
		end;
	end;
	return;
end;

function viSetGetForMoh:isParkingVehicle(vehicle) --parkingMod
	if vehicle.spec_parkvehicle ~= nil then
		local spec = vehicle.spec_parkvehicle;
		if spec.state[spec.uniqueUserId] then return true;end;
		return false;
	end;
	return false;
end;

function viSetGetForMoh:getAttachedType(vehicle, attachedType, attachedNr)	
	local attached = 0;	
	if attachedNr == 0 and vehicle.getAttachedImplements == nil and (attachedType == "none" or attachedType == "all") then return -1;end;
	if vehicle.getAttachedImplements ~= nil then 
		local attachTable = vehicle:getAttachedImplements(vehicle);
		if attachTable ~= nil then		
			for _,attach in pairs(attachTable) do		
				if attach.object ~= nil and attach.object.typeName ~= nil then
					local typeName = Utils.getNoNil(attach.object.typeName, "Unknown"):lower();
					if not string.find(typeName, "implement") then
						attached = attached+1;
						if attachedType == "all" or attachedType == "none" then break;end;											
						if attach.object.viCategoryName ~= nil and attach.object.viCategoryName ~= attachedType then attached = attached-1;end;
					end;					
					local tempAttached = viSetGetForMoh:getAttachedType(attach.object, attachedType, attachedNr+1);
					attached = attached+tempAttached;					
				end;
			end;
		end;
	end;
	return attached;
end;

function viSetGetForMoh:joinVehicle(delta, joinType, trailer, attachedType)
	local playerFarmId = g_currentMission.player.farmId;
	local joinContractorVehicle = VehicleInspector.global.joinVehicles == 2 or not g_currentMission.missionDynamicInfo.isMultiplayer;
	local isParkingVehicle = false;
	function isVehicleAndTrailerType(vehicle)
		if vehicle.viCategoryName == "nosupport" then return false;end;
		isParkingVehicle = viSetGetForMoh:isParkingVehicle(vehicle)
		if joinType == "all" and trailer and attachedType == "parking" then return isParkingVehicle;end;
		if joinType == "all" then return true;end;
		if joinType == vehicle.viCategoryName then 
			if not trailer then return true;end;
			local attached = viSetGetForMoh:getAttachedType(vehicle, attachedType, 0);
			if attached == -1 then return false;end;
			if attached <= 0 and attachedType == "none" then return true;end;
			if attached > 0 and attachedType == "none" then return false;end;
			return attached > 0;
		end;			
		return false;
	end;	
		
	if not g_currentMission.isToggleVehicleAllowed then
		return;
	end;
	local numVehicles = #g_currentMission.enterables;
	if numVehicles > 0 then
		local index = 1;
		local oldIndex = 1;
		if not g_currentMission.controlPlayer and g_currentMission.controlledVehicle ~= nil then
			for i = 1, numVehicles do
				if g_currentMission.controlledVehicle == g_currentMission.enterables[i] then
					oldIndex = i;
					index = i + delta;
					if numVehicles < index then
						index = 1;
					end;
					if index < 1 then
						index = numVehicles;
					end;
					break;
				end;
			end;
		elseif delta < 0 then
			index = numVehicles;
		end;
		local found = false;
		repeat
			local enterable = g_currentMission.enterables[index];			
			local isContractorVehicle = viSetGet:getFarmContractor(playerFarmId, enterable.ownerFarmId);
			local canJoinContratorVehicle = (isContractorVehicle and joinContractorVehicle) or (not isContractorVehicle and VehicleInspector.global.joinVehicles == 1);
			local canTabbable = enterable:getIsTabbable();
			local canJoinType = isVehicleAndTrailerType(enterable);
			if not canTabbable and trailer and attachedType == "parking" and isParkingVehicle then canTabbable = true;end;
			if canJoinType and canTabbable and enterable:getIsEnterable() and canJoinContratorVehicle then
				found = true;
			else
				index = index + delta;
				if numVehicles < index then
					index = 1;
				end;
				if index < 1 then
					index = numVehicles;
				end;
			end;
		until found or index == oldIndex;
		if found then
			g_currentMission:requestToEnterVehicle(g_currentMission.enterables[index]);
		end;
	end;	
end;

function viSetGetForMoh:generateVehicleInspectorPda()
	if not VehicleInspector.global.foundMoh or VehicleInspector.moh == nil then return;end;
	local pda = g_currentMission.multiOverlayV4.pdaFunction.getPdaTable("viVehiclePda_");
	if pda ~= nil then g_currentMission:showBlinkingWarning("VehicleInspector PDA already exists", 3000);return;end;
	local isGenerate = g_currentMission.multiOverlayV4.pdaFunction.generatePda("viVehiclePda_", "VehicleInspector Pda");
	if not isGenerate then g_currentMission:showBlinkingWarning("Generate VehicleInspector PDA Error/nGenerate manual", 3000);return;end;
	
	local int = 1;	
	VehicleInspector.moh.moSetGetPda:generateApp( {whatClick="viVehiclePda_", appValue={1,int}} );
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].apps[1][int].cmd[1] = {regName="VehicleInspector_cmd_action_viOnOff_",displayName="VehicleInspector On/Off", mouseClick={true,false,false}};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].selectApp = {1,int};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openMod = "VehicleInspector";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openGroup = "vehicle";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.selectIcon = 17;
	VehicleInspector.moh.moGeneralSettings.appIconSettingMenue.name = "viVehiclePda_";
	local isPreviewIconLoad = false;
	if VehicleInspector.moh.moSetGetOverlays.previewIcons["MultiOverlayV4"] == nil then VehicleInspector.moh.moSetGetOverlays:loadPreviewIcons();isPreviewIconLoad = true;end;
	VehicleInspector.moh.moHlGuiAppIconSetting:addIcon( {editTable=VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"]} );
	int = int+1;
	
	VehicleInspector.moh.moSetGetPda:generateApp( {whatClick="viVehiclePda_", appValue={1,int}} );
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].apps[1][int].cmd[1] = {regName="VehicleInspector_cmd_action_viJoinAllVehicle_",displayName="Join forward/back Vehicle(all)", mouseClick={true,false,true}};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].selectApp = {1,int};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openMod = "VehicleInspector";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openGroup = "vehicle";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.selectIcon = 1;
	VehicleInspector.moh.moHlGuiAppIconSetting:addIcon( {editTable=VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"]} );
	int = int+1;
	
	VehicleInspector.moh.moSetGetPda:generateApp( {whatClick="viVehiclePda_", appValue={1,int}} );
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].apps[1][int].cmd[1] = {regName="VehicleInspector_cmd_action_viJoinTractorVehicle_",displayName="Join forward/back Vehicle(tractor)", mouseClick={true,false,true}};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].selectApp = {1,int};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openMod = "VehicleInspector";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openGroup = "vehicle";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.selectIcon = 2;
	VehicleInspector.moh.moHlGuiAppIconSetting:addIcon( {editTable=VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"]} );
	int = int+1;
	
	VehicleInspector.moh.moSetGetPda:generateApp( {whatClick="viVehiclePda_", appValue={1,int}} );
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].apps[1][int].cmd[1] = {regName="VehicleInspector_cmd_action_viJoinHarvesterVehicle_",displayName="Join forward/back Vehicle(harvester)", mouseClick={true,false,true}};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].selectApp = {1,int};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openMod = "VehicleInspector";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openGroup = "vehicle";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.selectIcon = 3;
	VehicleInspector.moh.moHlGuiAppIconSetting:addIcon( {editTable=VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"]} );
	int = int+1;
	
	VehicleInspector.moh.moSetGetPda:generateApp( {whatClick="viVehiclePda_", appValue={1,int}} );
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].apps[1][int].cmd[1] = {regName="VehicleInspector_cmd_action_viJoinTruckVehicle_",displayName="Join forward/back Vehicle(truck)", mouseClick={true,false,true}};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].selectApp = {1,int};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openMod = "VehicleInspector";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openGroup = "vehicle";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.selectIcon = 4;
	VehicleInspector.moh.moHlGuiAppIconSetting:addIcon( {editTable=VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"]} );
	int = int+1;
	
	VehicleInspector.moh.moSetGetPda:generateApp( {whatClick="viVehiclePda_", appValue={1,int}} );
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].apps[1][int].cmd[1] = {regName="VehicleInspector_cmd_action_viJoinTeleLoaderVehicle_",displayName="Join forward/back Vehicle(teleloader)", mouseClick={true,false,true}};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].selectApp = {1,int};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openMod = "VehicleInspector";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openGroup = "vehicle";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.selectIcon = 5;
	VehicleInspector.moh.moHlGuiAppIconSetting:addIcon( {editTable=VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"]} );
	int = int+1;
	
	VehicleInspector.moh.moSetGetPda:generateApp( {whatClick="viVehiclePda_", appValue={1,int}} );
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].apps[1][int].cmd[1] = {regName="VehicleInspector_cmd_action_viJoinCarVehicle_",displayName="Join forward/back Vehicle(car)", mouseClick={true,false,true}};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].selectApp = {1,int};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openMod = "VehicleInspector";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openGroup = "vehicle";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.selectIcon = 6;
	VehicleInspector.moh.moHlGuiAppIconSetting:addIcon( {editTable=VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"]} );
	int = int+1;
	
	VehicleInspector.moh.moSetGetPda:generateApp( {whatClick="viVehiclePda_", appValue={1,int}} );
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].apps[1][int].cmd[1] = {regName="VehicleInspector_cmd_action_viJoinOtherVehicle_",displayName="Join forward/back Vehicle(other)", mouseClick={true,false,true}};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].selectApp = {1,int};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openMod = "VehicleInspector";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openGroup = "vehicle";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.selectIcon = 9;
	VehicleInspector.moh.moHlGuiAppIconSetting:addIcon( {editTable=VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"]} );
	int = int+1;
	
	VehicleInspector.moh.moSetGetPda:generateApp( {whatClick="viVehiclePda_", appValue={1,int}} );
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].apps[1][int].cmd[1] = {regName="VehicleInspector_cmd_action_viJoinTractorWithAttachedVehicle_",displayName="Join forward/back Vehicle with Attached(tractor)", mouseClick={true,false,true}};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].selectApp = {1,int};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openMod = "VehicleInspector";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openGroup = "vehicle";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.selectIcon = 7;
	VehicleInspector.moh.moHlGuiAppIconSetting:addIcon( {editTable=VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"]} );
	int = int+1;
	
	VehicleInspector.moh.moSetGetPda:generateApp( {whatClick="viVehiclePda_", appValue={1,int}} );
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].apps[1][int].cmd[1] = {regName="VehicleInspector_cmd_action_viJoinTractorWithoutAttachedVehicle_",displayName="Join forward/back Vehicle without Attached(tractor)", mouseClick={true,false,true}};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].selectApp = {1,int};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openMod = "VehicleInspector";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openGroup = "vehicle";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.selectIcon = 8;
	VehicleInspector.moh.moHlGuiAppIconSetting:addIcon( {editTable=VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"]} );
	int = int+1;
	
	VehicleInspector.moh.moSetGetPda:generateApp( {whatClick="viVehiclePda_", appValue={1,int}} );
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].apps[1][int].cmd[1] = {regName="VehicleInspector_cmd_action_viJoinContractorState_",displayName="Set Vehicle Join State (Own/All/Contracting)", mouseClick={true,false,false}};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].selectApp = {1,int};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openMod = "VehicleInspector";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openGroup = "vehicle";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.selectIcon = 18;
	VehicleInspector.moh.moHlGuiAppIconSetting:addIcon( {editTable=VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"]} );
	int = int+1;
	
	if isPreviewIconLoad then VehicleInspector.moh.moSetGetOverlays:deletePreviewIcons();end;
	VehicleInspector.moh.moGeneralSettings.appIconSettingMenue.name = "";
	--VehicleInspector.moh.moHlGuiAppIconSetting:setClose();

end;

function viSetGetForMoh:generateVehicleInspectorSlot(generate)
	if not VehicleInspector.global.foundMoh or VehicleInspector.moh == nil then return;end;
	local slot = g_currentMission.multiOverlayV4.slotFunction.getSlotTable("viVehicleSlot_");
	function setViSlotValues()
		VehicleInspector.global.mohSlot.isGenerate = true;		
		slot.setting.canCmdSettings = false;
		slot.setting.editSlotName = false;
		g_currentMission.multiOverlayV4.slotFunction.insertDeleteSlotCallback( {whichSlot="viVehicleSlot_", callback=viSetGetForMoh.cmd.viMohSlotDeleted} );
		g_currentMission.multiOverlayV4.slotFunction.insertSaveSlotCallback( {whichSlot="viVehicleSlot_", callback=viSetGetForMoh.cmd.viMohSlotSaved} );
		g_currentMission.multiOverlayV4.slotFunction.insertOpenSlotCallback( {whichSlot="viVehicleSlot_", callback=viSetGetForMoh.cmd.viMohSlotIsOpen} );
		if generate then 
			slot.setting.canCloseAll = false;
			slot.isOpen = true;		
			slot.cmd[1] = {regName="VehicleInspector_cmd_output_viMohSlotOutput_",displayName="VehicleInspector",mouseClick={true,true,true}};
		end;
		viSetGetForMoh:setExtraSettingLine();
	end;
	if slot ~= nil and generate then 
		g_currentMission:showBlinkingWarning("VehicleInspector SLOT already exists", 3000);
		return;
	elseif slot ~= nil and (generate == nil or not generate) then	
		setViSlotValues();
	elseif generate then
		local isGenerate, _ = g_currentMission.multiOverlayV4.slotFunction.generateSlot("viVehicleSlot_", "VehicleInspector");	
		if isGenerate then 
			slot = g_currentMission.multiOverlayV4.slotFunction.getSlotTable("viVehicleSlot_");
			setViSlotValues();
			VehicleInspector.moh.moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
			VehicleInspector.moh.moSetGetOverlays.infoHelpBox.info.titel = "VehicleInspector Info";
			VehicleInspector.moh.moSetGetOverlays.infoHelpBox.info.txt = "Danke das du dieses VI Features über den MultiOverlayV4 Hud probierst\nIm Slot hast du mehrere Settings Optionen die du nutzen kannst. (if available)";	
		end;
	end;	
end;

function viSetGetForMoh:setExtraSettingLine()	
	g_currentMission.multiOverlayV4.slotCallbacks.vehicleInspector =	{}
	g_currentMission.multiOverlayV4.slotCallbacks.vehicleInspector.settingIcons = viSetGetForMoh.clickSettingIcon;
	g_currentMission.multiOverlayV4.slotCallbacks.vehicleInspector.onOpenDrawSettingIcon = viSetGetForMoh.onOpenDrawSettingIcon;
	g_currentMission.multiOverlayV4.overlayFunction.loadIcons( {xmlTagName="viIcons.viSettingIcons", modDir=VehicleInspector.modDir, iconFile="scripte/mohFeatures/settings.dds", xmlFile="scripte/mohFeatures/viIcons.xml", modName="VehicleInspector", groupName="icon", fileFormat="m512x512", previewIcons=false, whichSlot="viVehicleSlot_"} );
	isOkay = g_currentMission.multiOverlayV4.slotFunction.generateSettingExtraLine( {modName="VehicleInspector", whichSlot="viVehicleSlot_"} );
	isOkay = g_currentMission.multiOverlayV4.slotFunction.insertSettingExtraIcon( {iconName="free", modName="VehicleInspector", txt="VI", infoTxt="VI Slot Menue Setting", callback=g_currentMission.multiOverlayV4.slotCallbacks.vehicleInspector.settingIcons, whichSlot="viVehicleSlot_"} );
	isOkay = g_currentMission.multiOverlayV4.slotFunction.insertSettingExtraIcon( {iconName="tractor", modName="VehicleInspector", ownTable={typ="tractor_"}, infoTxt="View Tractors", onOpen=g_currentMission.multiOverlayV4.slotCallbacks.vehicleInspector.onOpenDrawSettingIcon, callback=g_currentMission.multiOverlayV4.slotCallbacks.vehicleInspector.settingIcons, whichSlot="viVehicleSlot_"} );
	isOkay = g_currentMission.multiOverlayV4.slotFunction.insertSettingExtraIcon( {iconName="harvester", modName="VehicleInspector", ownTable={typ="harvester_"}, infoTxt="View Harvesters", onOpen=g_currentMission.multiOverlayV4.slotCallbacks.vehicleInspector.onOpenDrawSettingIcon, callback=g_currentMission.multiOverlayV4.slotCallbacks.vehicleInspector.settingIcons, whichSlot="viVehicleSlot_"} );
	isOkay = g_currentMission.multiOverlayV4.slotFunction.insertSettingExtraIcon( {iconName="truck", modName="VehicleInspector", ownTable={typ="truck_"}, infoTxt="View Trucks", onOpen=g_currentMission.multiOverlayV4.slotCallbacks.vehicleInspector.onOpenDrawSettingIcon, callback=g_currentMission.multiOverlayV4.slotCallbacks.vehicleInspector.settingIcons, whichSlot="viVehicleSlot_"} );
	isOkay = g_currentMission.multiOverlayV4.slotFunction.insertSettingExtraIcon( {iconName="car", modName="VehicleInspector", ownTable={typ="car_"}, infoTxt="View Cars", onOpen=g_currentMission.multiOverlayV4.slotCallbacks.vehicleInspector.onOpenDrawSettingIcon, callback=g_currentMission.multiOverlayV4.slotCallbacks.vehicleInspector.settingIcons, whichSlot="viVehicleSlot_"} );
	isOkay = g_currentMission.multiOverlayV4.slotFunction.insertSettingExtraIcon( {iconName="teleloader", modName="VehicleInspector", ownTable={typ="teleloader_"}, infoTxt="View TeleLoader", onOpen=g_currentMission.multiOverlayV4.slotCallbacks.vehicleInspector.onOpenDrawSettingIcon, callback=g_currentMission.multiOverlayV4.slotCallbacks.vehicleInspector.settingIcons, whichSlot="viVehicleSlot_"} );
	isOkay = g_currentMission.multiOverlayV4.slotFunction.insertSettingExtraIcon( {iconName="other", modName="VehicleInspector", ownTable={typ="other_"}, infoTxt="View Other(Unknown)", onOpen=g_currentMission.multiOverlayV4.slotCallbacks.vehicleInspector.onOpenDrawSettingIcon, callback=g_currentMission.multiOverlayV4.slotCallbacks.vehicleInspector.settingIcons, whichSlot="viVehicleSlot_"} );
	
end;

function viSetGetForMoh.onOpenDrawSettingIcon(args)
	if args == nil or type(args) ~= "table" or args.whichSlot == nil or args.overlay == nil or args.ownTable == nil then return;end;
	if args.ownTable.typ ~= nil and VehicleInspector.moh.moSetGetOverlays.slot[args.whichSlot] ~= nil then
		local color = "";
		local whichSlot = args.whichSlot;
		local overlay = args.overlay;
		local iconTyp = args.ownTable.typ;
		if iconTyp ~= nil and type(iconTyp) == "string" and string.len(iconTyp) > 0 then
			if VehicleInspector.global.mohSlot.viewViCategory[iconTyp] ~= nil then
				color = g_currentMission.hl.getColor(VehicleInspector.moh.moSetGetOverlays.slot[whichSlot].color.settingOn, true);
			else
				color = g_currentMission.hl.getColor(VehicleInspector.moh.moSetGetOverlays.slot[whichSlot].color.settingDefault, true);
			end;
			overlay.colorState = color;
		end;		
	end;
end;

function viSetGetForMoh.clickSettingIcon(args)	
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.button == Input.MOUSE_BUTTON_LEFT and args.isDown then
		if args.ownTable.typ ~= nil then
			local iconTyp = args.ownTable.typ;
			if iconTyp ~= nil and type(iconTyp) == "string" and string.len(iconTyp) > 0 then			
				g_currentMission:showBlinkingWarning("Features not available (next update!)", 3000);
				if VehicleInspector.global.mohSlot.viewViCategory[iconTyp] == nil then
					VehicleInspector.global.mohSlot.viewViCategory[iconTyp] = true;
				else
					VehicleInspector.global.mohSlot.viewViCategory[iconTyp] = nil;
				end;
			end;
		end;
	end;
end;