viMouseKeyEvents = {};

function viMouseKeyEvents:setKeyMouse(unicode, sym, modifier, isDownKey, posX, posY, isDown, isUp, button)	
	if not VehicleInspector.global.isOn and unicode ~= nil then viMouseKeyEvents:setKey(unicode, sym, modifier, isDownKey, true); return;end;
	if unicode ~= nil then
		if not g_currentMission.hl.dragDrop.on then
			viMouseKeyEvents:setKey(unicode, sym, modifier, isDownKey, false);			
		end;
	else
		if g_currentMission.hl.isMouseCursor then
			if not g_currentMission.hl.dragDrop.on then
				viMouseKeyEvents:setMouse(posX, posY, isDown, isUp, button);
			elseif g_currentMission.hl.dragDrop.on then
				
			end;
		end;
	end;	
end;

function viMouseKeyEvents:setMouse(posX, posY, isDown, isUp, button)
	local isPreviewArea = false;
	if VehicleInspector.global.isOn and not VehicleInspector.global.onlyMoh then
		for key,value in pairs (VehicleInspector.clickAreas.master) do
			if value ~= nil and value[1] ~= nil then
				if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(value))then	
					local whichArea = value.whichArea;
					if whichArea == "default" and VehicleInspector.clickAreas.slave[whichArea] ~= nil and #VehicleInspector.clickAreas.slave[whichArea] > 0 then
						for area=1, #VehicleInspector.clickAreas.slave[tostring(whichArea)] do
							if VehicleInspector.clickAreas.slave[tostring(whichArea)][area] ~= nil then
								if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(VehicleInspector.clickAreas.slave[tostring(whichArea)][area]))then
									local clickAreaTable = VehicleInspector.clickAreas.slave[tostring(whichArea)][area];
									if button == Input.MOUSE_BUTTON_LEFT and isDown and (tostring(clickAreaTable.whereClick) == "vehicleJoin_") then
										viSetGet:clickVehicleJoin(clickAreaTable);
										break;
									elseif (tostring(clickAreaTable.whereClick) == "vehicleJoin_") then
										if VehicleInspector.global.previewVehicleData.isOn then											
											VehicleInspector.previewVehicleData[1] = clickAreaTable;
											isPreviewArea = true;											
										end;
									end;
								end;
							end;
						end;
					elseif whichArea == "setting" and VehicleInspector.clickAreas.slave[whichArea] ~= nil and #VehicleInspector.clickAreas.slave[whichArea] > 0 then
						for area=1, #VehicleInspector.clickAreas.slave[tostring(whichArea)] do
							if VehicleInspector.clickAreas.slave[tostring(whichArea)][area] ~= nil then
								if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(VehicleInspector.clickAreas.slave[tostring(whichArea)][area]))then
									if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(VehicleInspector.clickAreas.slave[tostring(whichArea)][area]))then
										local clickAreaTable = VehicleInspector.clickAreas.slave[tostring(whichArea)][area];
										if button == Input.MOUSE_BUTTON_LEFT and isDown then
											if tostring(clickAreaTable.whereClick) == "viewHidden_" then
												VehicleInspector.global.isHidden = not VehicleInspector.global.isHidden;
												break;
											elseif tostring(clickAreaTable.whereClick) == "viewSortByCategory_" then												
												if VehicleInspector.global.sortBy+1 > VehicleInspector.vehicleTypeCategoryNumber.max then
													VehicleInspector.global.sortBy = 0;
												else													
													for sort=VehicleInspector.global.sortBy+1, VehicleInspector.vehicleTypeCategoryNumber.max do														
														if VehicleInspector.vehicleTypeCategoryName[sort] ~= nil then
															if VehicleInspector.vehicleTypeCategoryViewSettingLine[VehicleInspector.vehicleTypeCategoryName[sort]] ~= nil then
																VehicleInspector.global.sortBy = sort;
																break;
															end;
														end;														
													end;																										
												end;												
												if VehicleInspector.global.sortBy == 0 then
													g_currentMission:showBlinkingWarning("set Vehicle... NOT SORT", 2000);
												else
													g_currentMission:showBlinkingWarning("set Category *".. tostring(VehicleInspector.vehicleTypeCategoryViewSettingLine[VehicleInspector.vehicleTypeCategoryName[VehicleInspector.global.sortBy]][3]).. "* onTop", 2000);
												end;
												break;
											elseif tostring(clickAreaTable.whereClick) == "viewForce_" then
												if VehicleInspector.global.forceView+1 > 2 then VehicleInspector.global.forceView = 0;else VehicleInspector.global.forceView = VehicleInspector.global.forceView+1;end;		
												g_currentMission:showBlinkingWarning("set ViewForce *".. tostring(VehicleInspector.global.forceView).."* (default 0)", 2000);
												break;
											elseif not string.find(tostring(clickAreaTable.whereClick), "view") then
												local whereClick = string.gsub(tostring(clickAreaTable.whereClick), "_", "");
												if VehicleInspector.seeVehicle[whereClick] ~= nil then VehicleInspector.seeVehicle[whereClick] = not VehicleInspector.seeVehicle[whereClick];end;
												--old value
												if whereClick == "train" then VehicleInspector.seeVehicle.isTrain = not VehicleInspector.seeVehicle.isTrain;end;
												--old value
												break;
											end;
										elseif button == Input.MOUSE_BUTTON_RIGHT and isDown then
											if tostring(clickAreaTable.whereClick) == "viewSortByCategory_" then
												if VehicleInspector.global.sortBy-1 < 0 then													
													VehicleInspector.global.sortBy = VehicleInspector.vehicleTypeCategoryNumber.max;
												else
													local sort = VehicleInspector.global.sortBy-1;
													while sort >= 0 do
														if sort == 0 then VehicleInspector.global.sortBy = 0;break;end;
														if VehicleInspector.vehicleTypeCategoryName[sort] ~= nil then
															if VehicleInspector.vehicleTypeCategoryViewSettingLine[VehicleInspector.vehicleTypeCategoryName[sort]] ~= nil then
																VehicleInspector.global.sortBy = sort;
																break;
															end;
														end;
														sort = sort-1;
													end;																								
												end;												
												if VehicleInspector.global.sortBy == 0 then
													g_currentMission:showBlinkingWarning("set Vehicles... NOT SORT", 2000);
												else
													g_currentMission:showBlinkingWarning("set Category *".. tostring(VehicleInspector.vehicleTypeCategoryViewSettingLine[VehicleInspector.vehicleTypeCategoryName[VehicleInspector.global.sortBy]][3]).. "* onTop", 2000);
												end;
												break;
											elseif tostring(clickAreaTable.whereClick) == "viewForce_" then
												if VehicleInspector.global.forceView-1 < 0 then VehicleInspector.global.forceView = 2;else VehicleInspector.global.forceView = VehicleInspector.global.forceView-1;end;		
												g_currentMission:showBlinkingWarning("set ViewForce *".. tostring(VehicleInspector.global.forceView).."* (default 0)", 2000);
												break;
											end;
										end;
									end;
								end;
							end;	
						end;		
					end;
				end;
			end;
		end;
	end;
	if not isPreviewArea and VehicleInspector.previewVehicleData[1] ~= nil then VehicleInspector.previewVehicleData[1] = nil;end;
end;

function viMouseKeyEvents:setKey(unicode, sym, modifier, isDown, onlyMouse, cursorOnOff, action)
	--InputAction	
	if cursorOnOff then
		if g_currentMission.hl.isMouseCursor then
			VehicleInspector:get_hl("mouseOnOff", {false,false,"VehicleInspector"}, "viMouseKeyEvents:setKey");			
		else
			VehicleInspector:get_hl("mouseOnOff", {true,true,"VehicleInspector"}, "viMouseKeyEvents:setKey");			
		end;			
		return;	
	end;
	if action ~= nil and action == "VIViewContractorVehicle" then		
		VehicleInspector.seeVehicle.isOwnFarmVehicle = not VehicleInspector.seeVehicle.isOwnFarmVehicle;		
		if VehicleInspector.seeVehicle.isOwnFarmVehicle then
			g_currentMission:showBlinkingWarning("set ViewContractor Vehicle *OFF*", 2000);
		else
			g_currentMission:showBlinkingWarning("set ViewContractor Vehicle *ON*", 2000);
		end;
		return;
	end;
	if action ~= nil and action == "VIViewForce" then		
		if VehicleInspector.global.forceView+1 > 2 then VehicleInspector.global.forceView = 0;else VehicleInspector.global.forceView = VehicleInspector.global.forceView+1;end;		
		g_currentMission:showBlinkingWarning("set ViewForce *".. tostring(VehicleInspector.global.forceView).."* (default 0)", 2000);
		return;
	end;
	if VehicleInspector.hlDebugMode and Input.isKeyPressed(Input.KEY_f2)then
		g_currentMission.hl.debugPrint("VehicleInspectorMod");		
	end;
end;