hlGuiDraw = {};

function hlGuiDraw:setOpen()
	if not g_currentMission.hlGui.menue.isOpen then hlGuiDraw:setSmallViewOpen();return;end;
	if g_currentMission.hlGui.menue.isOpen then
		if g_currentMission.hlGui.menue.width[1] == 0 then hlGuiOverlays:setNormalDraw();end;
		g_currentMission.hlGui.clickAreas.menue["hlGuiMenue"] = {};
		g_currentMission.hlGui.clickAreas.master = {};		
		local modTable = hlGuiSetGet:getModTable(g_currentMission.hlGui.menue.select.modName);
		if modTable ~= nil then
			local disableClickArea = g_currentMission.hl.dragDrop.on or not g_currentMission.hl.isMouseCursor; 
			local thisDragDrop = g_currentMission.hl.isMouseCursor and g_currentMission.hl.dragDrop.on and (g_currentMission.hl.dragDrop.what == "_hlGuiMenue_" or g_currentMission.hl.dragDrop.what == "_hlGuiMenueWH_" ) and g_currentMission.hl.dragDrop.where == "hlGuiMenue";
			local iconWidth = hlGuiOverlays.buttonGfxWidth1*g_currentMission.hlGui.menue.zoomOutIn;
			local iconHeight = hlGuiOverlays.buttonGfxHeight1*g_currentMission.hlGui.menue.zoomOutIn;
			local distanceHeight = g_currentMission.hlGui.menue.distanceHeight;
			local distanceWidth = g_currentMission.hlGui.menue.distanceWidth;
			local isSelectPage = g_currentMission.hlGui.menue.select.page;
			local isSelectSide = g_currentMission.hlGui.menue.select.side;
			local modPageTotal = #modTable.page;
			local modSideTotal = #modTable.page[isSelectPage].side;
			local optiSize = g_currentMission.hlGui.menue.buttonOptiSize;
			local txt = "";
			local txtHeight = 0;
			local txtWidth = 0;
			local color = nil;
			local canColor = not hlGuiSetGet:isPullDownOpenButton();		
			local distanceEdge = g_currentMission.hlGui.menue.distanceEdge;
			if thisDragDrop and (g_currentMission.hl.dragDrop.what == "_hlGuiMenue_" or g_currentMission.hl.dragDrop.what == "_hlGuiMenueWH_") then
				hlGuiSetGet:resetPullDownButton();
				if g_currentMission.hl.dragDrop.what == "_hlGuiMenue_" then				
					g_currentMission.hlGui.menue.posX[1] = hlGui.mouseCursor.posX-(iconWidth/2)-distanceEdge;
					g_currentMission.hlGui.menue.posY[1] = hlGui.mouseCursor.posY+distanceEdge+(iconHeight/2);
					g_currentMission.hlGui.menue.isSave = false;
				elseif g_currentMission.hl.dragDrop.what == "_hlGuiMenueWH_" then				
					local tempWidth = hlGui.mouseCursor.posX-g_currentMission.hlGui.menue.posX[1]+(iconWidth/2);				
					local tempHeight = g_currentMission.hlGui.menue.posY[1]-hlGui.mouseCursor.posY+(iconHeight/2);
					local setRefresh = false;
					if tempWidth > iconWidth*g_currentMission.hlGui.menue.width.zoomOutIn then
						g_currentMission.hlGui.menue.width[1] = tempWidth;
						setRefresh = true;
					end;
					if tempHeight > iconHeight*g_currentMission.hlGui.menue.height.zoomOutIn then
						g_currentMission.hlGui.menue.height[1] = tempHeight;					
						setRefresh = true;
					end;
					if setRefresh then
						g_currentMission.hlGui.menue.isSave = false;
						hlGuiSetGet:resetSideLineBounds();
						hlGuiSetGet:resetHelpBox();
						hlGuiSetGet:resetInfoBox();
					end;
				end;			
			end;
			
			-------------------set menue pulldown line-------------------
			function setMenuePullDownLineTxt()
				local txtPosY = g_currentMission.hlGui.menue.pullDownButton.y+g_currentMission.hlGui.menue.pullDownButton.height-g_currentMission.hlGui.menue.pullDownButton.bounds[4];
				for line=1, #g_currentMission.hlGui.menue.pullDownButton.line do
					if g_currentMission.hlGui.menue.pullDownButton.line[line] ~= nil and g_currentMission.hlGui.menue.pullDownButton.line[line].view then
						txt = g_currentMission.hlGui.menue.pullDownButton.line[line].txt;
						txt = g_currentMission.hl.getTxtToWidthFix(txt, optiSize, g_currentMission.hlGui.menue.pullDownButton.width-(distanceEdge*2)-iconWidth, "..", 0);
						if g_currentMission.hlGui.menue.pullDownButton.line[line].isSelect then color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.select, true);else color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.txtPullDown, true);end;
						setTextColor(unpack(color));
						local isMouseArea = g_currentMission.hlGui.menue.pullDownButton.select > 0 and g_currentMission.hlGui.menue.pullDownButton.select == line;
						setTextBold(isMouseArea);
						renderText(g_currentMission.hlGui.menue.pullDownButton.x+distanceEdge, txtPosY+distanceEdge, optiSize, txt);
						renderText(g_currentMission.hlGui.menue.pullDownButton.x+distanceEdge, txtPosY+distanceEdge, optiSize, txt);
						setTextColor(1, 1, 1, 1);
						setTextBold(false);
						txtHeight = getTextHeight(optiSize, utf8Substr(txt, 0));					
						local tempArea = {
							g_currentMission.hlGui.menue.pullDownButton.x;
							g_currentMission.hlGui.menue.pullDownButton.x+g_currentMission.hlGui.menue.pullDownButton.width-distanceEdge-iconWidth;
							g_currentMission.hlGui.menue.pullDownButton.y;
							g_currentMission.hlGui.menue.pullDownButton.y+g_currentMission.hlGui.menue.pullDownButton.height;
							whatClick="hlGuiMenue";
							whereClick="pullDownMenueOpenArea_";						
						};
						if not disableClickArea then hlGuiDraw:clickAreas(false, tempArea );end;
						local tempArea = {
							g_currentMission.hlGui.menue.pullDownButton.x+distanceEdge;
							g_currentMission.hlGui.menue.pullDownButton.x+distanceEdge+g_currentMission.hlGui.menue.pullDownButton.width-distanceEdge-iconWidth;
							txtPosY+distanceEdge;
							txtPosY+distanceEdge+txtHeight;
							whatClick="hlGuiMenue";
							whereClick="pullDownMenueOpen_";
							pullDown={line=line};
						};
						if not disableClickArea then hlGuiDraw:clickAreas(false, tempArea );end;
						txtPosY = txtPosY-g_currentMission.hlGui.menue.pullDownButton.bounds[4]
					end;
				end;
			end;
			-------------------set menue pulldown line-------------------
			
			-------------------ground-------------------
			local width = g_currentMission.hlGui.menue.width[1];
			local height = g_currentMission.hlGui.menue.height[1];
			local posX = g_currentMission.hlGui.menue.posX[1];
			local posY = g_currentMission.hlGui.menue.posY[1]-height;		
			local overlay = g_currentMission.hlGui.menue.icon["ground"];
			local tempOverlay = g_currentMission.hlGui.menue.icon["dragDrop"];
			g_currentMission.hl.setOverlay(overlay, posX,posY,width,height);
			overlay:render();
			if not disableClickArea then hlGuiDraw:clickAreas(true, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="hlGuiMenue"} );end;			
			-------------------ground-------------------
			
			local iconRightPosX = overlay.x+overlay.width-distanceEdge-iconWidth
			local iconLeftPosX = overlay.x+distanceEdge;
			local iconPosY = overlay.y+overlay.height-distanceEdge-iconHeight;		
			
			-------------------default guimenue-------------------
			---dragDrop---
			overlay = g_currentMission.hlGui.menue.icon["dragDrop"];
			g_currentMission.hl.setOverlay(overlay, iconLeftPosX,iconPosY,iconWidth,iconHeight);
			if thisDragDrop or disableClickArea then
				if thisDragDrop and g_currentMission.hl.dragDrop.what == "_hlGuiMenue_" then
					color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.ready, true);
				else
					color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.off, true);
				end;
			else 
				color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.on, true);			
			end;
			g_currentMission.hl.setBackgroundColor(overlay, color);
			overlay:render();
			if not disableClickArea or (thisDragDrop and g_currentMission.hl.dragDrop.what == "_hlGuiMenue_") then hlGuiDraw:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="hlGuiMenue", whereClick="dragDrop_"} );end;
			---dragDrop---
			iconLeftPosX = iconLeftPosX+distanceEdge+iconWidth;
			---dragDropWH---
			overlay = g_currentMission.hlGui.menue.icon["dragDropWH"];
			g_currentMission.hl.setOverlay(overlay, iconRightPosX+distanceEdge,posY,iconWidth,iconHeight);
			if thisDragDrop or disableClickArea then
				if thisDragDrop and g_currentMission.hl.dragDrop.what == "_hlGuiMenueWH_" then
					color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.ready, true);
				else
					color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.off, true);
				end;
			else 
				color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.on, true);			
			end;
			g_currentMission.hl.setBackgroundColor(overlay, color);
			if g_currentMission.hlGui.menue.blinkDragDropHeight or g_currentMission.hlGui.menue.blinkDragDropWidth then
				if not g_currentMission.hl.runsTimer("1sec", true) then overlay:render();end;
			else
				overlay:render();
			end;
			if not disableClickArea or (thisDragDrop and g_currentMission.hl.dragDrop.what == "_hlGuiMenueWH_") then hlGuiDraw:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="hlGuiMenue", whereClick="dragDropWH_"} );end;
			---dragDropWH---		
			---close---
			overlay = g_currentMission.hlGui.menue.icon["close"];
			g_currentMission.hl.setOverlay(overlay, iconRightPosX,iconPosY,iconWidth,iconHeight);
			overlay:render();
			if not disableClickArea then hlGuiDraw:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="hlGuiMenue", whereClick="closeHlGuiMenue_"} );end;
			---close---
			iconRightPosX = iconRightPosX-distanceEdge-iconWidth;
			---save---
			overlay = g_currentMission.hlGui.menue.icon["save"];
			g_currentMission.hl.setOverlay(overlay, iconRightPosX,iconPosY,iconWidth,iconHeight);
			if g_currentMission.hlGui.menue.isSave then
				color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.on, true);
			else
				color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.off, true);
			end;
			g_currentMission.hl.setBackgroundColor(overlay, color);
			overlay:render();
			if not disableClickArea then hlGuiDraw:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="hlGuiMenue", whereClick="saveHlGuiMenue_"} );end;
			---save---
			iconRightPosX = iconRightPosX-distanceEdge-iconWidth;
			---help---
			overlay = g_currentMission.hlGui.menue.icon["buttonHelp"];
			g_currentMission.hl.setOverlay(overlay, iconRightPosX,iconPosY,iconWidth,iconHeight);
			if g_currentMission.hlGui.menue.isHelp then
				color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.ready, true);
			else
				color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.default, true);
			end;
			g_currentMission.hl.setBackgroundColor(overlay, color);
			overlay:render();
			if not disableClickArea then hlGuiDraw:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="hlGuiMenue", whereClick="helpHlGuiMenue_"} );end;
			---help---
			iconRightPosX = iconRightPosX-distanceEdge-iconWidth;
			---info---
			overlay = g_currentMission.hlGui.menue.icon["buttonInfo"];
			g_currentMission.hl.setOverlay(overlay, iconRightPosX,iconPosY,iconWidth,iconHeight);
			if g_currentMission.hlGui.menue.isInfo then
				color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.ready, true);
			else
				color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.default, true);
			end;
			g_currentMission.hl.setBackgroundColor(overlay, color);
			overlay:render();
			if not disableClickArea then hlGuiDraw:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="hlGuiMenue", whereClick="infoHlGuiMenue_"} );end;
			---info---
			iconRightPosX = iconRightPosX-distanceEdge-iconWidth;
			---zoomIn---
			overlay = g_currentMission.hlGui.menue.icon["zoomIn"];
			g_currentMission.hl.setOverlay(overlay, iconRightPosX,iconPosY,iconWidth,iconHeight);
			if g_currentMission.hlGui.menue.zoomOutIn <= g_currentMission.hlGui.menue.minZoomOutIn then
				color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.off, true);
			elseif g_currentMission.hlGui.menue.zoomOutIn == g_currentMission.hlGui.menue.defaultZoomOutIn then
				color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.on, true);
			else
				color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.ready, true);
			end;			
			g_currentMission.hl.setBackgroundColor(overlay, color);
			overlay:render();
			if not disableClickArea then hlGuiDraw:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="hlGuiMenue", whereClick="zoomInHlGuiMenue_"} );end;
			---zoomIn---
			iconRightPosX = iconRightPosX-distanceEdge-iconWidth;
			---zoomOut---
			overlay = g_currentMission.hlGui.menue.icon["zoomOut"];
			g_currentMission.hl.setOverlay(overlay, iconRightPosX,iconPosY,iconWidth,iconHeight);
			if g_currentMission.hlGui.menue.zoomOutIn >= g_currentMission.hlGui.menue.maxZoomOutIn then
				color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.off, true);
			elseif g_currentMission.hlGui.menue.zoomOutIn == g_currentMission.hlGui.menue.defaultZoomOutIn then
				color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.on, true);
			else
				color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.ready, true);
			end;
			g_currentMission.hl.setBackgroundColor(overlay, color);
			overlay:render();
			if not disableClickArea then hlGuiDraw:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="hlGuiMenue", whereClick="zoomOutHlGuiMenue_"} );end;
			---zoomOut---
			iconRightPosX = iconRightPosX-distanceEdge-iconWidth;
			---copyright---
			local copyrightTxt = tostring(hlGui.metadata.title).. tostring(hlGui.metadata.version).. tostring(hlGui.metadata.author);
			txt = g_currentMission.hl.getTxtToWidthFix(copyrightTxt, optiSize, iconRightPosX-iconLeftPosX-(distanceEdge*2)-iconWidth, "..", 0);
			--local txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
			color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.default, true);
			setTextColor(unpack(color));		
			renderText(iconLeftPosX+distanceEdge, iconPosY+distanceEdge, optiSize, txt);
			setTextColor(1, 1, 1, 1);
			---copyright---
			-------------------default guimenue-------------------
			
			iconRightPosX = g_currentMission.hlGui.menue.posX[1]+g_currentMission.hlGui.menue.width[1]-distanceEdge-iconWidth-distanceWidth;
			iconLeftPosX = g_currentMission.hlGui.menue.posX[1]+distanceEdge+distanceWidth;
			iconPosY = iconPosY-distanceEdge-iconHeight-distanceHeight;
			
			-------------------mod pulldown-------------------		
			---groundButton mod---
			overlay = g_currentMission.hlGui.menue.icon["groundButton"];
			g_currentMission.hl.setOverlay(overlay, iconLeftPosX,iconPosY,iconRightPosX-iconLeftPosX+iconWidth,iconHeight);		
			color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.buttonGround, true);		
			g_currentMission.hl.setBackgroundColor(overlay, color);
			overlay:render();
			---groundButton mod---
			---groundButton mod over txt---
			txt = g_currentMission.hl.getTxtToWidthFix("Select Mod (".. tostring(g_currentMission.hlGui.menue.modTotal).. ")", optiSize, iconRightPosX-iconLeftPosX-(distanceEdge*2), "..", 0);
			color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.txtTitle, true);
			setTextColor(unpack(color));
			setTextBold(true);
			renderText(iconLeftPosX+distanceEdge, iconPosY+iconHeight+distanceEdge, g_currentMission.hlGui.menue.overUnderOptiSize, txt);
			setTextColor(1, 1, 1, 1);
			setTextBold(false);
			---groundButton mod over txt---
			---pullDown mod buttonDown---
			tempOverlay = g_currentMission.hlGui.menue.icon["buttonDown"];
			g_currentMission.hl.setOverlay(tempOverlay, iconRightPosX,iconPosY,iconWidth,iconHeight);		
			color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.button, true);		
			g_currentMission.hl.setBackgroundColor(tempOverlay, color);
			tempOverlay:render();
			tempOverlay:render();
			if not disableClickArea then hlGuiDraw:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="hlGuiMenue", whereClick="modPullDownHlGuiMenue_", pullDown={x=overlay.x,y=overlay.y,width=overlay.width,multiple=false}} );end;
			---pullDown mod buttonDown---
			---pullDown mod open---
			if hlGuiSetGet:isPullDownOpenButton() and g_currentMission.hlGui.menue.pullDownButton.whatOpen == "modPullDownHlGuiMenue_" then
				tempOverlay = g_currentMission.hlGui.menue.icon["groundPullDown"];
				g_currentMission.hl.setOverlay(tempOverlay, overlay.x,g_currentMission.hlGui.menue.pullDownButton.y,overlay.width,g_currentMission.hlGui.menue.pullDownButton.height);
				tempOverlay:render();
				---pullDown Bounds mouse---
				if g_currentMission.hlGui.menue.pullDownButton.bounds[2]-g_currentMission.hlGui.menue.pullDownButton.bounds[1]+1 < g_currentMission.hlGui.menue.pullDownButton.bounds[3] then
					tempOverlay = g_currentMission.hlGui.menue.icon["buttonMouseMiddle"];
					g_currentMission.hl.setOverlay(tempOverlay, overlay.x+overlay.width-distanceEdge-iconWidth,g_currentMission.hlGui.menue.pullDownButton.y+(g_currentMission.hlGui.menue.pullDownButton.height/2)-(iconHeight/2),iconWidth,iconHeight);
					color = g_currentMission.hl.getColor("gold", true);
					g_currentMission.hl.setBackgroundColor(tempOverlay, color);
					tempOverlay:render()
				end;
				---pullDown Bounds mouse---
				---pullDown mod open line txt---
				setMenuePullDownLineTxt();
				---pullDown mod open line txt---
			end;
			---pullDown mod open---
			---pullDown mod txt---
			txt = modTable.displayName;
			txt = g_currentMission.hl.getTxtToWidthFix(txt, optiSize, iconRightPosX-iconLeftPosX-(distanceEdge*2), "..", 0);
			color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.txt, true);
			txtHeight = getTextHeight(optiSize, utf8Substr(txt, 0));
			setTextColor(unpack(color));
			setTextBold(true);
			renderText(iconLeftPosX+distanceEdge, iconPosY+distanceEdge+(iconHeight/2)-(txtHeight/2), optiSize, txt);		
			setTextColor(1, 1, 1, 1);
			setTextBold(false);
			---pullDown mod txt---		
			-------------------mod pulldown-------------------
			
			iconPosY = iconPosY-distanceEdge-iconHeight-distanceHeight;
			
			-------------------mod page/side pulldown-------------------		
			---groundButton page---
			local tempWidth = (iconRightPosX-iconLeftPosX)/1.2-distanceWidth;
			overlay = g_currentMission.hlGui.menue.icon["groundButton"];
			g_currentMission.hl.setOverlay(overlay, iconLeftPosX,iconPosY,tempWidth,iconHeight);		
			color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.buttonGround, true);		
			g_currentMission.hl.setBackgroundColor(overlay, color);
			if not hlGuiSetGet:pullDownOverlap(overlay) then overlay:render();end;
			---groundButton page---
			---groundButton page over txt---
			if modPageTotal > 0 then
				txt = g_currentMission.hl.getTxtToWidthFix("Page ".. tostring(isSelectPage).. "/".. tostring(modPageTotal), optiSize, iconRightPosX-iconLeftPosX-(distanceEdge*2), "..", 0);
			else
				txt = g_currentMission.hl.getTxtToWidthFix("Page 1/1", optiSize, tempWidth-iconWidth-(distanceEdge*2), "..", 0);
			end;
			color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.txtTitle, true);
			setTextColor(unpack(color));
			setTextBold(true);
			if not hlGuiSetGet:pullDownOverlap( {x=iconLeftPosX, y=iconPosY+iconHeight+distanceEdge}, txt, g_currentMission.hlGui.menue.overUnderOptiSize) then renderText(iconLeftPosX+distanceEdge, iconPosY+iconHeight+distanceEdge, g_currentMission.hlGui.menue.overUnderOptiSize, txt);end;
			setTextColor(1, 1, 1, 1);
			setTextBold(false);
			---groundButton page over txt---
			---pullDown page buttonDown---		
			tempOverlay = g_currentMission.hlGui.menue.icon["buttonDown"];
			g_currentMission.hl.setOverlay(tempOverlay, overlay.x+overlay.width-iconWidth,iconPosY,iconWidth,iconHeight);		
			color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.button, true);		
			g_currentMission.hl.setBackgroundColor(tempOverlay, color);
			if modPageTotal > 1 and not hlGuiSetGet:pullDownOverlap(tempOverlay) then
				tempOverlay:render();
				tempOverlay:render();
				if not disableClickArea then hlGuiDraw:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="hlGuiMenue", whereClick="pagePullDownHlGuiMenue_", pullDown={x=overlay.x,y=overlay.y,width=overlay.width,multiple=false}} );end;
			end;
			---pullDown page buttonDown---
			---pullDown page open---
			if modPageTotal > 1 and hlGuiSetGet:isPullDownOpenButton() and g_currentMission.hlGui.menue.pullDownButton.whatOpen == "pagePullDownHlGuiMenue_" then
				tempOverlay = g_currentMission.hlGui.menue.icon["groundPullDown"];
				g_currentMission.hl.setOverlay(tempOverlay, overlay.x,g_currentMission.hlGui.menue.pullDownButton.y,overlay.width,g_currentMission.hlGui.menue.pullDownButton.height);
				tempOverlay:render();
				---pullDown Bounds mouse---
				if g_currentMission.hlGui.menue.pullDownButton.bounds[2]-g_currentMission.hlGui.menue.pullDownButton.bounds[1]+1 < g_currentMission.hlGui.menue.pullDownButton.bounds[3] then
					tempOverlay = g_currentMission.hlGui.menue.icon["buttonMouseMiddle"];
					g_currentMission.hl.setOverlay(tempOverlay, overlay.x+overlay.width-distanceEdge-iconWidth,g_currentMission.hlGui.menue.pullDownButton.y+(g_currentMission.hlGui.menue.pullDownButton.height/2)-(iconHeight/2),iconWidth,iconHeight);
					color = g_currentMission.hl.getColor("gold", true);
					g_currentMission.hl.setBackgroundColor(tempOverlay, color);
					tempOverlay:render()
				end;
				---pullDown Bounds mouse---
				---pullDown page open line txt---
				setMenuePullDownLineTxt();
				---pullDown page open line txt---
			end;
			---pullDown page open--
			---pullDown page txt---
			txt = tostring(modTable.page[isSelectPage].displayName);
			txt = g_currentMission.hl.getTxtToWidthFix(txt, optiSize, tempWidth-iconWidth-(distanceEdge*2), "..", 0);
			color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.txt, true);
			txtHeight = getTextHeight(optiSize, utf8Substr(txt, 0));
			setTextColor(unpack(color));		
			setTextBold(true);
			if not hlGuiSetGet:pullDownOverlap( {x=iconLeftPosX, y=iconPosY+distanceEdge+(iconHeight/2)-(txtHeight/2)}, txt, optiSize) then renderText(iconLeftPosX+distanceEdge, iconPosY+distanceEdge+(iconHeight/2)-(txtHeight/2), optiSize, txt);end;		
			setTextBold(false);
			setTextColor(1, 1, 1, 1);
			---pullDown page txt---		
			---groundButton side---
			local tempWidth1 = (iconRightPosX-iconLeftPosX+iconWidth)-tempWidth-(distanceWidth*2);
			overlay = g_currentMission.hlGui.menue.icon["groundButton"];
			g_currentMission.hl.setOverlay(overlay, iconLeftPosX+tempWidth+(distanceWidth*2),iconPosY,tempWidth1,iconHeight);		
			color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.buttonGround, true);		
			g_currentMission.hl.setBackgroundColor(overlay, color);
			if not hlGuiSetGet:pullDownOverlap(overlay) then overlay:render();end;
			---groundButton side---
			---groundButton side over txt---
			if modSideTotal > 0 then
				txt = g_currentMission.hl.getTxtToWidthFix("Side ".. tostring(isSelectSide).. "/".. tostring(modSideTotal), optiSize, tempWidth1-(distanceEdge*2), "..", 0);
			else
				txt = g_currentMission.hl.getTxtToWidthFix("Side 1/1", optiSize, tempWidth1-(distanceEdge*2), "..", 0);
			end;
			color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.txtTitle, true);
			setTextColor(unpack(color));
			setTextBold(true);
			if not hlGuiSetGet:pullDownOverlap( {x=overlay.x, y=iconPosY+iconHeight+distanceEdge}, txt, g_currentMission.hlGui.menue.overUnderOptiSize) then renderText(overlay.x+distanceEdge, iconPosY+iconHeight+distanceEdge, g_currentMission.hlGui.menue.overUnderOptiSize, txt);end;
			setTextColor(1, 1, 1, 1);
			setTextBold(false);
			---groundButton side over txt---		
			---pullDown side buttonDown---		
			tempOverlay = g_currentMission.hlGui.menue.icon["buttonDown"];
			g_currentMission.hl.setOverlay(tempOverlay, overlay.x+overlay.width-iconWidth,iconPosY,iconWidth,iconHeight);		
			color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.button, true);		
			g_currentMission.hl.setBackgroundColor(tempOverlay, color);
			if modSideTotal > 1 and not hlGuiSetGet:pullDownOverlap(tempOverlay) then 
				tempOverlay:render();
				tempOverlay:render();
				if not disableClickArea then hlGuiDraw:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="hlGuiMenue", whereClick="sidePullDownHlGuiMenue_", pullDown={x=overlay.x,y=overlay.y,width=overlay.width,multiple=false}} );end;
			end;
			---pullDown side buttonDown---
			---pullDown side open---
			if modSideTotal > 1 and hlGuiSetGet:isPullDownOpenButton() and g_currentMission.hlGui.menue.pullDownButton.whatOpen == "sidePullDownHlGuiMenue_" then
				tempOverlay = g_currentMission.hlGui.menue.icon["groundPullDown"];
				g_currentMission.hl.setOverlay(tempOverlay, overlay.x,g_currentMission.hlGui.menue.pullDownButton.y,overlay.width,g_currentMission.hlGui.menue.pullDownButton.height);
				tempOverlay:render();
				---pullDown Bounds mouse---
				if g_currentMission.hlGui.menue.pullDownButton.bounds[2]-g_currentMission.hlGui.menue.pullDownButton.bounds[1]+1 < g_currentMission.hlGui.menue.pullDownButton.bounds[3] then
					tempOverlay = g_currentMission.hlGui.menue.icon["buttonMouseMiddle"];
					g_currentMission.hl.setOverlay(tempOverlay, overlay.x+overlay.width-distanceEdge-iconWidth,g_currentMission.hlGui.menue.pullDownButton.y+(g_currentMission.hlGui.menue.pullDownButton.height/2)-(iconHeight/2),iconWidth,iconHeight);
					color = g_currentMission.hl.getColor("gold", true);
					g_currentMission.hl.setBackgroundColor(tempOverlay, color);
					tempOverlay:render()
				end;
				---pullDown Bounds mouse---
				---pullDown side open line txt---
				setMenuePullDownLineTxt();
				---pullDown side open line txt---
			end;
			---pullDown side open--
			---pullDown side txt---
			txt = tostring(isSelectSide);		
			txt = g_currentMission.hl.getTxtToWidthFix(txt, optiSize, iconRightPosX-iconLeftPosX-(distanceEdge*2), "..", 0);
			color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.txt, true);
			txtHeight = getTextHeight(optiSize, utf8Substr(txt, 0));
			setTextColor(unpack(color));		
			setTextBold(true);
			if not hlGuiSetGet:pullDownOverlap( {x=overlay.x, y=iconPosY+distanceEdge+(iconHeight/2)-(txtHeight/2)}, txt, optiSize ) then renderText(overlay.x+distanceEdge, iconPosY+distanceEdge+(iconHeight/2)-(txtHeight/2), optiSize, txt);end;		
			setTextBold(false);
			setTextColor(1, 1, 1, 1);
			---pullDown side txt---
			tempOverlay = {
				x=g_currentMission.hlGui.menue.posX[1];
				y=iconPosY-(distanceEdge*2);
				width=g_currentMission.hlGui.menue.width[1];
				height=distanceHeight/2;
			};
			if not hlGuiSetGet:pullDownOverlap(tempOverlay) then hlGuiDraw:setLineBorder(g_currentMission.hlGui.menue.icon["lineBorder"], tempOverlay, 1, 0.0005, false, true, false, false);end;
			-------------------mod page/side pulldown-------------------

			iconRightPosX = g_currentMission.hlGui.menue.posX[1]+g_currentMission.hlGui.menue.width[1]-distanceEdge-distanceWidth;
			iconLeftPosX = g_currentMission.hlGui.menue.posX[1]+distanceEdge+distanceWidth;
			local lastIconPosY = iconPosY-distanceEdge-(distanceHeight/2);			
			iconPosY = iconPosY-distanceEdge-iconHeight-distanceHeight;					
			-------------------mod lines-------------------
			local minButtonGroundWidth = (iconWidth*2)+(distanceEdge*3);
			local minHeight = iconHeight+distanceEdge+(distanceHeight/2);
			g_currentMission.hlGui.menue.posY.beginLine = lastIconPosY;
			g_currentMission.hlGui.menue.posY.endLine = posY+minHeight;
			g_currentMission.hlGui.menue.height.line = distanceEdge+iconHeight+distanceHeight;
			if iconPosY >= posY+minHeight then
				if not disableClickArea then hlGuiDraw:clickAreas(false, {iconLeftPosX, iconRightPosX, posY, g_currentMission.hlGui.menue.posY.beginLine, whatClick="hlGuiMenue", whereClick="sideOpenArea_"} );end;
				hlGuiSetGet:blinkingDragDropHeight(false);
				txtHeight = getTextHeight(optiSize, utf8Substr("Test", 0));
				local sideTable = modTable.page[isSelectPage].side[isSelectSide];
				if sideTable ~= nil and sideTable.bounds[1] == 0 then hlGuiSetGet:setSideFirstLineBounds();end;
				if sideTable ~= nil and sideTable.otherDraw ~= nil and not hlGuiSetGet:pullDownOverlap( {x=iconLeftPosX,y=posY+minHeight,width=iconRightPosX-iconLeftPosX,height=lastIconPosY-(posY+minHeight)} ) then
					sideTable.otherDraw( {x=iconLeftPosX,y=posY+minHeight,minHeight=minHeight,width=iconRightPosX-iconLeftPosX,height=lastIconPosY-(posY+minHeight), optiSize=optiSize, bounds={sideTable.bounds[1],sideTable.bounds[2]},ownTable=sideTable.ownTable} );
				elseif sideTable ~= nil then
					if sideTable.line ~= nil and #sideTable.line > 0 then
						local warningDrapDropWidth = false;
						local warningDrapDropHeight = false;
						for line=1, #sideTable.line do							
							if sideTable.line[line] ~= nil and sideTable.line[line].view then
								if iconPosY > posY+minHeight then
									if sideTable.line[line].empty then
										if sideTable.line[line].otherDraw ~= nil then 
											sideTable.line[line].otherDraw( {x=iconLeftPosX,y=iconPosY,width=iconRightPosX-iconLeftPosX,height=distanceEdge+iconHeight+distanceHeight, optiSize=optiSize, line=line, ownTable=sideTable.line[line].ownTable} );
										end;
									else
										if sideTable.line[line].button ~= nil and #sideTable.line[line].button > 0 then
											local buttonLeng = (#sideTable.line[line].button*2)-2;
											local buttonWidth = hlGuiDraw:getLineWidth(iconRightPosX-iconLeftPosX-(distanceWidth*buttonLeng), sideTable.line[line]);
											for button=1, #sideTable.line[line].button do
												if sideTable.line[line].button[button] ~= nil then
													local buttonTable = sideTable.line[line].button[button];													
													if #buttonWidth > 0 then
														local groundButtonWidth = buttonWidth[button];
														if groundButtonWidth < minButtonGroundWidth then groundButtonWidth = minButtonGroundWidth;end;
														if iconLeftPosX+groundButtonWidth-0.001 > iconRightPosX then warningDrapDropWidth = true;break;end;
														overlay = g_currentMission.hlGui.menue.icon["groundButton"];
														g_currentMission.hl.setOverlay(overlay,iconLeftPosX,iconPosY,groundButtonWidth,iconHeight);														
														if buttonTable.visible then
															if not hlGuiSetGet:pullDownOverlap( {x=overlay.x,y=overlay.y,width=overlay.width,height=overlay.height} ) then
																local alreadyExistsTxtInfo = false;
																if buttonTable.groundButton ~= nil and buttonTable.groundButton then
																	if buttonTable.groundButtonColor ~= nil then
																		color = g_currentMission.hl.getColor(buttonTable.groundButtonColor, true);
																	else
																		color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.buttonGround, true);
																	end;
																	g_currentMission.hl.setBackgroundColor(overlay, color);
																	overlay:render();
																end;
																if buttonTable.clickButton ~= nil then
																	tempOverlay = g_currentMission.hlGui.menue.icon[buttonTable.clickButton];
																	g_currentMission.hl.setOverlay(tempOverlay, overlay.x+overlay.width-iconWidth,iconPosY,iconWidth,iconHeight);
																	if buttonTable.clickButtonColor ~= nil then
																		color = g_currentMission.hl.getColor(buttonTable.clickButtonColor, true);
																	else
																		color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.button, true);
																	end;
																	g_currentMission.hl.setBackgroundColor(tempOverlay, color);
																	tempOverlay:render();
																	if not disableClickArea then 
																		if buttonTable.clickButtonCallback ~= nil then 
																			if buttonTable.clickButton == "buttonLeftRight" then
																				hlGuiDraw:clickAreas(false, {tempOverlay.x, tempOverlay.x+(tempOverlay.width/2), tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="hlGuiMenue", whereClick="sideLineButtonLeft_", infoTxt=buttonTable.txtInfo, callback=buttonTable.clickButtonCallback, lineButton=buttonTable, line=line, button=button, ownTable=sideTable.ownTable} );
																				hlGuiDraw:clickAreas(false, {tempOverlay.x+(tempOverlay.width/2), tempOverlay.x+tempOverlay.width, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="hlGuiMenue", whereClick="sideLineButtonRight_", infoTxt=buttonTable.txtInfo, callback=buttonTable.clickButtonCallback, lineButton=buttonTable, line=line, button=button, ownTable=sideTable.ownTable} );
																				alreadyExistsTxtInfo = true;
																			elseif buttonTable.clickButton == "buttonUpDown" then
																				hlGuiDraw:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width, tempOverlay.y+(tempOverlay.height/2), tempOverlay.y+tempOverlay.height, whatClick="hlGuiMenue", whereClick="sideLineButtonUp_", infoTxt=buttonTable.txtInfo, callback=buttonTable.clickButtonCallback, lineButton=buttonTable, line=line, button=button, ownTable=sideTable.ownTable} );
																				hlGuiDraw:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width, tempOverlay.y, tempOverlay.y+(tempOverlay.height/2), whatClick="hlGuiMenue", whereClick="sideLineButtonDown_", infoTxt=buttonTable.txtInfo, callback=buttonTable.clickButtonCallback, lineButton=buttonTable, line=line, button=button, ownTable=sideTable.ownTable} );
																				alreadyExistsTxtInfo = true;
																			else
																				hlGuiDraw:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="hlGuiMenue", whereClick="sideLineButton_", infoTxt=buttonTable.txtInfo, callback=buttonTable.clickButtonCallback, lineButton=buttonTable, line=line, button=button, ownTable=sideTable.ownTable} );
																				alreadyExistsTxtInfo = true;
																			end;
																		elseif buttonTable.pullDownButton ~= nil and buttonTable.pullDownButton and buttonTable.pullDownCallback ~= nil then
																			hlGuiDraw:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="hlGuiMenue", whereClick="sideLineButtonPullDown_", infoTxt=buttonTable.txtInfo, callback=buttonTable.pullDownCallback, lineButton=buttonTable, ownTable=sideTable.ownTable, pullDown={x=overlay.x,y=overlay.y,width=overlay.width,multiple=buttonTable.pullDownMultipleSelect}} );
																			alreadyExistsTxtInfo = true;
																		end;
																	end;																	
																end;																
																if not alreadyExistsTxtInfo and buttonTable.txtInfo ~= nil then
																	hlGuiDraw:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="hlGuiMenue", whereClick="sideLineButtonInfo_", infoTxt=buttonTable.txtInfo} );
																end;
																if buttonTable.txtButton ~= nil then
																	if buttonTable.txtButtonCallback ~= nil then buttonTable.txtButton = tostring(buttonTable.txtButtonCallback( {lineButton=buttonTable} ));end;
																	txt = g_currentMission.hl.getTxtToWidthFix(buttonTable.txtButton, optiSize, groundButtonWidth-(distanceEdge*2)-(iconWidth*1.5), "..", 0);
																	if buttonTable.txtButtonColor ~= nil then
																		color = g_currentMission.hl.getColor(buttonTable.txtButtonColor, true);
																	else
																		color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.txt, true);
																	end;
																	setTextBold(buttonTable.txtBoldButton);
																	setTextColor(unpack(color));
																	renderText(iconLeftPosX+distanceEdge, iconPosY+distanceEdge, optiSize, txt);
																	setTextBold(false);
																	setTextColor(1, 1, 1, 1);
																end;
															end;															
															local helpIcon = 0;
															if buttonTable.txtHelp ~= nil and g_currentMission.hlGui.menue.isHelp then helpIcon = (iconWidth/1.5);end;
															if buttonTable.txtOverButton ~= nil then																
																txt = g_currentMission.hl.getTxtToWidthFix(buttonTable.txtOverButton, g_currentMission.hlGui.menue.overUnderOptiSize, groundButtonWidth-(distanceEdge*2)-helpIcon, "..", 0);
																if buttonTable.txtOverButtonColor ~= nil then
																	color = g_currentMission.hl.getColor(buttonTable.txtOverButtonColor, true);
																else
																	color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.txtTitle, true);
																end;																
																setTextBold(true);
																setTextColor(unpack(color));		
																if not hlGuiSetGet:pullDownOverlap( {x=overlay.x, y=iconPosY+iconHeight+distanceEdge}, txt, g_currentMission.hlGui.menue.overUnderOptiSize) then renderText(overlay.x+distanceEdge+helpIcon, iconPosY+iconHeight+distanceEdge, g_currentMission.hlGui.menue.overUnderOptiSize, txt);else helpIcon=0;end;
																setTextColor(1, 1, 1, 1);
																setTextBold(false);
															end;
															if helpIcon > 0 then
																tempOverlay = g_currentMission.hlGui.menue.icon["buttonHelp"];
																g_currentMission.hl.setOverlay(tempOverlay, overlay.x,iconPosY+iconHeight+distanceEdge,iconWidth/1.5,iconHeight/1.5);
																color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.ready, true);
																g_currentMission.hl.setBackgroundColor(tempOverlay, color);
																tempOverlay:render();
															end;
														elseif buttonTable.headLine then
															if not hlGuiSetGet:pullDownOverlap( {x=overlay.x,y=overlay.y,width=overlay.width,height=overlay.height} ) then
																if buttonTable.txtHeadLineColor ~= nil then
																	color = g_currentMission.hl.getColor(buttonTable.txtHeadLineColor, true);
																else
																	color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.txtTitle, true);
																end;
																setTextBold(true);
																setTextColor(unpack(color));
																txt = g_currentMission.hl.getTxtToWidthFix(buttonTable.txtHeadLine, optiSize, overlay.width, "..", 0);
																txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0)); 
																renderText(overlay.x+(overlay.width/2)-(txtWidth/2), iconPosY+(distanceEdge), optiSize, txt);																
																hlGuiDraw:setLineBorder(g_currentMission.hlGui.menue.icon["lineBorder"], overlay, 1, 0.0005, true, false, false, false);																
																setTextColor(1, 1, 1, 1);
																setTextBold(false);
															end;
														end;
														iconLeftPosX = iconLeftPosX+overlay.width+(distanceWidth*2);														
													end;
												end;
											end;											
										end;
									end;
									iconPosY = iconPosY-distanceEdge-iconHeight-distanceHeight;
									iconLeftPosX = g_currentMission.hlGui.menue.posX[1]+distanceEdge+distanceWidth;
								else
									warningDrapDropHeight = true;
									break;
								end;								
							end;							
						end;
						if hlGuiSetGet:isPullDownOpenButton() and g_currentMission.hlGui.menue.pullDownButton.whatOpen == "sideLineButtonPullDown_" then
							tempOverlay = g_currentMission.hlGui.menue.icon["groundPullDown"];
							g_currentMission.hl.setOverlay(tempOverlay, g_currentMission.hlGui.menue.pullDownButton.x,g_currentMission.hlGui.menue.pullDownButton.y,g_currentMission.hlGui.menue.pullDownButton.width,g_currentMission.hlGui.menue.pullDownButton.height);
							tempOverlay:render();
							---pullDown Bounds mouse---
							if g_currentMission.hlGui.menue.pullDownButton.bounds[2]-g_currentMission.hlGui.menue.pullDownButton.bounds[1]+1 < g_currentMission.hlGui.menue.pullDownButton.bounds[3] then
								tempOverlay = g_currentMission.hlGui.menue.icon["buttonMouseMiddle"];
								g_currentMission.hl.setOverlay(tempOverlay, overlay.x+overlay.width-distanceEdge-iconWidth,g_currentMission.hlGui.menue.pullDownButton.y+(g_currentMission.hlGui.menue.pullDownButton.height/2)-(iconHeight/2),iconWidth,iconHeight);
								color = g_currentMission.hl.getColor("gold", true);
								g_currentMission.hl.setBackgroundColor(tempOverlay, color);
								tempOverlay:render()
							end;
							---pullDown Bounds mouse---
							---pullDown side open line txt---
							setMenuePullDownLineTxt();
							---pullDown side open line txt---
						end;						
						if warningDrapDropWidth then hlGuiSetGet:blinkingDragDropWidth(true);else hlGuiSetGet:blinkingDragDropWidth(false);end;
						if warningDrapDropHeight then 							
						else 
							hlGuiSetGet:blinkingDragDropHeight(false);
						end;
						if sideTable.bounds[2]-sideTable.bounds[1]+1 < sideTable.bounds[3] then
							---mouse Scroll---
							tempOverlay = g_currentMission.hlGui.menue.icon["buttonMouseMiddle"];
							g_currentMission.hl.setOverlay(tempOverlay, posX+(width/2)-(iconWidth/2),posY+distanceEdge,iconWidth,iconHeight);
							color = g_currentMission.hl.getColor("gold", true);
							g_currentMission.hl.setBackgroundColor(tempOverlay, color);
							tempOverlay:render();
							---mouse Scroll---
							---button scroll up---
							tempOverlay = g_currentMission.hlGui.menue.icon["buttonUp"];
							g_currentMission.hl.setOverlay(tempOverlay, posX+(width/4)-(iconWidth/2),posY+distanceEdge,iconWidth,iconHeight);
							if sideTable.bounds[1] > 1 then
								color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.on, true);
							else
								color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.off, true);
							end;
							g_currentMission.hl.setBackgroundColor(tempOverlay, color);
							tempOverlay:render();
							---button scroll up---
							---button scroll down---
							tempOverlay = g_currentMission.hlGui.menue.icon["buttonDown"];
							g_currentMission.hl.setOverlay(tempOverlay, posX+width-(width/4)-(iconWidth/2),posY+distanceEdge,iconWidth,iconHeight);
							if sideTable.bounds[2] < sideTable.bounds[3] then
								color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.on, true);
							else
								color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.off, true);
							end;
							g_currentMission.hl.setBackgroundColor(tempOverlay, color);
							tempOverlay:render();
							---button scroll down---
						end;
					end;					
				end;
			else
				hlGuiSetGet:blinkingDragDropHeight(true);
			end;
			-------------------mod lines-------------------
			-------------------info/help box-------------------
			if g_currentMission.hlGui.menue.isInfo or string.len(g_currentMission.hlGui.menue.helpBox.txt) > 0 then
				if g_currentMission.hl.timers["hlGuiMenue_infoBox"] == nil then --or g_currentMission.hl.timers["hlGuiMenue_helpBox"] == nil then
					hlGuiSetGet.setInfoHelpBoxBounds( {} );
				end;
				txt = "";
				overlay = g_currentMission.hlGui.menue.icon["groundInfoBox"];
				g_currentMission.hl.setOverlay(overlay, posX,posY-(iconHeight*3)-(distanceEdge*4),width,iconHeight*3+(distanceEdge*4));
				overlay:render();
				hlGuiDraw:setLineBorder(g_currentMission.hlGui.menue.icon["lineBorder"], overlay, 1, 0.0005, true, false, false, false);
				tempOverlay = g_currentMission.hlGui.menue.icon["buttonInfo"];				
				if string.len(g_currentMission.hlGui.menue.helpBox.txt) > 0 then tempOverlay = g_currentMission.hlGui.menue.icon["buttonHelp"];end;
				g_currentMission.hl.setOverlay(tempOverlay, posX+distanceEdge,posY-(iconHeight)-(distanceEdge),iconWidth,iconHeight);
				color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.ready, true);
				g_currentMission.hl.setBackgroundColor(tempOverlay, color);
				tempOverlay:render();
				local beginLine, endLine = 0,0;
				local maxTxtWidth = width-(distanceEdge*3)-(iconWidth*2);
				if string.len(g_currentMission.hlGui.menue.helpBox.txt) > 0 then
					txt = utf8Substr(g_currentMission.hlGui.menue.helpBox.txt, 0);
					beginLine, endLine = g_currentMission.hlGui.menue.helpBox.bounds[1],g_currentMission.hlGui.menue.helpBox.bounds[2];
				elseif string.len(g_currentMission.hlGui.menue.infoBox.txt) > 0 then
					txt = utf8Substr(g_currentMission.hlGui.menue.infoBox.txt, 0);
					beginLine, endLine = g_currentMission.hlGui.menue.infoBox.bounds[1],g_currentMission.hlGui.menue.infoBox.bounds[2];
				end;
				if string.len(txt) > 0 then					
					setTextWrapWidth(maxTxtWidth);			
					setTextLineBounds(beginLine, endLine);
					color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.ready, true);
					setTextColor(unpack(color));
					setTextBold(true);
					renderText(posX+(distanceEdge*2)+iconWidth, overlay.y+overlay.height-(iconHeight-distanceEdge), optiSize, txt);
					setTextBold(false);
					setTextWrapWidth(0);
					setTextLineBounds(0, 0);
					setTextColor(1, 1, 1, 1);
				end;
			end;
			-------------------info/help box-------------------
		end;
	end;
end;

function hlGuiDraw.testOtherDraw(args)
	if args ~= nil and type(args) == "table" then
		local posX = args.x;
		local posY = args.y;
		local width = args.width;
		local height = args.height;
		local optiSize = args.optiSize;
		local txtHeight = getTextHeight(optiSize, utf8Substr("Test", 0));
		renderText(posX, posY+height-txtHeight, optiSize, "Test");
	end;
end;

function hlGuiDraw.testLineOtherDraw(args)
	if args ~= nil and type(args) == "table" then
		local posX = args.x;
		local posY = args.y;
		local width = args.width;
		local height = args.height;
		local optiSize = args.optiSize;
		local txtHeight = getTextHeight(optiSize, utf8Substr("Test ".. tostring(args.line), 0));
		renderText(posX, posY+(height/2)-(txtHeight/2), optiSize, "Test ".. tostring(args.line));
	end;
end;

function hlGuiDraw:setSmallViewOpen()
	if not g_currentMission.hl.isMouseCursor and g_currentMission.hlGui.menue.smallViewHidden then return;end;	
	if g_currentMission.hlGui.menue.posX[2] == 0 then hlGuiOverlays:setSmallViewDraw();end;
	g_currentMission.hlGui.clickAreas.menue["hlGuiMenue"] = {};
	g_currentMission.hlGui.clickAreas.master = {};	
	local disableClickArea = g_currentMission.hl.dragDrop.on or not g_currentMission.hl.isMouseCursor; 
	local overlay = g_currentMission.hlGui.menue.icon["ground"];	
	g_currentMission.hl.setOverlay(overlay, g_currentMission.hlGui.menue.posX[2],g_currentMission.hlGui.menue.posY[2],g_currentMission.hlGui.menue.width[2],g_currentMission.hlGui.menue.height[2]);
	overlay:render();
	if not disableClickArea then 
		hlGuiDraw:clickAreas(true, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="hlGuiMenue"} );
		hlGuiDraw:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="hlGuiMenue", whereClick="openHlGuiMenue_"} );
	end;
	overlay = g_currentMission.hlGui.menue.icon["buttonOtherSetting"];
	local difWidth = g_currentMission.hlGui.menue.width[2]/1.4;
	local difHeight = g_currentMission.hlGui.menue.height[2]/1.4;	
	g_currentMission.hl.setOverlay(overlay, g_currentMission.hlGui.menue.posX[2]+(g_currentMission.hlGui.menue.width[2]/2)-(difWidth/2),g_currentMission.hlGui.menue.posY[2]+(g_currentMission.hlGui.menue.height[2]/2)-(difHeight/2),difWidth,difHeight);
	local color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.ready, true);
	g_currentMission.hl.setBackgroundColor(overlay, color);
	overlay:render();
end;

function hlGuiDraw:getLineWidth(width, lineTable)
	if width <= 0 then return {width};end;
	local lineTyp = #lineTable.button;	
	local percentWidth = width/100;	
	local isPercentWidth = 0;
	local newWidth = {};	
	if lineTyp == 1 then return {width};end; --set default 1
	local isWidth = 0;
	for a=1, lineTyp do		
		if lineTable.button[a] ~= nil and lineTable.button[a].width ~= nil and percentWidth*lineTable.button[a].width <= width and isPercentWidth < 100 then
			isPercentWidth = isPercentWidth+lineTable.button[a].width;
			newWidth[a] = percentWidth*lineTable.button[a].width;
			isWidth = isWidth+1;				
		end;
	end;	
	if isWidth == 0 and lineTyp == 1 then return {width};end; --set default 1
	if isWidth < #lineTable.button then --error fix width
		local restPercentWidth = 100-isPercentWidth;
		local missingWidth = restPercentWidth/(#lineTable.button-isWidth);
		for a=1, #lineTable.button do
			if isWidth < lineTyp then
				if newWidth[a] == nil then
					isPercentWidth = isPercentWidth+missingWidth;
					newWidth[a] = percentWidth*missingWidth;
					isWidth = isWidth+1;					
				end;
			else
				break;
			end;
		end;		
	end;	
	return newWidth;
end;

function hlGuiDraw:setLineBorder(line, referenceOverlay, length, fat, up, down, left, right, setColor, alignment)	
	local color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.default, true);
	if setColor ~= nil then color = g_currentMission.hl.getColor(tostring(setColor), true);end;
	g_currentMission.hl.setBackgroundColor(line, color);	
	
	--line.debugEnabled = true;		
	local xPixel = hlGuiOverlays.buttonGfxWidth1;
	local yPixel = hlGuiOverlays.buttonGfxHeight1;
	local tempLengthW = xPixel*length;
	local tempLengthH = yPixel*length;	
	
	if up then 
		if alignment == nil or alignment == 0 then --left pos
			g_currentMission.hl.setOverlay(line, referenceOverlay.x, referenceOverlay.y+referenceOverlay.height-(fat/2), referenceOverlay.width/length-(fat/2), fat);
		elseif alignment == 1 then --middle pos
			g_currentMission.hl.setOverlay(line, referenceOverlay.x+(referenceOverlay.width/2)-((referenceOverlay.width/length-(fat/2))/2), referenceOverlay.y+referenceOverlay.height-(fat/2), referenceOverlay.width/length-(fat/2), fat);
		elseif alignment == 2 then --right pos
			g_currentMission.hl.setOverlay(line, referenceOverlay.x+referenceOverlay.width-(referenceOverlay.width/length-(fat/2)), referenceOverlay.y+referenceOverlay.height-(fat/2), referenceOverlay.width/length-(fat/2), fat);
		end;
		line:render();
		--renderOverlay(line.overlayId, line.x+line.offsetX-xPixel, line.y+line.offsetY-yPixel, line.width+2*xPixel, yPixel);
	end;		
	
	if down then 
		if alignment == nil or alignment == 0 then
			g_currentMission.hl.setOverlay(line, referenceOverlay.x, referenceOverlay.y, referenceOverlay.width/length-(fat/2), fat);
		elseif alignment == 1 then
			g_currentMission.hl.setOverlay(line, referenceOverlay.x+(referenceOverlay.width/2)-(referenceOverlay.width/length-(fat/2)/2), referenceOverlay.y, referenceOverlay.width/length-(fat/2), fat);
		elseif alignment == 2 then
			g_currentMission.hl.setOverlay(line, referenceOverlay.x+referenceOverlay.width-referenceOverlay.width/length-(fat/2), referenceOverlay.y, referenceOverlay.width/length-(fat/2), fat);
		end;
		line:render();
		--renderOverlay(line.overlayId, line.x+line.offsetX-xPixel, line.y+line.offsetY-yPixel, line.width+2*xPixel, yPixel);
	end;	
		
	if left then g_currentMission.hl.setOverlay(line, referenceOverlay.x, referenceOverlay.y, fat, referenceOverlay.height/length);
		line:render();
		--renderOverlay(line.overlayId, line.x+line.offsetX-xPixel, line.y+line.offsetY, xPixel, line.height);
	end;
		
	
	if right then g_currentMission.hl.setOverlay(line, referenceOverlay.x+referenceOverlay.width-(fat/2), referenceOverlay.y, fat, referenceOverlay.height/length);
		line:render();
		--renderOverlay(line.overlayId, line.x+line.offsetX-xPixel+line.width, line.y+line.offsetY, xPixel, line.height);
	end;	
end;

function hlGuiDraw:clickAreas(masterArea, args)	
	if masterArea ~= nil and masterArea then
		g_currentMission.hlGui.clickAreas.master[args.whatClick] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1
			whichArea=args.whatClick;
		};
	else	
		g_currentMission.hlGui.clickAreas.menue[args.whatClick][#g_currentMission.hlGui.clickAreas.menue[args.whatClick]+1] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1
			whatClick = args.whatClick;			
			whereClick = args.whereClick;
			infoTxt = args.infoTxt;
			helpTxt = args.helpTxt;			
			callback = args.callback;						
			ownTable = args.ownTable;
			pullDown = args.pullDown;
			line = args.line;
			button = args.button;
			lineButton = args.lineButton;
		};
	end;	
end;