viHlGui = {};
source(VehicleInspector.modDir.."scripte/hlGui/viGlobalSetting.lua");
source(VehicleInspector.modDir.."scripte/hlGui/viMohSetting.lua");
source(VehicleInspector.modDir.."scripte/hlGui/viOtherSetting.lua");

function viHlGui:generate(debugPrint)
	if g_currentMission.hlGui == nil or g_currentMission.hlGui.setGet == nil then 
		print("***Error	-can not generate VehicleInspector Settings Menue (! is hlGui Menue loaded !)- Error***");
		VehicleInspector.global.hlGui.isLoad = false;
		return;
		
	end;
	local errorTable = {};
	g_currentMission.hlGui.callbacks.vi = {};
	g_currentMission.hlGui.callbacks.vi["onOpenHlGui"] = viHlGui.onOpenHlGui;
	g_currentMission.hlGui.callbacks.vi["closeHlGui"] = viHlGui.setCloseHlGui;
	g_currentMission.hlGui.callbacks.vi["saveHlGui"] = viHlGui.setSaveHlGui;
	local isLoad = g_currentMission.hlGui.setGet:generateModMenue( {modName="VehicleInspector",displayName= tostring(VehicleInspector.metadata.title).. tostring(VehicleInspector.metadata.version), saveCallback=g_currentMission.hlGui.callbacks.vi["saveHlGui"], closeCallback=g_currentMission.hlGui.callbacks.vi["closeHlGui"]} );
	if not isLoad then errorTable[errorTable+1] = "***Error	-can not generate VehicleInspector Settings Menue (! is hlGui Menue loaded !)- Error***";end;
	if isLoad then
		g_currentMission.hlGui.callbacks.vi["clickButton"] = viHlGui.clickButtonCallback;
		g_currentMission.hlGui.callbacks.vi["pullDownButton"] = viHlGui.pullDownButtonCallback;
		g_currentMission.hlGui.callbacks.vi["clickPullDownLine"] = viHlGui.clickPullDownLineCallback;
		g_currentMission.hlGui.callbacks.vi["txtButton"] = viHlGui.txtButtonCallback;
		g_currentMission.hlGui.callbacks.vi["openDraw"] = viHlGui.setOpenDraw;	
		-----GlobalSetting Page/Side-----
		VehicleInspector.global.hlGui.page["GlobalSetting"] = 1;VehicleInspector.global.hlGui.side["GlobalSetting"] = 1;
		isLoad = g_currentMission.hlGui.setGet:generateModPage( {modName="VehicleInspector", displayName="Global Setting"} );
		if not isLoad then errorTable[errorTable+1] = "***Error Global Setting";end;
		isLoad = g_currentMission.hlGui.setGet:generateModPageSide( {modName="VehicleInspector", page=VehicleInspector.global.hlGui.page["GlobalSetting"]} );
		if not isLoad then errorTable[errorTable+1] = "***Error Global Setting Page Side";end;
		viGlobalSetting:generateSide(1);
		-----GlobalSetting Page/Side-----
		-----OtherSetting Page/Side-----
		VehicleInspector.global.hlGui.page["OtherSetting"] = 2;VehicleInspector.global.hlGui.side["OtherSetting"] = 1;
		isLoad = g_currentMission.hlGui.setGet:generateModPage( {modName="VehicleInspector", displayName="Other Setting"} );
		if not isLoad then errorTable[errorTable+1] = "***Error Other Setting";end;
		isLoad = g_currentMission.hlGui.setGet:generateModPageSide( {modName="VehicleInspector", page=VehicleInspector.global.hlGui.page["OtherSetting"]} );
		if not isLoad then errorTable[errorTable+1] = "***Error Other Setting Page Side";end;
		viOtherSetting:generateSide(1);
		-----OtherSetting Page/Side-----
		-----MohSetting Page/Side-----
		VehicleInspector.global.hlGui.page["MohSetting"] = 3;VehicleInspector.global.hlGui.side["MohSetting"] = 1;
		isLoad = g_currentMission.hlGui.setGet:generateModPage( {modName="VehicleInspector", displayName="VI MultiOverlayV4 Hud Setting"} );
		if not isLoad then errorTable[errorTable+1] = "***Error Moh Setting";end;
		isLoad = g_currentMission.hlGui.setGet:generateModPageSide( {modName="VehicleInspector", page=VehicleInspector.global.hlGui.page["MohSetting"]} );
		if not isLoad then errorTable[errorTable+1] = "***Error VI MultiOverlay Setting Page Side";end;
		viMohSetting:generateSide(1);
		-----MohSetting Page/Side-----
	end;
	if #errorTable > 0 then
		if debugPrint then
			for a=1, #errorTable do
				print("---VI DebugPrint= ".. tostring(errorTable[a]))
			end;
		end;
		VehicleInspector.global.hlGui.isLoad = false;
		return;
	end;
	VehicleInspector.global.hlGui.isLoad = true;
end;

function viHlGui.clickButtonCallback(args)	
	if args == nil or type(args) ~= "table" or args.lineButton == nil then return;end;	
	if args.lineButton.ownTable.pageName == "GlobalSetting" then
		if not VehicleInspector.global.isOn then 
			if args.lineButton.ownTable.side ~= 1 then return;end;
			if args.lineButton.ownTable.whatClick ~= "viOnOff_" then return;end;
		end;
		viGlobalSetting:clickButtonCallback(args);	
	elseif args.lineButton.ownTable.pageName == "MohSetting" then		
		if not VehicleInspector.global.isOn then return;end;
		viMohSetting:clickButtonCallback(args);	
	elseif args.lineButton.ownTable.pageName == "OtherSetting" then		
		viOtherSetting:clickButtonCallback(args);
	end;
	return;
end;

function viHlGui.pullDownButtonCallback(args)
	local pullDownTable = {};
	if not VehicleInspector.global.isOn then return pullDownTable;end;
	if args == nil or type(args) ~= "table" or args.lineButton == nil then return pullDownTable;end;
	if args.lineButton.ownTable.pageName == "GlobalSetting" then
		pullDownTable = viGlobalSetting:pullDownCallback(args.lineButton);	
	elseif args.lineButton.ownTable.pageName == "MohSetting" then
		pullDownTable = viMohSetting:pullDownCallback(args.lineButton);
	elseif args.lineButton.ownTable.pageName == "OtherSetting" then
		pullDownTable = viOtherSetting:pullDownCallback(args.lineButton);
	end;
	return pullDownTable;
end;

function viHlGui.clickPullDownLineCallback(args)
	if not VehicleInspector.global.isOn then return;end;
	if args == nil or type(args) ~= "table" or args.selectLine == nil or args.ownTable == nil then return;end;	
	if args.ownTable.pageName == "GlobalSetting" then
		viGlobalSetting:clickPullDownLineCallback(args);	
	elseif args.ownTable.pageName == "MohSetting" then
		viMohSetting:clickPullDownLineCallback(args);
	elseif args.ownTable.pageName == "OtherSetting" then
		viOtherSetting:clickPullDownLineCallback(args);
	end;
	return;
end;

function viHlGui.txtButtonCallback(args)
	if args == nil or type(args) ~= "table" or args.lineButton == nil or args.lineButton.ownTable == nil then return "";end;
	local txtButton = "";
	if args.lineButton.ownTable.pageName == "GlobalSetting" then
		if not VehicleInspector.global.isOn then 
			if args.lineButton.ownTable.side ~= 1 then return "";end;
			if args.lineButton.ownTable.whatClick ~= "viOnOff_" then return "";end;
		end;
		txtButton = viGlobalSetting:txtButtonCallback(args.lineButton);	
	elseif args.lineButton.ownTable.pageName == "MohSetting" then
		if not VehicleInspector.global.isOn then return "";end;
		txtButton = viMohSetting:txtButtonCallback(args.lineButton);
	elseif args.lineButton.ownTable.pageName == "OtherSetting" then		
		txtButton = viOtherSetting:txtButtonCallback(args.lineButton);
	end;
	return tostring(txtButton);
end;

function viHlGui.onOpenHlGui(args)
	
end

function viHlGui.setOpenDraw(args)
	
end;

function viHlGui.setCloseHlGui()
	
end;

function viHlGui.setSaveHlGui()
	viSetGetSettingsXml:onSaveCallbackGuiMenue();
end;