viMohSetting = {}

function viMohSetting:clickButtonCallback(args)
	local color = "";
	local txt = "";
	if args.lineButton.ownTable.side == 1 then
		if args.lineButton.ownTable.whatClick == "viOnlyMoh_" then			
			if not VehicleInspector.global.foundMoh then return;end;
			VehicleInspector.global.onlyMoh = not VehicleInspector.global.onlyMoh;			
			g_currentMission.hlGui.setGet:setUnSave();			
			return;				
		elseif args.lineButton.ownTable.whatClick == "viGenerateVehicleInspectorPda_" then
			if not VehicleInspector.global.foundMoh or VehicleInspector.moh == nil then return;end;
			local pda = g_currentMission.multiOverlayV4.pdaFunction.getPdaTable("viVehiclePda_");
			if pda ~= nil then return;end;
			viSetGetForMoh:generateVehicleInspectorPda();
			return;
		elseif args.lineButton.ownTable.whatClick == "viGenerateVehicleInspectorSlot_" then
			if not VehicleInspector.global.foundMoh or VehicleInspector.moh == nil then return;end;
			local slot = g_currentMission.multiOverlayV4.pdaFunction.getPdaTable("viVehicleSlot_");
			if slot ~= nil then return;end;
			viSetGetForMoh:generateVehicleInspectorSlot(true);
			return;	
		end;
	end;
end;

function viMohSetting:txtButtonCallback(lineButton)
	local txtButton = "";
	if lineButton.ownTable.side == 1 then
		if lineButton.ownTable.whatClick == "viOnlyMoh_" then			
			if VehicleInspector.global.onlyMoh and VehicleInspector.global.foundMoh then
				txtButton = "On";
				lineButton.clickButtonColor = "green";
			elseif VehicleInspector.global.foundMoh and VehicleInspector.global.foundMoh then
				txtButton = "Off"
				lineButton.clickButtonColor = "red";
			else
				txtButton = "MultiOverlay Mod not Found"
				lineButton.clickButtonColor = "red";
			end;
			if VehicleInspector.global.onlyMoh then VehicleInspector.clickAreas = {master={}, slave={}};end;
		elseif lineButton.ownTable.whatClick == "viGenerateVehicleInspectorPda_" then
			if not VehicleInspector.global.foundMoh or VehicleInspector.moh == nil then 
				txtButton = "MultiOverlay Mod not Found"
				lineButton.clickButtonColor = "red";
			else
				local pda = g_currentMission.multiOverlayV4.pdaFunction.getPdaTable("viVehiclePda_");
				if pda ~= nil then
					txtButton = "Pda already exists"
					lineButton.clickButtonColor = "red";
				else
					txtButton = "Ready"
					lineButton.clickButtonColor = "green";
				end;
			end;
		elseif lineButton.ownTable.whatClick == "viGenerateVehicleInspectorSlot_" then
			if not VehicleInspector.global.foundMoh or VehicleInspector.moh == nil then 
				txtButton = "MultiOverlay Mod not Found"
				lineButton.clickButtonColor = "red";
			else
				local slot = g_currentMission.multiOverlayV4.slotFunction.getSlotTable("viVehicleSlot_");
				if slot ~= nil then
					txtButton = "Slot already exists"
					lineButton.clickButtonColor = "red";
				else
					txtButton = "Ready"
					lineButton.clickButtonColor = "green";
				end;
			end;	
		end;
	end;
	return txtButton;
end;

function viMohSetting:pullDownCallback(lineButton)
	local pullDownTable = {}
	
	return pullDownTable;
end;

function viMohSetting:clickPullDownLineCallback(args)
	
end;

function viMohSetting:generateSide(side)
	local buttons = {};
	local color = ""
	local txtButton = "";
	if side == 1 then
		--line 1--
		buttons = {
			--[1] = {
			--	txtOverButton = "Only VI over MultiOverlay Mod";				
			--	txtButton = "Off";
			--	txtBoldButton = true;
			--	txtButtonCallback = g_currentMission.hlGui.callbacks.vi["txtButton"];
			--	clickButton = "buttonOnOff";
			--	clickButtonColor = "green";
			--	clickButtonCallback = g_currentMission.hlGui.callbacks.vi["clickButton"];
			--	ownTable = {pageName="MohSetting", whatClick="viOnlyMoh_",side=side};
			--	txtInfo = "!Achtung! Die Anzeige wird dann nur noch über einen MultiOverlay Slot angezeigt. Alle VI Cmd's befinden sich in der Group *VehicleInspector...*. Dies hat keinen Einfluss auf zusätzliche VI Anzeigen im MultiOverlay Mod";
			--};
			[1] = {
				txtOverButton = "Generate VI Vehicle Pda";				
				txtButton = "Ready";
				txtBoldButton = true;
				txtButtonCallback = g_currentMission.hlGui.callbacks.vi["txtButton"];
				clickButton = "buttonGenerate";
				clickButtonColor = "green";
				clickButtonCallback = g_currentMission.hlGui.callbacks.vi["clickButton"];
				ownTable = {pageName="MohSetting", whatClick="viGenerateVehicleInspectorPda_",side=side};
				txtInfo = "Generiert ein VI Spezifisches Pda im MultiOverlayV4 Hud. Dort könnt ihr zum Beispiel mit Linker/Rechter Maustaste in die jeweiligen Fahrzeug Typen direkt Joinen und etc.. Das Pda kann von euch auch angepasst werden.";
			};
			[2] = {
				txtOverButton = "Generate VI Vehicle Slot";				
				txtButton = "Ready";
				txtBoldButton = true;
				txtButtonCallback = g_currentMission.hlGui.callbacks.vi["txtButton"];
				clickButton = "buttonGenerate";
				clickButtonColor = "green";
				clickButtonCallback = g_currentMission.hlGui.callbacks.vi["clickButton"];
				ownTable = {pageName="MohSetting", whatClick="viGenerateVehicleInspectorSlot_",side=side};
				txtInfo = "Generiert ein VI Spezifischen Slot im MultiOverlayV4 Hud. Dort könnt ihr im Extra Settings Menü zusätzliche Einstellungen vornehmen. Der Slot kann von euch auch angepasst werden. Der Slot ist für andere Cmds gesperrt und kannn nur vom VI genutzt werden.";
			};	
		};		
		g_currentMission.hlGui.setGet:generateModSideLine({modName="VehicleInspector", page=VehicleInspector.global.hlGui.page["MohSetting"], side=side, lineButtons=buttons});
		--line 1--			
	end;
end;
























