viVehicleMohOutput = {}; --Default Output Display for MultiOverlayV4
local test = true;
function viVehicleMohOutput:load(slotTable)
	viOutput:loadVehicle(false,true);
	local playerFarmId = g_currentMission.player.farmId;
	local lineTable = {line={}};
	local isLineTable = nil;
	local color = "txt";	
	local splitTyp = "§";
	local iconPos = VehicleInspector.moh.moSetGetOverlays.icons.byName["VehicleInspector"]["icon"]["vehicleInspectorJoin"];
	local overlay = VehicleInspector.moh.moSetGetOverlays.icons["VehicleInspector"]["icon"][iconPos]; 
	---format VI Output in MultiOverlayV4 Output---later own function
	if #VehicleInspector.output <= 0 then
		lineTable.line[#lineTable.line+1] = {};
		isLineTable = lineTable.line[#lineTable.line];			
		isLineTable.txt = {};
		isLineTable.txt[1] = {};
		isLineTable.txt[1].bold = true;
		isLineTable.txt[1].slotColor = color;					
		isLineTable.txt[1].txt = g_i18n:getText("shop_noVehicles");			
		isLineTable.txt[1].alignment = 2;
	else
		local txtDistanceString = viVehicleMohOutput:getTxtDistanceString();			
		local separatorColor = g_currentMission.hl.getColor(VehicleInspector.showColor.separator, true);
		local separatorTxt = splitTyp.. txtDistanceString.. tostring(VehicleInspector.txt.separator).. txtDistanceString.. splitTyp;
		for line=1, #VehicleInspector.output do
			local isLine = VehicleInspector.output[line];
			if isLine ~= nil and isLine.txt ~= nil and #isLine.txt > 0 then
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[#isLineTable.txt+1] = {txtSplitColum={txt={},splitTyp=splitTyp}};
				local lineTxt = "";
				local foundLineTxt = false;
				local foundPlayer = false;
				for outputTxt=1, #isLine.txt do
					foundLineTxt = true;
					local isTxt = isLine.txt[outputTxt];
					if isTxt ~= nil then						
						if isTxt.typ == "farmSeparator" then 
							isLineTable.txt[#isLineTable.txt].txt = tostring(isTxt.txt);
							isLineTable.txt[#isLineTable.txt].otherColor = isTxt.txtColor;
							isLineTable.txt[#isLineTable.txt].txtBold = true;
							foundLineTxt = false;
							break;
						end;
						isLineTable.txt[#isLineTable.txt].txtSplitColum.txt[#isLineTable.txt[#isLineTable.txt].txtSplitColum.txt+1] = {};						
						local txtColum = isLineTable.txt[#isLineTable.txt].txtSplitColum.txt[#isLineTable.txt[#isLineTable.txt].txtSplitColum.txt];
						if isTxt.separator then
							lineTxt = lineTxt.. separatorTxt;
							txtColum.txt = txtDistanceString.. tostring(VehicleInspector.txt.separator).. txtDistanceString;
							txtColum.otherColor = separatorColor;
							txtColum.txtBold = false;							
						else
							lineTxt = lineTxt.. tostring(utf8Substr(isTxt.txt, 0));
							txtColum.txt = tostring(utf8Substr(isTxt.txt, 0));							
							txtColum.otherColor = isTxt.txtColor;
							txtColum.txtBold = isTxt.txtBold;							
							txtColum.callback = viVehicleMohOutput.clickTxtSplitColum;							
							txtColum.ownTable = {typ=isTxt.typ};
							if isTxt.typ ~= nil and string.find(isTxt.typ, "player") then foundPlayer = true;end;
						end;						
					end;
				end;
				if foundLineTxt then						
					isLineTable.txt[#isLineTable.txt].txt = lineTxt;
					if g_currentMission.hl.isMouseCursor and not g_currentMission.hl.dragDrop.on then
						if isLine.rootNode ~= nil and isLine.rootNode > 0 then
							local iconColor = "green";
							if foundPlayer then iconColor = "red";end;
							isLineTable.txt[#isLineTable.txt].icon = {before={},after={}};
							isLineTable.txt[#isLineTable.txt].icon.before[1] = {name="vehicleInspectorJoin", color=iconColor, modName="VehicleInspector", groupName="icon", callback={[1]=viVehicleMohOutput.clickVehicleJoin}, ownTable={isLine.rootNode}};
						end;
					end;
				end;
			end;
		end;
	end;
	if slotTable ~= nil and slotTable.help.outputOn and lineTable.line[1] ~= nil and lineTable.line[1].txt ~= nil and lineTable.line[1].txt[1] ~= nil then		
		if lineTable.line[1].txt[1].icon == nil then lineTable.line[1].txt[1].icon = {before={},after={}};
			lineTable.line[1].txt[1].icon.before[1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=viVehicleMohOutput.clickTitleHelpTxt}};
		else
			table.insert(lineTable.line[1].txt[1].icon.before, 1, {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=viVehicleMohOutput.clickTitleHelpTxt}});
		end;
	end;
	---format VI Output in MultiOverlayV4 Output---	
	viVehicleMohOutput.output = lineTable;
end;	

function viVehicleMohOutput.giveOutputTable(args)
	if args == nil or type(args) ~= "table" then return false;end;
	--g_currentMission.multiOverlayV4.moduleFunction.setActiveRunningModul( {modName="vehicleInspector", modulName="vehicles" } );	
	viVehicleMohOutput:load(args.slotTable);
	return viVehicleMohOutput.output;
end;

function viVehicleMohOutput.clickTxtSplitColum(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		g_currentMission:showBlinkingWarning("Mouse Left Click not available (next update!)", 3000);
	elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown then
		g_currentMission:showBlinkingWarning("Mouse Right Click not available (next update!)", 3000);
	elseif args.mouseClick == "MOUSE_BUTTON_MIDDLE" and args.isDown then
		g_currentMission:showBlinkingWarning("Mouse Middle Click not available (next update!)", 3000);
	end;	
end;

function viVehicleMohOutput.clickVehicleJoin(args)	
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then		
		if args.ownTable[1] ~= nil then
			viSetGet:clickVehicleJoin({rootNode=args.ownTable[1]});
		end;
	end;	
end;

function viVehicleMohOutput.clickTitleHelpTxt(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		VehicleInspector.moh.moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		VehicleInspector.moh.moSetGetOverlays.infoHelpBox.help.titel = "VehicleInspector";
		VehicleInspector.moh.moSetGetOverlays.infoHelpBox.help.txt = "Click Icons or Vehicles for more Info (Mouse Click Left/Right/Middle)\nJoin a Vehicle only over first Icon";
	end;
end;

function viVehicleMohOutput:getTxtDistanceString()
	local distanceString = "";
	local txtWidthDistance = VehicleInspector.global.txtWidthDistance;
	local slot = g_currentMission.multiOverlayV4.slotFunction.getSlotTable("viVehicleSlot_");
	local txtSlotWidth = getTextWidth(slot.txtSize, " ");
	local maxWidth = math.floor(txtWidthDistance/txtSlotWidth, 0.5);	
	if maxWidth == 0 then return " ";end;
	for a=1, maxWidth do
		distanceString = distanceString.. " ";
	end;	
	return distanceString;
end;

--g_currentMission.multiOverlayV4.moduleFunction.addActiveRunningModul( {modName="vehicleInspector", modulName="vehicles" } );