viSetGetOverlays = {};

function viSetGetOverlays:loadOverlays()	
	VehicleInspector:get_hl("getDefaultBackground", {VehicleInspector.overlays, "ground"}, "viSetGetOverlays:loadOverlays");
	setOverlayUVs(VehicleInspector.overlays["ground"].overlayId, 0.0078125,0.990234375, 0.0078125,0.9921875, 0.009765625,0.990234375, 0.009765625,0.9921875);
	VehicleInspector:get_hl("getDefaultBackground", {VehicleInspector.overlays, "settingGround"}, "viSetGetOverlays:loadOverlays");
	setOverlayUVs(VehicleInspector.overlays["settingGround"].overlayId, 0.0078125,0.990234375, 0.0078125,0.9921875, 0.009765625,0.990234375, 0.009765625,0.9921875);	
	VehicleInspector:get_hl("getDefaultBackground", {VehicleInspector.overlays, "previewGround"}, "viSetGetOverlays:loadOverlays");
	setOverlayUVs(VehicleInspector.overlays["previewGround"].overlayId, 0.0078125,0.990234375, 0.0078125,0.9921875, 0.009765625,0.990234375, 0.009765625,0.9921875);
	
	local color = VehicleInspector:get_hl("getColor", {VehicleInspector.showColor.background, true, {0/255,0/255,0/255,1.00}}, "viSetGetOverlays:loadOverlays");
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["ground"], color}, "viSetGetOverlays:loadOverlays");	
	color = VehicleInspector:get_hl("getColor", {"blackDisabled", true, {0/255,0/255,0/255,1.00}}, "viSetGetOverlays:loadOverlays");	
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["settingGround"], color}, "viSetGetOverlays:loadOverlays");
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["previewGround"], color}, "viSetGetOverlays:loadOverlays");
	VehicleInspector:get_hl("getDefaultBackground", {VehicleInspector.overlays, "selectVehicle"}, "viSetGetOverlays:loadOverlays");
	setOverlayUVs(VehicleInspector.overlays["selectVehicle"].overlayId, 0.0078125,0.990234375, 0.0078125,0.9921875, 0.009765625,0.990234375, 0.009765625,0.9921875);
	color = VehicleInspector:get_hl("getColor", {VehicleInspector.showColor.selectVehicle, true, {240/255,230/255,140/255,1.00}}, "viSetGetOverlays:loadOverlays");
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["selectVehicle"], color}, "viSetGetOverlays:loadOverlays");
	
	
	
	--VehicleInspector.overlays["ground"] = Overlay.new(HUD.MENU_BACKGROUND_PATH, 0, 0, 0, 0);
	--local color = VehicleInspector:get_hl("getColor", {VehicleInspector.showColor.background, true, {0/255,0/255,0/255,1.00}}, "viSetGetOverlays:loadOverlays");
	--VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["ground"], color}, "viSetGetOverlays:loadOverlays");
	--VehicleInspector.overlays["selectVehicle"] = Overlay.new(HUD.MENU_BACKGROUND_PATH, 0, 0, 0, 0);	
	--color = VehicleInspector:get_hl("getColor", {VehicleInspector.showColor.selectVehicle, true, {240/255,230/255,140/255,1.00}}, "viSetGetOverlays:loadOverlays");
	--VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["selectVehicle"], color}, "viSetGetOverlays:loadOverlays");
	local speedMeter = g_currentMission.inGameMenu.hud.speedMeter;	
	if speedMeter ~= nil then		
		local width = speedMeter.damageBarElement:getWidth();
		local w = width;		
		local height = speedMeter.damageBarElement:getHeight();
		local h = height;
		local posX, posY = speedMeter.damageBarElement:getPosition();
		VehicleInspector.attachedDamageIcon, VehicleInspector.attachedFuelIcon = speedMeter:createGaugeIconElements(g_baseHUDFilename, 0, 0);
		VehicleInspector.attachedDamageBar = speedMeter:createDamageBar(g_baseHUDFilename, 0, 0);		
		--g_currentMission.hl.setOverlay(VehicleInspector.attachedDamageBar.overlay, posX+(width*1.2), posY);
		g_currentMission.hl.setOverlay(VehicleInspector.attachedDamageBar.overlay, posX+(width*1.2), posY, width*1.1, height);				
		width = speedMeter.damageGaugeIconElement:getWidth();
		height = speedMeter.damageGaugeIconElement:getHeight();
		g_currentMission.hl.setOverlay(VehicleInspector.attachedDamageIcon.overlay, posX+(w*2.2), posY+h-(height), width, height);
		VehicleInspector.attachedDamageIcon.overlay.visible = false;
		width = speedMeter.fuelGaugeIconElement:getWidth();
		height = speedMeter.fuelGaugeIconElement:getHeight();
		g_currentMission.hl.setOverlay(VehicleInspector.attachedFuelIcon.overlay, posX+(w*2.2), posY, width, height);
		VehicleInspector.attachedFuelIcon.overlay.visible = false;
	end;
	viSetGetOverlays:loadIconOverlays();
end;

function viSetGetOverlays:loadIconOverlays()
	local iconFilePath = Utils.getFilename("scripte/mohFeatures/settings.dds", VehicleInspector.modDir);
	VehicleInspector.overlays["buttonLeft"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["buttonLeft"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 63)));	
	local color = VehicleInspector:get_hl("getColor", {"ls22", true}, "viSetGetOverlays:loadOverlays");
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["buttonLeft"], color}, "viSetGetOverlays:loadOverlays");
		
	VehicleInspector.overlays["buttonRight"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["buttonRight"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 64)));	
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["buttonRight"], color}, "viSetGetOverlays:loadOverlays");
		
	VehicleInspector.overlays["roundGround"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["roundGround"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 62)));
	color = g_currentMission.hl.getColor("blackDisabled", true);
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["roundGround"], color}, "viSetGetOverlays:loadOverlays");
	
	VehicleInspector.overlays["storeGround"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["storeGround"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 52)));
		
	VehicleInspector.overlays["speed"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["speed"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 61)));
	color = g_currentMission.hl.getColor("whiteOff", true);
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["speed"], color}, "viSetGetOverlays:loadOverlays");	
		
	VehicleInspector.overlays["repair"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["repair"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 60)));
	color = g_currentMission.hl.getColor("yellow", true);
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["repair"], color}, "viSetGetOverlays:loadOverlays");
	
	VehicleInspector.overlays["warning1"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["warning1"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 59)));
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["warning1"], color}, "viSetGetOverlays:loadOverlays");
	
	VehicleInspector.overlays["refuel"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["refuel"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 58)));
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["refuel"], color}, "viSetGetOverlays:loadOverlays");
	
	VehicleInspector.overlays["tempomat"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["tempomat"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 57)));
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["tempomat"], color}, "viSetGetOverlays:loadOverlays");
	
	color = g_currentMission.hl.getColor("whiteOff", true);
	VehicleInspector.overlays["field"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["field"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 56)));
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["field"], color}, "viSetGetOverlays:loadOverlays");
	
	color = g_currentMission.hl.getColor("blackDisabled", true);
	VehicleInspector.overlays["backGround"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["backGround"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 55)));
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["backGround"], color}, "viSetGetOverlays:loadOverlays");
	
	VehicleInspector.overlays["middleGround"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["middleGround"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 54)));
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["middleGround"], color}, "viSetGetOverlays:loadOverlays");
	
	VehicleInspector.overlays["frontGround"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["frontGround"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 53)));
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["frontGround"], color}, "viSetGetOverlays:loadOverlays");
	
	color = g_currentMission.hl.getColor("green", true);
	VehicleInspector.overlays["attached"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["attached"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 51)));
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["attached"], color}, "viSetGetOverlays:loadOverlays");
	
	color = g_currentMission.hl.getColor("ls22", true);
	VehicleInspector.overlays["uMarker"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["uMarker"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 50)));
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["uMarker"], color}, "viSetGetOverlays:loadOverlays");
	
	color = g_currentMission.hl.getColor("green", true);
	VehicleInspector.overlays["view"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["view"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 49)));
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["view"], color}, "viSetGetOverlays:loadOverlays");	
	--VehicleInspector.overlays["view"].view = true;
	
	color = g_currentMission.hl.getColor("yellow", true);
	VehicleInspector.overlays["sort1"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["sort1"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 48)));
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["view"], color}, "viSetGetOverlays:loadOverlays");	
	--VehicleInspector.overlays["sort1"].view = true;
	
	VehicleInspector.overlays["leasing"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["leasing"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 47)));
	
	VehicleInspector.overlays["forceView"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["forceView"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 46)));
	--VehicleInspector.overlays["forceView"].view = true;
	
	color = g_currentMission.hl.getColor("blackDisabled", true);
	VehicleInspector.overlays["fillLevelBarH"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["fillLevelBarH"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 45)));
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["fillLevelBarH"], color}, "viSetGetOverlays:loadOverlays");
	VehicleInspector.overlays["fillLevelBarColorH"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["fillLevelBarColorH"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 45)));
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["fillLevelBarColorH"], color}, "viSetGetOverlays:loadOverlays");
		
	VehicleInspector.overlays["fillLevelBarV"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["fillLevelBarV"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 44)));
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["fillLevelBarV"], color}, "viSetGetOverlays:loadOverlays");
	VehicleInspector.overlays["fillLevelBarColorV"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["fillLevelBarColorV"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 44)));
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["fillLevelBarColorV"], color}, "viSetGetOverlays:loadOverlays");
	
	VehicleInspector.overlays["overloaded"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["overloaded"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 43)));
	color = g_currentMission.hl.getColor("yellow", true);
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["overloaded"], color}, "viSetGetOverlays:loadOverlays");
	
	VehicleInspector.overlays["parking"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["parking"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 42)));
	color = g_currentMission.hl.getColor("yellow", true);
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["parking"], color}, "viSetGetOverlays:loadOverlays");
	
	VehicleInspector.overlays["gps"] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.overlays["gps"], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 41)));
	color = g_currentMission.hl.getColor("ls15", true);
	VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["gps"], color}, "viSetGetOverlays:loadOverlays");
	
	local lenO = #VehicleInspector.categoryOverlays+1;
	VehicleInspector.categoryOverlays[lenO] = {};
	VehicleInspector.categoryOverlays[lenO] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.categoryOverlays[lenO], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 2)));
	VehicleInspector.categoryOverlays[lenO].category = "tractor";VehicleInspector.categoryOverlays[lenO].view = true;
	
	lenO = #VehicleInspector.categoryOverlays+1;
	VehicleInspector.categoryOverlays[lenO] = {};
	VehicleInspector.categoryOverlays[lenO] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.categoryOverlays[lenO], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 3)));
	VehicleInspector.categoryOverlays[lenO].category = "harvester";VehicleInspector.categoryOverlays[lenO].view = true;
	
	lenO = #VehicleInspector.categoryOverlays+1;
	VehicleInspector.categoryOverlays[lenO] = {};
	VehicleInspector.categoryOverlays[lenO] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.categoryOverlays[lenO], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 4)));
	VehicleInspector.categoryOverlays[lenO].category = "truck";VehicleInspector.categoryOverlays[lenO].view = true;
		
	lenO = #VehicleInspector.categoryOverlays+1;
	VehicleInspector.categoryOverlays[lenO] = {};
	VehicleInspector.categoryOverlays[lenO] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.categoryOverlays[lenO], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 6)));
	VehicleInspector.categoryOverlays[lenO].category = "teleloader";VehicleInspector.categoryOverlays[lenO].view = true;
	
	lenO = #VehicleInspector.categoryOverlays+1;
	VehicleInspector.categoryOverlays[lenO] = {};
	VehicleInspector.categoryOverlays[lenO] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.categoryOverlays[lenO], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 7)));
	VehicleInspector.categoryOverlays[lenO].category = "other";VehicleInspector.categoryOverlays[lenO].view = true;
	
	lenO = #VehicleInspector.categoryOverlays+1;
	VehicleInspector.categoryOverlays[lenO] = {};
	VehicleInspector.categoryOverlays[lenO] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.categoryOverlays[lenO], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 5)));
	VehicleInspector.categoryOverlays[lenO].category = "car";VehicleInspector.categoryOverlays[lenO].view = true;
	
	lenO = #VehicleInspector.categoryOverlays+1;
	VehicleInspector.categoryOverlays[lenO] = {};
	VehicleInspector.categoryOverlays[lenO] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.categoryOverlays[lenO], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 8)));
	VehicleInspector.categoryOverlays[lenO].category = "train";VehicleInspector.categoryOverlays[lenO].view = true;
	
	lenO = #VehicleInspector.categoryOverlays+1;
	VehicleInspector.categoryOverlays[lenO] = {};
	VehicleInspector.categoryOverlays[lenO] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.categoryOverlays[lenO], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 15)));
	VehicleInspector.categoryOverlays[lenO].category = "tool";VehicleInspector.categoryOverlays[lenO].view = false;
	
	lenO = #VehicleInspector.categoryOverlays+1;
	VehicleInspector.categoryOverlays[lenO] = {};
	VehicleInspector.categoryOverlays[lenO] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.categoryOverlays[lenO], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 16)));
	VehicleInspector.categoryOverlays[lenO].category = "trailer";VehicleInspector.categoryOverlays[lenO].view = false;
	
	lenO = #VehicleInspector.categoryOverlays+1;
	VehicleInspector.categoryOverlays[lenO] = {};
	VehicleInspector.categoryOverlays[lenO] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.categoryOverlays[lenO], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 17)));
	VehicleInspector.categoryOverlays[lenO].category = "loadtrailer";VehicleInspector.categoryOverlays[lenO].view = false;
	
	lenO = #VehicleInspector.categoryOverlays+1;
	VehicleInspector.categoryOverlays[lenO] = {};
	VehicleInspector.categoryOverlays[lenO] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.categoryOverlays[lenO], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 18)));
	VehicleInspector.categoryOverlays[lenO].category = "lowtrailer";VehicleInspector.categoryOverlays[lenO].view = false;
	
	lenO = #VehicleInspector.categoryOverlays+1;
	VehicleInspector.categoryOverlays[lenO] = {};
	VehicleInspector.categoryOverlays[lenO] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.categoryOverlays[lenO], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 19)));
	VehicleInspector.categoryOverlays[lenO].category = "traintrailer";VehicleInspector.categoryOverlays[lenO].view = false;
	
	lenO = #VehicleInspector.categoryOverlays+1;
	VehicleInspector.categoryOverlays[lenO] = {};
	VehicleInspector.categoryOverlays[lenO] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.categoryOverlays[lenO], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 20)));
	VehicleInspector.categoryOverlays[lenO].category = "horse";VehicleInspector.categoryOverlays[lenO].view = false;
	
	lenO = #VehicleInspector.categoryOverlays+1;
	VehicleInspector.categoryOverlays[lenO] = {};
	VehicleInspector.categoryOverlays[lenO] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.categoryOverlays[lenO], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 21)));
	VehicleInspector.categoryOverlays[lenO].category = "isLeasing";VehicleInspector.categoryOverlays[lenO].view = true;
	
	lenO = #VehicleInspector.categoryOverlays+1;
	VehicleInspector.categoryOverlays[lenO] = {};
	VehicleInspector.categoryOverlays[lenO] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.categoryOverlays[lenO], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 22)));
	VehicleInspector.categoryOverlays[lenO].category = "isGps";VehicleInspector.categoryOverlays[lenO].view = true;
	
	lenO = #VehicleInspector.categoryOverlays+1;
	VehicleInspector.categoryOverlays[lenO] = {};
	VehicleInspector.categoryOverlays[lenO] = Overlay.new(iconFilePath, 0, 0, 0, 0);
	g_currentMission.hl.setOverlayUVsPx(VehicleInspector.categoryOverlays[lenO], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 23)));
	VehicleInspector.categoryOverlays[lenO].category = "isParking";VehicleInspector.categoryOverlays[lenO].view = true;
end;

function viSetGetOverlays:loadIconFillTypes()
	if g_currentMission.fillTypeManager.fillTypes ~= nil then		
		for index, desc in pairs(g_currentMission.fillTypeManager.fillTypes) do		
			if desc ~= nil and desc.index ~= nil and desc.hudOverlayFilename ~= nil and desc.hudOverlayFilename ~= "" then
				VehicleInspector.fillTypeOverlays[desc.index] = Overlay.new(desc.hudOverlayFilename, 0, 0, 0, 0);
			end;
		end;
	end;
end;

function viSetGetOverlays:loadStoreItem(vehicle)	
	local imageFilename = vehicle:getImageFilename();
	if imageFilename ~= nil then		
		local vehicleTypeName = vehicle.typeName;
		local notLoad = vehicleTypeName == nil or string.find(vehicleTypeName:lower(), "train") or string.find(vehicleTypeName:lower(), "wagon") or string.find(vehicleTypeName:lower(), "locomotive") or string.find(vehicleTypeName:lower(), "pallet")
		local vehicleName = tostring(vehicle.getName(vehicle));		
		if not notLoad and VehicleInspector.storeOverlays[vehicleName] == nil then
			VehicleInspector.storeOverlays[vehicleName] = Overlay.new(imageFilename, 0, 0, 0, 0);
			VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.storeOverlays[vehicleName], {1,1,1,1}}, "viSetGetOverlays:loadStoreItem()");
		end;
	end;
end;